
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.gva.cit.catalogClient.ui.serverConnect;
import java.awt.GridLayout;

import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import org.gvsig.i18n.Messages;
import com.iver.utiles.swing.jcomboServer.JComboServer;
import com.iver.utiles.swing.jcomboServer.ServerData;
import java.awt.FlowLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;

/**
 * Panel de conexin con los servers de catlogo.
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public class ServerConnectPanel extends JPanel {
/**
 * 
 * 
 */
    private JPanel panelSuperior = null;
/**
 * 
 * 
 */
    private JComboServer servidoresCombo = null;
/**
 * 
 * 
 */
    private JPanel panelBotones = null;
/**
 * 
 * 
 */
    private JRadioButton z3950Button = null;
    private JLabel versionLabel = null;
/**
 * 
 * 
 */
    private JRadioButton srwButton = null;
/**
 * 
 * 
 */
    private JRadioButton cswButton = null;
/**
 * 
 * 
 */
    private JPanel panelServidores = null;
/**
 * 
 * 
 */
    private JPanel panelInferior = null;
//  @jve:decl-index=0:
/**
 * 
 * 
 */
    private JEditorPane respuestaText = null;
/**
 * 
 * 
 */
    private JPanel panelRespuesta = null;
/**
 * 
 * 
 */
    private JScrollPane jScrollPane = null;
/**
 * 
 * 
 */
    private JPanel panelLabRespuesta = null;
//  @jve:decl-index=0:
/**
 * 
 * 
 */
    private JLabel jLabel1 = null;
/**
 * 
 * 
 */
    private JPanel panelLabServidores = null;
/**
 * 
 * 
 */
    private JLabel servidoresLabel = null;
/**
 * 
 * 
 */
    private JPanel panelServidoresCombo = null;
/**
 * 
 * 
 */
    private JPanel panelLabDB = null;
/**
 * 
 * 
 */
    private JLabel dbLabel = null;
/**
 * 
 * 
 */
    private JPanel panelDBText = null;
/**
 * 
 * 
 */
    private JTextField dbText = null;
/**
 * 
 * 
 */
private JPanel jPanel = null;

/**
 * 
 * 
 * 
 * @param translator 
 */
    public  ServerConnectPanel() {
        initialize();
    } 

/**
 * This method initializes this
 * 
 */
    private void initialize() {        
        this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        this.setBounds(0, 0, 625, 225);
        this.setPreferredSize(new java.awt.Dimension(685,200));
        //this.add(getPanelPrincipal(), null);
        this.setBackground(java.awt.Color.white);
        this.add(getPanelSuperior(), null);
        this.add(getPanelInferior(), null);
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelSuperior() {        
        if (panelSuperior == null) {
            panelSuperior = new JPanel();
            panelSuperior.setPreferredSize(new java.awt.Dimension(585,110));
            panelSuperior.add(getPanelServidores(), null);
            panelSuperior.add(getPanelBotones(), null);
        }
        return panelSuperior;
    } 

/**
 * This method initializes jComboBox1
 * 
 * 
 * @return javax.swing.JComboBox
 */
    public JComboServer getServidoresCombo() {        
        if (servidoresCombo == null) {
            servidoresCombo = new JComboServer();
            servidoresCombo.setActionCommand("servidoresCombo");
            servidoresCombo.setPreferredSize(new java.awt.Dimension(470,25));
            servidoresCombo.setEditable(true);
        }
        return servidoresCombo;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelBotones() {        
        if (panelBotones == null) {
            panelBotones = new JPanel();
            panelBotones.setLayout(new BoxLayout(panelBotones, BoxLayout.Y_AXIS));
            panelBotones.setBorder(javax.swing.BorderFactory.createTitledBorder(
                    null, Messages.getText("protocolsGroup"),
                    javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
                    javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
            panelBotones.setName("Protocolos");
            panelBotones.setToolTipText("");
            panelBotones.add(getZ3950Button(), null);
            panelBotones.add(getSrwButton(), null);
            panelBotones.add(getCswButton(), null);
            ButtonGroup group = new ButtonGroup();
            group.add(getZ3950Button());
            group.add(getSrwButton());
            group.add(getCswButton());
        }
        return panelBotones;
    } 

/**
 * This method initializes jRadioButton
 * 
 * 
 * @return javax.swing.JRadioButton
 */
    public JRadioButton getZ3950Button() {        
        if (z3950Button == null) {
            z3950Button = new JRadioButton();
            z3950Button.setText("Z39.50");
            z3950Button.setSelected(true);
        }
        return z3950Button;
    } 

/**
 * This method initializes jRadioButton
 * 
 * 
 * @return javax.swing.JRadioButton
 */
    public JRadioButton getSrwButton() {        
        if (srwButton == null) {
            srwButton = new JRadioButton();
            srwButton.setText("SRU/SRW");
        }
        return srwButton;
    } 

/**
 * This method initializes jRadioButton
 * 
 * 
 * @return javax.swing.JRadioButton
 */
    public JRadioButton getCswButton() {        
        if (cswButton == null) {
            cswButton = new JRadioButton();
            cswButton.setText("CS-W");
        }
        return cswButton;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelServidores() {        
        if (panelServidores == null) {
            panelServidores = new JPanel();
            panelServidores.setLayout(new BoxLayout(panelServidores,
                    BoxLayout.Y_AXIS));
            panelServidores.setPreferredSize(new java.awt.Dimension(475,115));
            panelServidores.add(getJPanel(), null);
            panelServidores.add(getJPanel2(), null);
            panelServidores.add(getJPanel3(), null);
            panelServidores.add(getJPanel4(), null);
            panelServidores.add(getPanelLabRespuesta(), null);
        }
        return panelServidores;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelInferior() {        
        if (panelInferior == null) {
            panelInferior = new JPanel();
            panelInferior.setLayout(new FlowLayout());
            panelInferior.setComponentOrientation(java.awt.ComponentOrientation.LEFT_TO_RIGHT);
            panelInferior.setPreferredSize(new java.awt.Dimension(585,77));
            panelInferior.add(getJPanel5(), null);
        }
        return panelInferior;
    } 

/**
 * This method initializes jTextArea
 * 
 * 
 * @return javax.swing.JTextArea
 */
    private JEditorPane getRespuestaText() {        
        if (respuestaText == null) {
            respuestaText = new JEditorPane();
            respuestaText.setPreferredSize(new java.awt.Dimension(195,500));
            respuestaText.setSize(new java.awt.Dimension(572,69));
            respuestaText.setEditable(false);
        }
        return respuestaText;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelRespuesta() {        
        if (panelRespuesta == null) {
            panelRespuesta = new JPanel();
            panelRespuesta.setLayout(new BoxLayout(getPanelRespuesta(), BoxLayout.X_AXIS));
            panelRespuesta.setBorder(javax.swing.BorderFactory.createLineBorder(
                    java.awt.Color.lightGray, 0));
            panelRespuesta.setPreferredSize(new java.awt.Dimension(575,72));
            panelRespuesta.add(getJScrollPane(), null);
        }
        return panelRespuesta;
    } 

/**
 * This method initializes jScrollPane
 * 
 * 
 * @return javax.swing.JScrollPane
 */
    private JScrollPane getJScrollPane() {        
        if (jScrollPane == null) {
            jScrollPane = new JScrollPane();
            jScrollPane.setViewportView(getRespuestaText());
            getRespuestaText().setBackground(jScrollPane.getBackground());
            jScrollPane.setPreferredSize(new java.awt.Dimension(565,75));
            jScrollPane.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        }
        return jScrollPane;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelLabRespuesta() {        
        if (panelLabRespuesta == null) {
            GridLayout gridLayout = new GridLayout();
            gridLayout.setRows(1);
            jLabel1 = new JLabel();
            panelLabRespuesta = new JPanel();
            panelLabRespuesta.setPreferredSize(new java.awt.Dimension(435,20));
            panelLabRespuesta.setLayout(gridLayout);
            panelLabRespuesta.add(jLabel1, null);
            jLabel1.setText(Messages.getText("serverReply"));
        }
        return panelLabRespuesta;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getJPanel() {        
        if (panelLabServidores == null) {
            servidoresLabel = new JLabel();
            GridLayout gridLayout6 = new GridLayout();
            GridLayout gridLayout5 = new GridLayout();
            GridLayout gridLayout7 = new GridLayout();
            GridLayout gridLayout4 = new GridLayout();
            panelLabServidores = new JPanel();
            panelLabServidores.setLayout(gridLayout7);
            servidoresLabel.setText(Messages.getText("serverURL"));
            servidoresLabel.setPreferredSize(new java.awt.Dimension(375, 16));
            servidoresLabel.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);
            servidoresLabel.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
            gridLayout4.setRows(1);
            panelLabServidores.setPreferredSize(new java.awt.Dimension(435,20));
            panelLabServidores.setComponentOrientation(java.awt.ComponentOrientation.LEFT_TO_RIGHT);
            gridLayout5.setRows(1);
            gridLayout6.setRows(1);
            gridLayout7.setRows(1);
            panelLabServidores.add(servidoresLabel, null);
        }
        return panelLabServidores;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getJPanel2() {        
        if (panelServidoresCombo == null) {
            panelServidoresCombo = new JPanel();
            panelServidoresCombo.setLayout(new BoxLayout(getJPanel2(), BoxLayout.X_AXIS));
            panelServidoresCombo.setPreferredSize(new java.awt.Dimension(435,25));
            panelServidoresCombo.setName("Protocolos");
            panelServidoresCombo.setToolTipText("Protocolos");
            panelServidoresCombo.setBorder(javax.swing.BorderFactory.createEmptyBorder(
                    0, 0, 0, 0));
            panelServidoresCombo.add(getServidoresCombo(), null);
        }
        return panelServidoresCombo;
    } 

/**
 * It returns the server address
 * 
 * 
 * @return String
 */
    public String getServerAddress() {        
        return getServidoresCombo().getSelectedServer().getServerAddress();
    } 

/**
 * It returns the server
 * 
 * 
 * @return ServerData
 */
    public ServerData getServer() {        
        return getServidoresCombo().getSelectedServer();
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public JComboServer getServerCombo() {        
        return getServidoresCombo();
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public String getProtocol() {        
        if (this.getZ3950Button().isSelected()) {
            return "Z3950";
        }
        if (this.getSrwButton().isSelected()) {
            return "SRW";
        }
        if (this.getCswButton().isSelected()) {
            return "CSW";
        }
        return null;
    } 

/**
 * Sets the button enabled
 * 
 * 
 * @param protocol 1 - z3950
 * 2 - SRW
 * 3 - CSW
 */
    public void setProtocol(String protocol) {        
        if (protocol.equals(ServerData.SERVER_SUBTYPE_CATALOG_Z3950)){
            getZ3950Button().setSelected(true);
        }
        if (protocol.equals(ServerData.SERVER_SUBTYPE_CATALOG_SRW)){
            getSrwButton().setSelected(true);
        }
        if (protocol.equals(ServerData.SERVER_SUBTYPE_CATALOG_CSW)){
            getCswButton().setSelected(true);
        }       
    } 

/**
 * 
 * 
 * 
 * @param texto 
 */
    public void setRespuesta(String texto) {        
        this.getRespuestaText().setText(texto);
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getJPanel3() {        
        if (panelLabDB == null) {
            dbLabel = new JLabel();
            GridLayout gridLayout11 = new GridLayout();
            panelLabDB = new JPanel();
            panelLabDB.setPreferredSize(new java.awt.Dimension(435,20));
            panelLabDB.setLayout(gridLayout11);
            dbLabel.setText(Messages.getText("database"));
            gridLayout11.setRows(1);
            panelLabDB.add(dbLabel, null);
        }
        return panelLabDB;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getJPanel4() {        
        if (panelDBText == null) {
            panelDBText = new JPanel();
            panelDBText.setLayout(new BoxLayout(getJPanel4(), BoxLayout.X_AXIS));
            panelDBText.setPreferredSize(new java.awt.Dimension(435,25));
            panelDBText.add(getDbText(), null);
        }
        return panelDBText;
    } 

/**
 * This method initializes jTextField
 * 
 * 
 * @return javax.swing.JTextField
 */
    public JTextField getDbText() {        
        if (dbText == null) {
            dbText = new JTextField();
            dbText.setPreferredSize(new java.awt.Dimension(470,23));
        }
        return dbText;
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public String getDatabase() {        
        if (dbText.getText() == null) {
            return "";
        }
        return dbText.getText();
    } 
    
    public void setDatabase(){
    	dbText.setText(getServer().getDatabase());
    }

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel5() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setLayout(new BoxLayout(getJPanel5(), BoxLayout.Y_AXIS));
			jPanel.add(getPanelRespuesta(), null);
		}
		return jPanel;
	}
 }
//  @jve:decl-index=0:visual-constraint="23,27"
