
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package es.gva.cit.gazetteer.drivers;
import es.gva.cit.gazetteer.querys.Query;
import java.util.Vector;

/**
 * This class must be inherited by all the gazetteer drivers. It contains
 * the common attributes.
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public abstract class AsbtractGazetteerServiceDriver implements IGazetteerServiceDriver {

	/**
	 * 
	 * 
	 */
	private Vector Feature;

	/**
	 * 
	 * 
	 */
	private String serverAnswerReady = null;
	/**
	 * <p></p>
	 * 
	 * 
	 */
	private Query query;

	/**
	 * Server Projection
	 */     
	private String projection;

	/**
	 * 
	 * 
	 * 
	 * @return Returns the serverAnswerReady.
	 */
	public String getServerAnswerReady() {        
		return serverAnswerReady;
	} 

	/**
	 * 
	 * 
	 * 
	 * @param serverAnswerReady The serverAnswerReady to set.
	 */
	public void setServerAnswerReady(String serverAnswerReady) {        
		this.serverAnswerReady = serverAnswerReady;
	} 

	/**
	 * 
	 * 
	 * 
	 * @return Returns the feature.
	 */
	public Vector getVectorFeatures() {        
		return Feature;
	} 

	/**
	 * 
	 * 
	 * 
	 * @param feature The feature to set.
	 */
	public void setVectorFeatures(Vector feature) {        
		Feature = feature;
	} 

	/**
	 * 
	 * 
	 * 
	 * @return Returns the feature.
	 */
	public Vector getFeature() {        
		return Feature;
	} 

	/**
	 * 
	 * 
	 * 
	 * @param feature The feature to set.
	 */
	public void setFeature(Vector feature) {        
		Feature = feature;
	} 

	/**
	 * 
	 * 
	 * 
	 * @return Returns the query.
	 */
	public Query getQuery() {        
		return query;
	} 

	/**
	 * 
	 * 
	 * 
	 * @param query The query to set.
	 */
	public void setQuery(Query query) {        
		this.query = query;
	}

	/**
	 * @return the projection
	 */
	public String getProjection() {
		return projection;
	}

	/**
	 * @param projection the projection to set
	 */
	public void setProjection(String projection) {
		this.projection = projection;
	} 
}
