
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.gva.cit.gazetteer.idec.parsers;
import es.gva.cit.catalogClient.metadataXML.XMLNode;
import es.gva.cit.catalogClient.metadataXML.XMLTree;
import es.gva.cit.gazetteer.idec.drivers.IDECGazetteerServiceDriver;

/**
 * 
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public class IdecCapabilitiesParser {
/**
 * 
 * 
 */
    IDECGazetteerServiceDriver driver;

/**
 * 
 * 
 * 
 * @param driver 
 */
    public  IdecCapabilitiesParser(IDECGazetteerServiceDriver driver) {        
        this.driver = driver;
    } 

/**
 * 
 * 
 * 
 * @return 
 * @param node 
 */
    public boolean parse(XMLNode node) {        
        String prefix = "";
        if (node.getName().equals("wsdl:definitions")){
        	prefix = "wsdl:";
        }
        
        if (!(node.getName().equals(prefix + "definitions"))){        		
            driver.setServerAnswerReady("El servidor no soporta el protocolo " +
                    "especificado");
            return false;
        }
        
        
        XMLNode[] nodes = XMLTree.searchMultipleNode(node,prefix + "message");
                
        if (nodes.length == 0){
            driver.setServerAnswerReady("El servidor no timplementa ninguna " +
                    "operacin");
            return false;        
        }
        
        String msg = "El servidor soporta las operaciones: ";
        
        msg = msg + XMLTree.searchAtribute(nodes[0],"name");
        
        for (int i=1 ; i<nodes.length ; i++){
            msg = msg + ", " + XMLTree.searchAtribute(nodes[i],"name");
        }
       
        driver.setServerAnswerReady(msg);
             
        driver.setProjection("EPSG:23031");  
        return true;
    } 
 }
