/*
 * Created on 28-abr-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.project.documents.view.legend.gui;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.geom.AffineTransform;

import javax.swing.JComponent;

import com.iver.cit.gvsig.fmap.core.v02.FGraphicUtilities;
import com.iver.cit.gvsig.fmap.core.v02.FSymbol;


/**
 * @author fjp
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class FPreviewSymbol extends JComponent {
	
	private  FSymbol m_FSymbol;
	private String m_Str;
	private boolean m_bUseFSymbol;
	

	/**
	 * 
	 */
	public FPreviewSymbol() {
		super();
			initialize();
	// this.setDoubleBuffered(true);		
		this.setBackground(Color.WHITE);
		this.setForeground(Color.BLACK);
	}


	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
        this.setSize(70, 52);
			
	}
	protected void paintComponent(Graphics g) {		
		super.paintComponent(g);
		if (m_FSymbol == null)
		{
			return;
		}
		// Segn el tipo de smbolo, creamos un shape u otro y utilizamos
		// la funcin comn de dibujado de shape sobre un graphics con un simbolo
		
		Graphics2D g2 = (Graphics2D) g;
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		
		
		g.setClip(0,0,getWidth(), getHeight());
		Rectangle r = g.getClipBounds(); //getClipRect();
		// g.clipRect(r.x, r.y, r.width, r.height);
		// g.setColor(Color.WHITE);
		// g2.fillRect(0, 0,getWidth(), getHeight());
		if (m_bUseFSymbol)
		{
			AffineTransform mT2 = AffineTransform.getScaleInstance(0.8, 0.8);
			mT2.concatenate(AffineTransform.getTranslateInstance(r.width * 0.1, r.height * 0.1 ));				
			       
			FGraphicUtilities.DrawSymbol((Graphics2D)g,mT2,r,m_FSymbol);	
		}
		else
		{
			FontMetrics metrics = g2.getFontMetrics();
			int width = metrics.stringWidth(m_Str );
			//int height = metrics.getMaxAscent();
			// g2.setFont(theSymbol.m_Font);

			g2.drawString(m_Str, (float) r.getCenterX()-width/2, (float) r.getCenterY() +3);			
		}
		
	}

	/**
	 * @param symbol
	 */
	public void setSymbol(FSymbol symbol) {
		// Lo clonamos para que si viene en coordenadas de mundo real
		// (m_bUseSize = true), dibujarlo con un tamao fijo en pixels.
		
		FSymbol cloneSym = symbol.fastCloneSymbol();
		if (!cloneSym.isSizeInPixels())
		{
			cloneSym.setSizeInPixels(true);
			cloneSym.setSize(10); // pixels
		}
		
		m_FSymbol = cloneSym;
		m_bUseFSymbol = true;
		
		repaint();
	}
	
	public void setTextDescrip(String str)
	{
		m_bUseFSymbol = false;
		m_Str = str;
	}

	/* (non-Javadoc)
	 * @see java.awt.Component#isShowing()
	 */
	public boolean isShowing() {
		// TODO Auto-generated method stub
		return true; // super.isShowing();
	}
}  //  @jve:visual-info  decl-index=0 visual-constraint="10,10"
