/*
 * Created on 01-jun-2004
 *
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.project.documents.view.legend.gui;

import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.core.FShape;
import com.iver.cit.gvsig.fmap.core.v02.FSymbol;
import com.iver.cit.gvsig.fmap.layers.Annotation_Layer;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.LayerEvent;
import com.iver.cit.gvsig.fmap.layers.LayerListener;
import com.iver.cit.gvsig.fmap.rendering.Annotation_Legend;
import com.iver.cit.gvsig.fmap.rendering.Legend;
import com.iver.cit.gvsig.fmap.rendering.VectorialLegend;

/**
 * Panel legend annotation properties.
 *
 * @author Vicente Caballero Navarro
 */
public class PanelLegendAnnotation extends AbstractPanel implements
		ILegendPanel,LayerListener {

	private VectorialLegend m_Renderer;

	private Annotation_Layer m_lyr;

	private FSymbol m_FSymbol;

	private javax.swing.JRadioButton jRadioButton = null;

	private javax.swing.JRadioButton jRadioButton1 = null;

	private JCheckBox jCheckBoxTextOnly = null;

	private JCheckBox chkDelOverLapping = null;

	private JCheckBox chkAvoidOverLapping = null;

	/**
	 * This is the default constructor
	 */
	public PanelLegendAnnotation() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private void initialize() {
		this.setLayout(null);
		this.setSize(454, 308);
		this.add(getJCheckBoxTextOnly(), null);
		ButtonGroup jButtonGroup = new ButtonGroup();
		jButtonGroup.add(getJRadioButton1());
		jButtonGroup.add(getJRadioButton());

		this.add(getJRadioButton1(), null);
		this.add(getJRadioButton(), null);
		this.add(getChkDelOverLapping(), null);
		this.add(getChkAvoidOverLapping(), null);
	}

	public void setLayer(FLayer lyr, Legend r) {
		m_lyr = (Annotation_Layer) lyr;
		m_Renderer = (VectorialLegend) r;
		getChkAvoidOverLapping().setSelected(((Annotation_Legend)r).isAvoidOverLapping());
		getChkDelOverLapping().setSelected(((Annotation_Legend)r).isDelOverLapping());
		if (r.getDefaultSymbol() instanceof FSymbol)
			setFSymbol((FSymbol) r.getDefaultSymbol());
		m_lyr.addLayerListener(this);
		if (m_lyr.isEditing()){
			chkAvoidOverLapping.setVisible(false);
			chkDelOverLapping.setVisible(false);
		}else{
			chkAvoidOverLapping.setVisible(true);
			chkDelOverLapping.setVisible(true);
		}
	}

	public void setFSymbol(FSymbol sym) {
		if (sym == null) {
			m_FSymbol = new FSymbol(FShape.MULTI);
		} else
			m_FSymbol = sym;

		getJRadioButton1().setSelected(!m_FSymbol.isFontSizeInPixels());
		getJCheckBoxTextOnly().setSelected(!m_FSymbol.isShapeVisible());
	}

	/**
	 * This method initializes jRadioButton
	 *
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButton() {
		if (jRadioButton == null) {
			jRadioButton = new javax.swing.JRadioButton();
			jRadioButton.setText(PluginServices.getText(this, "En_pixels"));
			jRadioButton.setBounds(new java.awt.Rectangle(27,50,303,23));
			jRadioButton.setSelected(true);
		}
		return jRadioButton;
	}

	/**
	 * This method initializes jRadioButton1
	 *
	 * @return javax.swing.JRadioButton
	 */
	private javax.swing.JRadioButton getJRadioButton1() {
		if (jRadioButton1 == null) {
			jRadioButton1 = new javax.swing.JRadioButton();
			jRadioButton1.setText(PluginServices.getText(this, "En_metros"));
			jRadioButton1.setBounds(new java.awt.Rectangle(27,21,303,23));
		}
		return jRadioButton1;
	}

	public Legend getLegend() {
		return m_Renderer;
	}

	/**
	 * @param renderer
	 *            The renderer to set.
	 */
	public void setRenderer(Legend renderer) {
		this.m_Renderer = (VectorialLegend) renderer;
		getChkDelOverLapping().setSelected(((Annotation_Legend)renderer).isDelOverLapping());
		getChkAvoidOverLapping().setSelected(((Annotation_Legend)renderer).isAvoidOverLapping());
		if (m_Renderer.getDefaultSymbol() instanceof FSymbol)
			setFSymbol((FSymbol) m_Renderer.getDefaultSymbol());
	}

	/**
	 * This method initializes jCheckBox1
	 *
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBoxTextOnly() {
		if (jCheckBoxTextOnly == null) {
			jCheckBoxTextOnly = new JCheckBox();
			jCheckBoxTextOnly.setBounds(27, 88, 303, 23);
			jCheckBoxTextOnly.setText(PluginServices.getText(this,
					"draw_text_only"));
		}
		return jCheckBoxTextOnly;
	}

	public void updateValuesFromControls(VectorialLegend l) {
		m_FSymbol.setFontSizeInPixels(jRadioButton.isSelected());
		m_FSymbol.setShapeVisible(!jCheckBoxTextOnly.isSelected());
		((Annotation_Legend)l).setAvoidOverLapping(chkAvoidOverLapping.isSelected());
		((Annotation_Legend)l).setDelOverLapping(chkDelOverLapping.isSelected());
		l.setDefaultSymbol(m_FSymbol);
	}

	public void repaint() {
		super.repaint();
	}

	public void actualizar() {
		getJRadioButton().setSelected(m_FSymbol.isFontSizeInPixels());
		getJCheckBoxTextOnly().setSelected(!m_FSymbol.isShapeVisible());
	}

	/**
	 * This method initializes chkOverWrite
	 *
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getChkDelOverLapping() {
		if (chkDelOverLapping == null) {
			chkDelOverLapping = new JCheckBox();
			chkDelOverLapping.setBounds(new java.awt.Rectangle(27,147,303,23));
			chkDelOverLapping.setText(PluginServices.getText(this,"remove_annotation_overlapping"));
			chkDelOverLapping.setSelected(false);
		}
		return chkDelOverLapping;
	}

	/**
	 * This method initializes chkTryNotOverWrite
	 *
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getChkAvoidOverLapping() {
		if (chkAvoidOverLapping == null) {
			chkAvoidOverLapping = new JCheckBox();
			chkAvoidOverLapping.setBounds(new java.awt.Rectangle(27,116,303,23));
			chkAvoidOverLapping.setText(PluginServices.getText(this,"avoid_overlapping"));

		}
		return chkAvoidOverLapping;
	}

	public void visibilityChanged(LayerEvent e) {
		// TODO Auto-generated method stub

	}

	public void activationChanged(LayerEvent e) {
		// TODO Auto-generated method stub

	}

	public void nameChanged(LayerEvent e) {
		// TODO Auto-generated method stub

	}

	public void editionChanged(LayerEvent e) {
		if (m_lyr ==null)
			return;
		if (m_lyr.isEditing()){
			chkAvoidOverLapping.setVisible(false);
			chkDelOverLapping.setVisible(false);
		}else{
			chkAvoidOverLapping.setVisible(true);
			chkDelOverLapping.setVisible(true);
		}

	}
}