/*
 * Created on 23-feb-2006
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: MaxFunction.java,v 1.2.2.1 2007/04/17 14:18:32 caballero Exp $
 * $Log: MaxFunction.java,v $
 * Revision 1.2.2.1  2007/04/17 14:18:32  caballero
 * cambio MIN_VALUE por NEGATIVE_INFINITY
 *
 * Revision 1.2  2006/06/20 18:19:43  azabala
 * refactorizacin para que todos los nuevos geoprocesos cuelguen del paquete impl
 *
 * Revision 1.1  2006/05/24 21:12:16  azabala
 * primera version en cvs despues de refactoring orientado a crear un framework extensible de geoprocessing
 *
 * Revision 1.1  2006/02/26 20:55:28  azabala
 * *** empty log message ***
 *
 *
 */
package com.iver.cit.gvsig.geoprocess.core.fmap;

import com.hardcode.gdbms.engine.values.NumericValue;
import com.hardcode.gdbms.engine.values.ValueFactory;

/**
 * * Sumarization function that returns min value of all field values.
 * 
 * @author azabala
 */
public class MaxFunction implements SummarizationFunction {

	double maxValue = Double.NEGATIVE_INFINITY;

	public void process(NumericValue value) {
		double val = value.doubleValue();
		if (maxValue < val) {
			maxValue = val;
		}
	}

	public NumericValue getSumarizeValue() {
		if(maxValue == Double.NEGATIVE_INFINITY){
			//process method wasnt be called
			return ValueFactory.createValue(0d);
		}
		return ValueFactory.createValue(maxValue);
	}
	
	public String toString(){
		return "max";
	}

	public void reset() {
		maxValue = Double.NEGATIVE_INFINITY;
		
	}

}
