/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 */
package org.gvsig.georeferencing.gui.panels;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionListener;

import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.gvsig.georeferencing.gui.dialog.GeoreferencingDialog;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.layers.FLyrPoints;
import com.iver.cit.gvsig.project.documents.view.gui.View;
/**
 * Panel que contiene opciones de georreferenciacin a elegir por
 * el usuario. Esta clase no maneja eventos.
 * 
 * @author Nacho Brodin (brodin_ign@gva.es)
 *
 */
public class GeorefOptionsPanel extends JPanel implements ActionListener{

	private JPanel pGeneral = null;
	private JPanel pGrado = null;
	private GeoreferencingDialog grd = null;
	
	private JLabel lGrado = null;
	private JComboBox cbGrado = null;
	private JPanel pAlgoritmo = null;
	private JLabel lAlgoritmo = null;
	private JComboBox cbAlgoritmo = null;
	private JPanel jPanel = null;
	private JPanel jPanel1 = null;
	private JPanel jPanel11 = null;
	private JPanel jPanel12 = null;
	private JPanel jPanel13 = null;
	private JPanel jPanel14 = null;
	private JPanel jPanel15 = null;
	private JPanel jPanel16 = null;
	
	/**
	 * This is the default constructor
	 */
	public GeorefOptionsPanel(GeoreferencingDialog grd) {
		super();
		this.grd = grd;
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
        this.setLayout(new BorderLayout());
        this.setPreferredSize(new java.awt.Dimension(380,160));
        this.setBounds(0, 0, 380, 160);
        this.add(getPGeneral(), java.awt.BorderLayout.CENTER);
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getPGeneral() {
		if (pGeneral == null) {
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			pGeneral = new JPanel();
			pGeneral.setLayout(new GridBagLayout());
			pGeneral.setPreferredSize(new java.awt.Dimension(380,20));
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.gridy = 0;
			gridBagConstraints5.anchor = java.awt.GridBagConstraints.CENTER;
			gridBagConstraints5.gridheight = 1;
			gridBagConstraints5.gridwidth = 1;
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridy = 1;
			gridBagConstraints7.gridx = 0;
			gridBagConstraints7.gridy = 2;
			pGeneral.add(getPGrado(), gridBagConstraints5);
			pGeneral.add(getPAlgoritmo(), gridBagConstraints1);
			pGeneral.add(getJPanel(), gridBagConstraints7);
		}
		return pGeneral;
	}
	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getPGrado() {
		if (pGrado == null) {
			lGrado = new JLabel();
			FlowLayout flowLayout6 = new FlowLayout();
			pGrado = new JPanel();
			pGrado.setLayout(flowLayout6);
			pGrado.setPreferredSize(new java.awt.Dimension(370,30));
			pGrado.setBorder(javax.swing.BorderFactory.createEmptyBorder(0,0,0,0));
			flowLayout6.setAlignment(java.awt.FlowLayout.LEFT);
			flowLayout6.setHgap(10);
			flowLayout6.setVgap(3);
			lGrado.setText(PluginServices.getText(this,"grado_polinomio"));
			pGrado.add(lGrado, null);
			pGrado.add(getCbGrado(), null);
			lGrado.setVisible(false);
			getCbGrado().setVisible(false);
		}
		return pGrado;
	}

	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getCbGrado() {
		if (cbGrado == null) {
			cbGrado = new JComboBox();
		}
		return cbGrado;
	}
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getPAlgoritmo() {
		if (pAlgoritmo == null) {
			lAlgoritmo = new JLabel();
			FlowLayout flowLayout2 = new FlowLayout();
			pAlgoritmo = new JPanel();
			pAlgoritmo.setLayout(flowLayout2);
			lAlgoritmo.setText(PluginServices.getText(this,"algoritmo"));
			pAlgoritmo.setPreferredSize(new java.awt.Dimension(370,30));
			flowLayout2.setAlignment(java.awt.FlowLayout.LEFT);
			flowLayout2.setHgap(10);
			flowLayout2.setVgap(3);
			pAlgoritmo.add(lAlgoritmo, null);
			pAlgoritmo.add(getCbAlgoritmo(), null);
			pAlgoritmo.setVisible(false);
			getCbAlgoritmo().setVisible(false);
		}
		return pAlgoritmo;
	}
	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getCbAlgoritmo() {
		if (cbAlgoritmo == null) {
			cbAlgoritmo = new JComboBox();
		}
		return cbAlgoritmo;
	}
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel() {
		if (jPanel == null) {
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.gridy = 1;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 0;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 0;
			gridBagConstraints3.gridy = 2;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.gridy = 3;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.gridy = 4;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 0;
			gridBagConstraints6.gridy = 5;
			jPanel = new JPanel();
			jPanel.setLayout(new GridBagLayout());
			jPanel.setPreferredSize(new java.awt.Dimension(370,120));
			jPanel.add(getJPanel11(), gridBagConstraints);
			jPanel.add(getJPanel12(), gridBagConstraints2);
			jPanel.add(getJPanel13(), gridBagConstraints3);
			jPanel.add(getJPanel14(), gridBagConstraints4);
			jPanel.add(getJPanel15(), gridBagConstraints5);
			jPanel.add(getJPanel16(), gridBagConstraints6);
		}
		return jPanel;
	}
	
	/**
	 * Accin cuando se pulsa el botn de aceptar en el dialogo.
	 * <UL>
	 * <LI>Cambiamos el nombre a la capa georraster</LI>
	 * <LI>A la capa Georraster le asignamos la capa de puntos para poder recuperarla</LI>
	 * <LI>Cerramos la ventana</LI>
	 * </UL>
	 */
	public void actionPerformed(java.awt.event.ActionEvent e) {
		if(e.getSource() instanceof JCheckBox){
			if(((JCheckBox)e.getSource()).getName().equals("mostrar_puntos")){
				FLyrPoints lyrPoints = grd.getConectorPanel().getDataPointsTabPanel().getSelectPointsPanel().getLyrPoints();
				View theView = null;
				try{
					theView = (View) PluginServices.getMDIManager().getActiveWindow();
				}catch(ClassCastException exc){
					return;
				}
								
				if(((JCheckBox)e.getSource()).isSelected()){ //Mostramos el nmero de punto
					grd.getConectorPanel().getDataPointsTabPanel().getSelectPointsPanel().getLyrPoints().setShowNumber(true);
					grd.getConectorPanel().getAdjustGeorefPanel().getZoomLeft().draw();
					grd.getConectorPanel().getAdjustGeorefPanel().getZoomRight().draw();
					theView.getMapControl().getMapContext().invalidate();
				}else{ //Ocultamos el nmero de punto
					grd.getConectorPanel().getDataPointsTabPanel().getSelectPointsPanel().getLyrPoints().setShowNumber(false);
					grd.getConectorPanel().getAdjustGeorefPanel().getZoomLeft().draw();
					grd.getConectorPanel().getAdjustGeorefPanel().getZoomRight().draw();
					theView.getMapControl().getMapContext().invalidate();
				}
			}
			
			if(((JCheckBox)e.getSource()).getName().equals("crear_worldfile")){
				if(((JCheckBox)e.getSource()).isSelected())
					grd.setCreateWorldFile(true);
				else
					grd.setCreateWorldFile(false);
			}
			
			if(((JCheckBox)e.getSource()).getName().equals("errores_csv")){
				if(((JCheckBox)e.getSource()).isSelected())
					grd.setErrorCSV(true);
				else
					grd.setErrorCSV(false);
			}
			
			if(((JCheckBox)e.getSource()).getName().equals("desactivar_capa")){
				if(((JCheckBox)e.getSource()).isSelected())
					grd.setOffLayer(true);
				else
					grd.setOffLayer(false);
			}
			
			if(((JCheckBox)e.getSource()).getName().equals("centrar_punto")){
				if(((JCheckBox)e.getSource()).isSelected())
					grd.setCenterPoint(true);
				else
					grd.setCenterPoint(false);
					
			}
			
			if(((JCheckBox)e.getSource()).getName().equals("desactivar_puntos")){
				if(((JCheckBox)e.getSource()).isSelected())
					grd.setOffPoints(true);
				else
					grd.setOffPoints(false);
					
			}
		}
	}

	/**
	 * This method initializes jPanel11	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel11() {
		if (jPanel11 == null) {
			jPanel11 =  new OptionsPanel(this.grd, "mostrar_puntos");
			((OptionsPanel)jPanel11).getCbCheckBox().addActionListener(this);
		}
		return jPanel11;
	}

	/**
	 * This method initializes jPanel12	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel12() {
		if (jPanel12 == null) {
			jPanel12 =  new OptionsPanel(this.grd, "crear_worldfile");
			((OptionsPanel)jPanel12).getCbCheckBox().setSelected(true);
			((OptionsPanel)jPanel12).getCbCheckBox().addActionListener(this);
		}
		return jPanel12;
	}

	/**
	 * This method initializes jPanel13	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel13() {
		if (jPanel13 == null) {
			jPanel13 =  new OptionsPanel(this.grd, "errores_csv");
			((OptionsPanel)jPanel13).getCbCheckBox().setSelected(true);
			((OptionsPanel)jPanel13).getCbCheckBox().addActionListener(this);
		}
		return jPanel13;
	}

	/**
	 * This method initializes jPanel14	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel14() {
		if (jPanel14 == null) {
			jPanel14 =  new OptionsPanel(this.grd, "desactivar_capa");
			((OptionsPanel)jPanel14).getCbCheckBox().setSelected(true);
			((OptionsPanel)jPanel14).getCbCheckBox().addActionListener(this);
		}
		return jPanel14;
	}
	
	/**
	 * This method initializes jPanel15	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel15() {
		if (jPanel15 == null) {
			jPanel15 =  new OptionsPanel(this.grd, "centrar_punto");
			((OptionsPanel)jPanel15).getCbCheckBox().setSelected(true);
			((OptionsPanel)jPanel15).getCbCheckBox().addActionListener(this);
		}
		return jPanel15;
	}
	
	/**
	 * This method initializes jPanel16	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel16() {
		if (jPanel16 == null) {
			jPanel16 =  new OptionsPanel(this.grd, "desactivar_puntos");
			((OptionsPanel)jPanel16).getCbCheckBox().setSelected(true);
			((OptionsPanel)jPanel16).getCbCheckBox().addActionListener(this);
		}
		return jPanel16;
	}
 }
