package com.iver.cit.gvsig.gui.dialogs;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;

import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import org.gvsig.remoteClient.wfs.WFSStatus;

import com.hardcode.gdbms.engine.instruction.FieldNotFoundException;
import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.andami.ui.mdiManager.WindowInfo;
import com.iver.cit.gvsig.ProjectExtension;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.drivers.wfs.FMapWFSDriver;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.fmap.layers.FLyrWFS;
import com.iver.cit.gvsig.fmap.layers.FLyrWFSFactory;
import com.iver.cit.gvsig.fmap.layers.WFSLayerNode;
import com.iver.cit.gvsig.fmap.rendering.VectorialLegend;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.cit.gvsig.gui.panels.WFSParamsPanel;
import com.iver.cit.gvsig.gui.wizards.WFSWizardData;
import com.iver.cit.gvsig.gui.wizards.WizardListener;
import com.iver.cit.gvsig.gui.wizards.WizardListenerSupport;
import com.iver.cit.gvsig.project.documents.table.ProjectTable;
import com.iver.cit.gvsig.project.documents.table.ProjectTableFactory;
import com.iver.cit.gvsig.project.documents.view.gui.BaseView;
import com.iver.cit.gvsig.project.documents.view.gui.View;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: WFSPropsDialog.java,v 1.4.2.14 2007/07/05 09:59:33 jorpiell Exp $
 * $Log: WFSPropsDialog.java,v $
 * Revision 1.4.2.14  2007/07/05 09:59:33  jorpiell
 * When a layer is modified the last project table is deleted
 *
 * Revision 1.4.2.13  2007/06/26 09:33:07  jorpiell
 * Refreshing the information tab always a change happens
 *
 * Revision 1.4.2.12  2007/01/08 10:09:12  ppiqueras
 * Corridos bugs + nueva funcionalidad.
 *
 * Revision 1.4.2.11  2007/01/04 10:06:25  jcampos
 * Upgrade new version
 *
 * Revision 1.4.2.10  2006/12/19 08:19:55  jorpiell
 * Problem decreasing the selected attributes number solved
 *
 * Revision 1.4.2.9  2006/12/18 08:43:55  jorpiell
 * Add a new method to set the layerDriver
 *
 * Revision 1.4.2.8  2006/12/04 09:38:51  ppiqueras
 * Bug corregido
 *
 * Revision 1.15  2006/12/04 08:59:47  ppiqueras
 * Algunos bugs corregidos. A cambio hay 2 bugs relacionados que todavía no han sido corregidos (ver PHPCollab) (los tiene asignados Jorge).
 *
 * Revision 1.14  2006/11/28 08:05:31  jorpiell
 * Se refrescan los mapas despus de aplicar un filtro
 *
 * Revision 1.13  2006/11/16 16:57:49  jorpiell
 * Se copia la laeyenda de la capa anterior antes de eliminarla
 *
 * Revision 1.12  2006/11/14 13:45:49  ppiqueras
 * Añadida pequeña funcionalidad:
 * Cuando se pulsa el botón "Aplicar", (al seleccionar un nuevo filtro), si el árbol de campos posee alguno seleccionado, actualiza los valores (con los nuevos), asociados a éste campo seleccionado.
 *
 * Revision 1.11  2006/10/31 09:40:49  jorpiell
 * Se ha creado una factoria para crear la capa. De ese modo no se repite cdigo desde le panel de propiedades y desde el panel de la capa
 *
 * Revision 1.9  2006/10/23 08:47:12  jorpiell
 * Refactorizado un mtodo
 *
 * Revision 1.8  2006/10/23 08:29:06  ppiqueras
 * Algunos cambios
 *
 * Revision 1.6  2006/10/02 09:09:45  jorpiell
 * Cambios del 10 copiados al head
 *
 * Revision 1.4.2.3  2006/09/27 11:12:15  jorpiell
 * Hay que comprobar que se han devuelto un nmero de features menor que el nmero mximo permitido
 *
 * Revision 1.4.2.2  2006/09/27 09:15:01  jorpiell
 * Ya no se hace otra peticin al pulsar sobre el botn aceptar.
 *
 * Revision 1.4.2.1  2006/09/19 12:28:11  jorpiell
 * Ya no se depende de geotools
 *
 *
 * Revision 1.4  2006/08/30 07:42:29  jorpiell
 * Se le asigna a la capa creada una proyeccin concreta. Si esto no se hace, al exportar a postigis se produce un error.
 *
 * Revision 1.3  2006/08/29 07:56:12  cesar
 * Rename the *View* family of classes to *Window* (ie: SingletonView to SingletonWindow, ViewInfo to WindowInfo, etc)
 *
 * Revision 1.2  2006/08/29 07:13:40  cesar
 * Rename class com.iver.andami.ui.mdiManager.View to com.iver.andami.ui.mdiManager.IWindow
 *
 * Revision 1.1  2006/06/21 12:35:45  jorpiell
 * Se ha aadido la ventana de propiedades. Esto implica aadir listeners por todos los paneles. Adems no se muestra la geomatra en la lista de atributos y se muestran nicamnete los que se van a descargar
 *
 *
 */
/**
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 * @author Pablo Piqueras Bartolom (p_queras@hotmail.com)
 */
public class WFSPropsDialog extends JPanel implements IWindow{
	private WFSParamsPanel wfsParamsTabbedPane = null;
	private WindowInfo m_ViewInfo = null;
	private FLayer fLayer = null;
	private JButton btnApply = null;
	private JButton btnOk = null;
	private JButton btnCancel = null;
	private CommandListener m_actionListener = null;
	private JPanel buttonsPanel = null;
	boolean applied = false;


	public WFSPropsDialog(FLayer layer) {
		super();
		initialize(layer);
	}

	private void initialize(FLayer layer) {
		setLayout(null);		
		setFLayer(layer);
		wfsParamsTabbedPane = getParamsPanel(((FLyrWFS) layer).getProperties());
		wfsParamsTabbedPane.addWizardListener(new WizardListener(){
			public void wizardStateChanged(boolean finishable) {
				getBtnOk().setEnabled(finishable);
				getBtnApply().setEnabled(finishable);
			}

			public void error(Exception e) {
			}

		})  ;
		//wfsParamsTabbedPane.disableDisagregatedLayers();
		this.add(wfsParamsTabbedPane);
		this.add(getButtonsPanel(), null);
	}

	public JPanel getButtonsPanel() {
		if (buttonsPanel == null) {
			m_actionListener = new CommandListener(this);
			buttonsPanel = new JPanel();
			buttonsPanel.setBounds(5, wfsParamsTabbedPane.getHeight(), 471, 40);
			buttonsPanel.setLayout(null);     
			buttonsPanel.setName("buttonPanel");

			buttonsPanel.add(getBtnOk(), null);
			buttonsPanel.add(getBtnApply(), null);
			buttonsPanel.add(getBtnCancel(), null);
		}
		return buttonsPanel;
	}


	/**
	 * With getParamsPanel we have access to the map config TabbedPane.
	 * If this panel doesn't exist yet (which can occur when an existing project is
	 * recovered) it is been automatically constructed by connecting to the server,
	 * reloading the necessary data, filling up the content and setting the selected
	 * values that were selected when the projet was saved.
	 * 
	 * 
	 * Since a connection to the server is needed when rebuiliding the panel, this
	 * causes a delay for the panel's showing up or a nullPointer error if there is
	 * no path to the server.
	 * 
	 * 
	 * Con getParamsPanel tenemos acceso a juego de pestaas de configuracin
	 * del mapa. Si este panel todava no existe (como puede ser cuando
	 * recuperamos un proyecto guardado) �ste se crea automticamente conectando
	 * al servidor, recuperando los datos necesarios, rellenando el contenido y
	 * dejando seleccionados los valores que estaban seleccionados cuando se
	 * guard� el proyecto.
	 * 
	 * 
	 * Como para reconstruirse requiere una conexi�n con el servidor esto causa
	 * un retardo en la aparici�n en el toc o un error de nullPointer si no
	 * hay conexi�n hasta el servidor.
	 * 
	 * 
	 * @return WMSParamsPanel
	 */
	public WFSParamsPanel getParamsPanel(HashMap info) {
		if (info!=null){
			URL host = (URL) info.get("host");
			WFSWizardData dataSource = new WFSWizardData();
			//dataSource.setHost(host, false);
			dataSource.setDriver(((FLyrWFS)fLayer).getWfsDriver());
			WFSParamsPanel toc = new WFSParamsPanel();
			toc.setStatus((WFSStatus)info.get("status"));
			toc.setWizardData(dataSource);
			toc.setListenerSupport(new WizardListenerSupport());
			toc.setSelectedFeature((WFSLayerNode)info.get("wfsLayerNode"));
			toc.setLayerName(fLayer.getName());
			toc.setVisible(true);
			toc.refreshInfo();
			applied = false;
			return toc;	    	
		}
		return null;        
	}


	public WindowInfo getWindowInfo() {
		if (m_ViewInfo == null){
			m_ViewInfo=new WindowInfo(WindowInfo.MODALDIALOG);
			m_ViewInfo.setTitle(PluginServices.getText(this,"fit_WFS_layer"));
			m_ViewInfo.setWidth(wfsParamsTabbedPane.getWidth()+ 10);
			m_ViewInfo.setHeight(wfsParamsTabbedPane.getHeight() + 40);
		}
		return m_ViewInfo;
	}

	/**
	 * @return Returns the fLayer.
	 */
	public FLayer getFLayer() {
		return fLayer;
	}

	/**
	 * @param layer The fLayer to set.
	 */
	public void setFLayer(FLayer layer) {
		fLayer = layer;
	}

	public JButton getBtnOk() {
		if (btnOk == null) {
			btnOk = new JButton("ok");
			btnOk.setText(PluginServices.getText(this,"ok"));
			btnOk.setActionCommand("OK");
			btnOk.addActionListener(m_actionListener);
			btnOk.setBounds(367, 9, 90, 25);
		}
		return btnOk;
	}

	public JButton getBtnApply() {
		if (btnApply == null) {
			btnApply = new JButton("apply");
			btnApply.setText(PluginServices.getText(this,"apply"));
			btnApply.setEnabled(false);
			btnApply.setActionCommand("APPLY");
			btnApply.addActionListener(m_actionListener);
			btnApply.setBounds(267, 9, 90, 25);
		}
		return btnApply;
	}

	public JButton getBtnCancel() {
		if (btnCancel == null) {
			btnCancel = new JButton("cancel");
			btnCancel.setText(PluginServices.getText(this,"cancel"));
			btnCancel.setActionCommand("CANCEL");
			btnCancel.addActionListener(m_actionListener);
			btnCancel.setBounds(137, 9, 90, 25);
		}
		return btnCancel;
	}

	public void close() {
		PluginServices.getMDIManager().closeWindow(this);		
	}

	/**
	 * Merge two FLayers in one
	 * @param group1
	 * @param group2
	 * @return
	 */
	private FLayers mergeFLayers(FLayers group1, FLayers group2)
	{    	
		FLayer layer;
		for(int i = 0; i < group2.getLayersCount(); i++)
		{
			layer = group2.getLayer( i );
			if(group1.getLayer( layer.getName()) == null ){
				group1.addLayer( layer );
			}
		}

		return group1;
	}

	private class CommandListener implements ActionListener {
		public CommandListener(WFSPropsDialog tp) {
			//m_tp = tp;
		}

		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {
			if ((e.getActionCommand() == "CANCEL") || (!getBtnApply().isEnabled())) {
				close();
				return;
			}else{					
				String layerName = fLayer.getName();
				VectorialLegend legend = (VectorialLegend)((FLyrVect)fLayer).getLegend();
				FMapWFSDriver driver = wfsParamsTabbedPane.getDriver();					 
				removeProjectTable((FLyrVect)fLayer);				 
				try {
					fLayer = wfsParamsTabbedPane.getLayer();
					URL host = new URL(wfsParamsTabbedPane.getData().getHost());
					String onlineResource = wfsParamsTabbedPane.getData().getOnlineResource();
					fLayer = new FLyrWFSFactory().getFLyrWFS(fLayer,host,onlineResource,driver,true);
					if (fLayer != null){
						((FLyrWFS)fLayer).setLegend(legend);
					}						 

				} catch (MalformedURLException e1) {
					e1.printStackTrace();
				} catch (FieldNotFoundException e1) {
					e1.printStackTrace();
				} catch (DriverException e1) {
					e1.printStackTrace();
				} 

				if (e.getActionCommand() == "APPLY"){
					// We can't 'apply' if there is a filter query and it's incorrect
					if (wfsParamsTabbedPane.getFilterQuery() != null) {					
						BaseView vista = (BaseView) PluginServices.getMDIManager().getActiveWindow();
						MapControl mapCtrl = vista.getMapControl();					 
						mapCtrl.getMapContext().getLayers().replaceLayer(layerName, fLayer);					 
						mapCtrl.getMapContext().invalidate();
						applied = true;
						getBtnApply().setEnabled(!applied);
						refreshLayouts();						 

						// If we load another layer, or the same but we've selected others attributes -> notify it to he WFSFilter panel
						if (getWFSFilterPanelIsAsTabForWFSLayersLoad() || (wfsParamsTabbedPane.getFieldsSelectedOfSameLayerHasChanged())) {
							setWFSFilterPanelIsAsTabForWFSLayersLoad(false);
							wfsParamsTabbedPane.resetFieldsSelectedOfSameLayerHasChanged(); // reset that attribute
						}

						// Update values associated to the current selected field
						wfsParamsTabbedPane.updateWFSFilterFieldValues();	
					}
					return;				 
				}

				if (e.getActionCommand() == "OK") {
					// We can't 'apply' if there is a filter query and it's incorrect
					if (wfsParamsTabbedPane.getFilterQuery() != null) {	
						if (!applied) {
							if (getBtnApply().isEnabled()){

								layerName = prepareFlyrWFSLayer();

								View vista = (View) PluginServices.getMDIManager().getActiveWindow();
								MapControl mapCtrl = vista.getMapControl();
								mapCtrl.getMapContext().getLayers().replaceLayer(layerName, fLayer);
								mapCtrl.getMapContext().invalidate();
								refreshLayouts();	
							}
						}	
						close();

						// Update all fields and values known about the current layer loaded (and selected)
						((FLyrWFS)fLayer).setAllFieldsAndValuesKnown(wfsParamsTabbedPane.getAllFieldsAndValuesKnownOfCurrentLayer());
					}
				}
			}
		}

		/**
		 * It removes the associated project table
		 * @param flayer
		 * Flayer vercorial
		 */
		private void removeProjectTable(FLyrVect flayer){
			//remove it
			ProjectExtension ext = (ProjectExtension) PluginServices.getExtension(ProjectExtension.class);
			ArrayList tables = ext.getProject().getDocumentsByType(ProjectTableFactory.registerName);
			for (int i=0 ; i<tables.size() ; i++){
				ProjectTable projectTable = (ProjectTable)tables.get(i);
				try {
					Object obj = projectTable.getAssociatedTable().getRecordset();
					if (flayer.getRecordset().equals(projectTable.getAssociatedTable().getRecordset())){
						ext.getProject().delDocument(projectTable);
					}
				} catch (DriverException e) {
					//It doens't matter. The table will not deleted
				}
				
			}
		}

		/**
		 * Updates data in the current layer of current active view
		 * 
		 * @param currentView The current active view
		 * @return Te name of the layer
		 */
		private String prepareFlyrWFSLayer() {
//			layerName = fLayer.getName();
			//	 	 View activeView = (View) PluginServices.getMDIManager().getActiveWindow();
			VectorialLegend legend = (VectorialLegend)((FLyrVect)fLayer).getLegend();
			FMapWFSDriver driver = wfsParamsTabbedPane.getDriver();						
			try {
				fLayer = wfsParamsTabbedPane.getLayer();
				URL host = new URL(wfsParamsTabbedPane.getData().getHost());
				String onlineResource = wfsParamsTabbedPane.getData().getOnlineResource();
				fLayer = new FLyrWFSFactory().getFLyrWFS(fLayer,host,onlineResource,driver,true);
				if (fLayer != null) {
					((FLyrWFS)fLayer).setLegend(legend);

					// Update all fields and values known about the current layer loaded (and selected)
					((FLyrWFS)fLayer).setAllFieldsAndValuesKnown(wfsParamsTabbedPane.getAllFieldsAndValuesKnownOfCurrentLayer());
				}
			} catch (MalformedURLException e1) {
				e1.printStackTrace();
			} catch (FieldNotFoundException e1) {
				e1.printStackTrace();
			} catch (DriverException e1) {
				e1.printStackTrace();
			}

			return fLayer.getName();
		}		
	}

	/**
	 * @see WFSFilterPanel#setWFSFilterPanelIsAsTabForWFSLayersLoad(boolean)
	 */
	public void setWFSFilterPanelIsAsTabForWFSLayersLoad(boolean b) {
		this.wfsParamsTabbedPane.setWFSFilterPanelIsAsTabForWFSLayersLoad(b);
	}

	/**
	 * @see WFSFilterPanel#getWFSFilterPanelIsAsTabForWFSLayersLoad()
	 */
	public boolean getWFSFilterPanelIsAsTabForWFSLayersLoad() {
		return this.wfsParamsTabbedPane.getWFSFilterPanelIsAsTabForWFSLayersLoad();
	}

	/**
	 * Sets all fielsd and values known of current layer to WFSFilterPanel
	 */
	public void updateAllFieldsAndValuesKnownOfCurrentLayerToWFSFilterPanel() {
		this.wfsParamsTabbedPane.setAllFieldsAndValuesKnownOfCurrentLayer(((FLyrWFS)this.getFLayer()).getAllFieldsAndValuesKnown());
	}

	/**
	 * Refresh the layouts
	 *
	 */
	private void refreshLayouts(){	
		IWindow[] windows = PluginServices.getMDIManager().getAllWindows();
		for (int i=0 ; i<windows.length ; i++){
			if (windows[i] instanceof Layout){
				((Layout)windows[i]).fullRefresh();
			}
		}
	}
}

