package com.iver.cit.gvsig.fmap.layers;
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2005 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */

/* CVS MESSAGES:
 *
 * $Id: TimeDimensionTest.java,v 1.5 2006/02/28 15:25:15 jaume Exp $
 * $Log: TimeDimensionTest.java,v $
 * Revision 1.5  2006/02/28 15:25:15  jaume
 * *** empty log message ***
 *
 * Revision 1.3.2.3  2006/01/31 16:25:24  jaume
 * correcciones de bugs
 *
 * Revision 1.4  2006/01/26 16:07:14  jaume
 * *** empty log message ***
 *
 * Revision 1.3.2.1  2006/01/26 12:59:33  jaume
 * 0.5
 *
 * Revision 1.3  2006/01/24 18:01:17  jaume
 * *** empty log message ***
 *
 * Revision 1.2  2006/01/24 14:36:33  jaume
 * This is the new version
 *
 * Revision 1.1.2.3  2006/01/20 15:59:13  jaume
 * *** empty log message ***
 *
 * Revision 1.1.2.2  2006/01/20 15:22:46  jaume
 * *** empty log message ***
 *
 * Revision 1.1.2.1  2006/01/19 16:09:30  jaume
 * *** empty log message ***
 *
 *
 */
/**
 * 
 */
import junit.framework.TestCase;

/**
 * 
 * @author jaume
 *
 */
public class TimeDimensionTest extends TestCase{
    static String[] values = new String[] {
        "2004-12-24/2005-12-18/P1D", //
        "2004-12-24/2005-12-18/PT1H", //
        "2004-12-24/2005-12-18/P1M", //
        "2000-07-01/2000-07-31/P1D", //
        "2004-10-12T13:55:20Z",
        "2004-10-12T13:55:20",
        "2004-10-12 13:55:20",
        "2004-10-12T13:55",
        "2004-10-12 13:55",
        "2004-10-12",
        "2004-10",
        "2004",
        "T13:55:20Z",
        "T13:55:20"
    };
    
    
    
    private TimeDimension t1;
    private TimeDimension t2;
    private TimeDimension t3;
    private TimeDimension t4;
    private TimeDimension t5;
    private TimeDimension t6;
    private TimeDimension t7;
    private TimeDimension t8;
    private TimeDimension t9;
    private TimeDimension t10;
    
    protected void setUp() {
    	// 8 Days and a position per day -> 8 positions
        t1 = new TimeDimension("ISO8601", "", "2004-12-24/2004-12-31/P1D");
        // 31 days -> 31 positions
        t2 = new TimeDimension("ISO8601", "", "2000-07-01/2000-07-31/P1D");
        // a 366-day year and a position per day -> 366 positions
        t3 = new TimeDimension("ISO8601", "", "2004-01-01/2004-12-31/P1D");
        // 1 days * 24 hours -> 25 positions
        t4 = new TimeDimension("ISO8601", "", "2004-01-01/2004-01-02/PT1H"); 
        // regular year of 365 days -> 365 positions
        t5 = new TimeDimension("ISO8601", "", "2005-01-01/2005-12-31/P1D");
        // a simple date (1 position)
        t6 = new TimeDimension("ISO8601", "", "2004-10-12T13:55:20Z");
        
        t7 = new TimeDimension("ISO8601", "", "2005-08-23T17:45Z");
        // 8 days and a position per day -> 8 positions
        t8 = new TimeDimension("ISO8601", "", "2005-08-23T17:45Z/2005-08-30T17:45Z/P1D");
    }

    public void testPositionCalculation() {
    	assertTrue(t1.valueCount()==8);
    	assertTrue(t2.valueCount()==31);
    	assertTrue(t3.valueCount()==366);
    	assertTrue(t4.valueCount()==25);
    	assertTrue(t5.valueCount()==365);
    	assertTrue(t6.valueCount()==1);
    	assertTrue(t7.valueCount()==1);
    	assertTrue(t8.valueCount()==8);
    }
}

/*
// los que dice que reconoce
1988-06-30/1988-10-02/P1D
2002-01-01/2002-12-31/P1D
2005-08-23T17:45Z/2005-08-30T17:45Z/P1D
2005-08-23T17:45Z/2005-08-30T17:45Z/P1D
2005-08-26T22:45Z/2005-08-30T22:45Z/PT5M
2005-08-26T22:45Z/2005-08-30T22:45Z/PT5M
2005-08-26T22:45Z/2005-08-30T22:45Z/PT5M
2005-08-26T22:45Z/2005-08-30T22:45Z/PT5M
2005-08-24T15:50Z
2005-08-25T16:30Z
2005-08-26T18:45Z
2005-08-27T16:20Z
2005-08-28T17:00Z
2005-08-29T19:15Z
2005-08-30T16:45Z
2005-08-31T15:50Z
2005-08-26T23:45Z/2005-08-30T23:45Z/PT5M
2005-08-26T23:45Z/2005-08-30T23:45Z/PT5M
2005-07-16T15:45Z
2005-07-17T16:25Z
2005-07-18T17:10Z
2005-07-19T19:20Z
2005-07-20T20:05Z
2005-07-06T15:05Z
2005-07-07T15:50Z
2005-07-09T18:45Z
2005-07-10T16:15Z
2002-01/2002-12/P1M
2004-01-24T20:22:19Z,2004-01-30T03:26:50Z,2004-02-14T00:18:00Z,2004-04-13T04:07:00Z
1991-06-16/1991-06-29/P1D
2003-09-02T14:20Z
2003-09-03T15:05Z
2003-09-04T17:15Z
2003-09-05T14:50Z
2003-09-06T17:05Z
2004-08-11T18:15Z
2004-08-12T15:55Z
2004-08-13T16:35Z
2004-09-05T13:30Z
2004-09-09T17:45Z
2004-09-10T15:25Z
2004-09-10T18:30Z
2004-09-11T16:10Z
2004-09-13T15:55Z
2004-09-13T19:00Z
2004-09-14T16:35Z
2004-09-15T18:50Z
2004-09-16T16:23Z
2005-01-06T00:00Z/2005-01-11T21:00Z/PT3H
2004-08-27T16:40Z
2004-08-28T14:15Z
2004-08-30T17:10Z
2004-08-31T14:45Z
2004-08-31T17:55Z
2004-09-01T15:30Z
2004-09-03T18:24Z
2004-09-04T16:00Z
2004-09-05T18:15Z
2004-09-06T19:00Z
2003-09-06T00:00Z/2003-09-19T21:00Z/PT3H
2000-07-01/2000-07-31/P1D
2003-10-23/2003-11-01/P1D
2004-06-21/2004-07-10/P1D
2000-01-01/2001-12-31/P1D
2000-01/2001-12/P1M
2003-06-20T12:00:00Z/2004-06-19T12:00:00Z/P1D
2004-08-13/2004-11-15/P1D
2002-07/2004-06/P1M
2002-07/2004-06/P1M
2002-07/2004-06/P1M
2002-07/2004-06/P1M
2002-07/2004-06/P1M
2002-07/2004-06/P1M
2002-07/2004-06/P1M
2002-07/2004-06/P1M
2002-07/2004-06/P1M
2004-09-16T17:55Z
2004-09-22T15:46Z
2004-09-23T18:00Z
2004-09-24T15:35Z
2004-09-25T16:15Z
2004-09-26T18:35Z
2004-09-02T00:00Z/2004-09-28T06:00Z/PT3H
2003-09-14T03:00Z/2003-09-21T00:00Z/PT3H
2003-09-14T03:00Z/2003-09-21T00:00Z/PT3H
2001-04-07/2001-04-17/P1D
2001-06-02/2001-06-20/P1D
2003-09-08T13:45Z
2003-09-10T16:40Z
2003-09-11T14:15Z
2003-09-12T15:00Z
2003-09-14T14:45Z
2003-09-14T17:55Z
2003-09-15T15:30Z
2003-09-16T17:40Z
2003-09-17T15:09Z
2003-09-17T18:24Z
2003-09-18T15:55Z
2002-06-02/2003-09-07/P1D
2000-01-01/2003-12-31/P1D
2000-01-01/2003-12-31/P1D
1997-12-20T00:00Z/1998-01-14T23:00Z/PT1H
1998-08-29T00:00Z/1998-09-19T23:00Z/PT1H
2000-03-01T06:00Z/2000-12-31T18:00Z/PT6H
2001-09-10T14:27:00Z/2001-09-10T14:31:59Z/PT1S
1973-09-15,1983-05-22,2000-09-25
1975-06-19,1986-08-01,1992-06-22,2001-02-07
1973-05-29,1987-08-19,2000-07-29
1998-05-10,1998-05-18,1998-05-22,1998-05-24,1998-05-29,1998-05-31
1988-06-30/1988-10-02/P1D
2002-01-01/2002-12-31/P1D
2003-08-03T09:46:21Z,2003-08-13T07:45:00Z,2003-08-23T05:43:52Z,2003-09-02T03:42:05Z,2003-09-12T01:40:49Z,2003-09-21T23:39:01Z,2003-10-01T21:38:00Z,2003-10-11T19:36:26Z,2003-10-21T17:34:41Z,2003-10-31T15:33:27Z,2003-11-10T13:32:02Z,2003-11-20T11:30:33Z,2003-11-30T09:29:00Z,2003-12-10T07:32:27Z,2003-12-20T05:31:28Z,2003-12-30T03:25:27Z,2004-01-09T01:24:02Z,2004-01-18T23:28:27Z,2004-01-28T21:26:59Z,2004-02-07T19:19:35Z,2004-02-17T17:18:15Z,2004-02-27T15:22:35Z,2004-03-08T13:21:08Z,2004-03-18T11:13:45Z,2004-03-28T09:12:24Z,2004-04-07T07:16:42Z,2004-04-17T05:13:59Z,2004-04-27T03:04:33Z,2004-05-07T01:06:04Z,2004-05-16T23:09:58Z,2004-05-26T18:47:47Z,2004-06-25T14:57:55Z,2004-07-05T12:56:09Z,2004-07-13T23:21:20Z,2004-07-25T08:53:03Z,2004-08-02T23:02:34Z,2004-08-14T04:50:00Z,2004-08-24T02:48:09Z,2004-09-03T00:46:54Z,2004-09-12T22:45:31Z,2004-09-22T20:44:38Z,2004-10-02T18:43:10Z,2004-10-12T16:41:35Z,2004-10-22T14:40:22Z,2004-11-01T12:39:46Z,2004-11-11T10:37:33Z,2004-11-21T08:35:33Z,2004-12-01T06:34:28Z,2004-12-11T04:33:17Z,2004-12-17T17:47:42Z,2004-12-30T23:59:57Z,2005-01-09T22:26:47Z,2005-01-19T20:27:49Z,2005-01-29T18:32:28Z,2005-02-08T16:25:08Z,2005-02-18T14:20:55Z,2005-02-28T12:21:58Z,2005-03-10T10:20:38Z,2005-03-17T02:54:59Z,2005-03-30T06:17:28Z,2005-04-09T04:16:07Z,2005-04-19T02:15:15Z
2005-01-01/2005-07-03/P1D
2005-01-01/2005-07-03/P1D
2005-01-01/2005-07-03/P1D
2005-01-01/2005-07-03/P1D
1997-01-01/1999-12-27/P10D
1997-01-01/1999-12-27/P10D
1998-05-10,1998-05-18,1998-05-22,1998-05-24,1998-05-29,1998-05-31
1997-12-20T00:00Z/1998-01-14T23:00Z/PT1H
1998-08-29T00:00Z/1998-09-19T23:00Z/PT1H
2002-01/2002-12/P1M
2002-10-01/2003-06-22/P1D
1979-09/2004-09/P1Y
2002-01/2002-12/P1M
2001-05-20,2002-05-23,2003-05-19
2004-01-01/2004-12-31/P1D
2000-09-16,2000-11-28,2000-12-12,2001-01-01,2001-01-22,2001-02-25,2001-09-08,2001-10-10,2001-10-26,2001-11-04,2001-11-09,2001-11-11,2001-11-12
1993-02-17,2000-02-21,2002-06-02
2002-01-31,2002-02-17,2002-02-23,2002-03-05,2002-03-07
2002-07/2004-06/P1M
2002-07/2004-06/P1M
2004-11-09T21:10Z,2004-11-15T20:35Z,2004-11-19T20:10Z,2004-11-21T04:00Z,2004-11-26T20:15Z,2004-12-02T21:20Z,2004-12-04T21:05Z,2004-12-07T21:35Z,2004-12-10T20:30Z,2004-12-13T12:50Z,2004-12-20T21:05Z,2004-12-23T21:35Z,2005-01-02T20:35Z,2005-01-11T20:30Z,2005-01-12T21:10Z,2005-01-14T21:00Z,2005-01-17T21:30Z,2005-01-18T20:35Z,2005-01-21T21:05Z,2005-01-26T21:25Z,2005-01-29T04:20Z,2005-01-30T05:05Z,2005-01-31T05:45Z,2005-02-02T03:55Z,2005-02-14T21:55Z,2005-02-19T20:35Z,2005-02-25T21:35Z,2005-02-26T20:40Z,2005-03-21T04:50Z
2002-09-01/2003-07-01/P1D
2002-09-01/2003-07-01/P1D
2002-09-01/2003-06-30/P1D
2005-08-23T17:45Z/2005-08-30T17:45Z/P1D
2005-08-23T17:45Z/2005-08-30T17:45Z/P1D
2005-08-26T22:45Z/2005-08-30T22:45Z/PT5M
2005-08-26T22:45Z/2005-08-30T22:45Z/PT5M
2005-08-26T22:45Z/2005-08-30T22:45Z/PT5M
2005-08-26T22:45Z/2005-08-30T22:45Z/PT5M
2005-08-24T15:50Z
2005-08-25T16:30Z
2005-08-26T18:45Z
2005-08-27T16:20Z
2005-08-28T17:00Z
2005-08-29T19:15Z
2005-08-30T16:45Z
2005-08-31T15:50Z
2005-08-26T23:45Z/2005-08-30T23:45Z/PT5M
2005-08-26T23:45Z/2005-08-30T23:45Z/PT5M
2005-07-16T15:45Z
2005-07-17T16:25Z
2005-07-18T17:10Z
2005-07-19T19:20Z
2005-07-20T20:05Z
2005-07-06T15:05Z
2005-07-07T15:50Z
2005-07-09T18:45Z
2005-07-10T16:15Z
1991-06-16/1991-06-29/P1D
2003-09-02T14:20Z
2003-09-03T15:05Z
2003-09-04T17:15Z
2003-09-05T14:50Z
2003-09-06T17:05Z
2004-08-11T18:15Z
2004-08-12T15:55Z
2004-08-13T16:35Z
2004-09-05T13:30Z
2004-09-09T17:45Z
2004-09-10T15:25Z
2004-09-10T18:30Z
2004-09-11T16:10Z
2004-09-13T15:55Z
2004-09-13T19:00Z
2004-09-14T16:35Z
2004-09-15T18:50Z
2004-09-16T16:23Z
2004-08-27T16:40Z
2004-08-28T14:15Z
2004-08-30T17:10Z
2004-08-31T14:45Z
2004-08-31T17:55Z
2004-09-01T15:30Z
2004-09-03T18:24Z
2004-09-04T16:00Z
2004-09-05T18:15Z
2004-09-06T19:00Z
1973-09-15,1983-05-22,2000-09-25
1975-06-19,1986-08-01,1992-06-22,2001-02-07
1973-05-29,1987-08-19,2000-07-29
2004-09-16T17:55Z
2004-09-22T15:46Z
2004-09-23T18:00Z
2004-09-24T15:35Z
2004-09-25T16:15Z
2004-09-26T18:35Z
2004-09-02T00:00Z/2004-09-28T06:00Z/PT3H
2003-09-14T03:00Z/2003-09-21T00:00Z/PT3H
2003-09-14T03:00Z/2003-09-21T00:00Z/PT3H
2001-06-02/2001-06-20/P1D
2003-09-08T13:45Z
2003-09-10T16:40Z
2003-09-11T14:15Z
2003-09-12T15:00Z
2003-09-14T14:45Z
2003-09-14T17:55Z
2003-09-15T15:30Z
2003-09-16T17:40Z
2003-09-17T15:09Z
2003-09-17T18:24Z
2003-09-18T15:55Z
1973-12-25,1975-12-24,1977-02-10,1979-11-06,1988-12-10,1992-01-20,1995-12-30,2000-01-02,2001-11-20
1988-06-30/1988-10-02/P1D
2001-09-10T14:27:00Z/2001-09-10T14:31:59Z/PT1S
1980-01-12/1995-12-31/P12D
2002-01-01/2002-12-31/P1D
2002-01/2002-12/P1M
2002-10-01/2003-06-22/P1D
2001-05-20,2002-05-23,2003-05-19
1973-05-29,1987-08-19,2000-07-29
2002-07/2004-06/P1M
2002-07/2004-06/P1M
2002-09-01/2003-07-01/P1D
2002-09-01/2003-07-01/P1D
2002-09-01/2003-06-30/P1D
2002-07/2004-06/P1M
2002-07/2004-06/P1M
2003-08-03T09:46:21Z,2003-08-13T07:45:00Z,2003-08-23T05:43:52Z,2003-09-02T03:42:05Z,2003-09-12T01:40:49Z,2003-09-21T23:39:01Z,2003-10-01T21:38:00Z,2003-10-11T19:36:26Z,2003-10-21T17:34:41Z,2003-10-31T15:33:27Z,2003-11-10T13:32:02Z,2003-11-20T11:30:33Z,2003-11-30T09:29:00Z,2003-12-10T07:32:27Z,2003-12-20T05:31:28Z,2003-12-30T03:25:27Z,2004-01-09T01:24:02Z,2004-01-18T23:28:27Z,2004-01-28T21:26:59Z,2004-02-07T19:19:35Z,2004-02-17T17:18:15Z,2004-02-27T15:22:35Z,2004-03-08T13:21:08Z,2004-03-18T11:13:45Z,2004-03-28T09:12:24Z,2004-04-07T07:16:42Z,2004-04-17T05:13:59Z,2004-04-27T03:04:33Z,2004-05-07T01:06:04Z,2004-05-16T23:09:58Z,2004-05-26T18:47:47Z,2004-06-25T14:57:55Z,2004-07-05T12:56:09Z,2004-07-13T23:21:20Z,2004-07-25T08:53:03Z,2004-08-02T23:02:34Z,2004-08-14T04:50:00Z,2004-08-24T02:48:09Z,2004-09-03T00:46:54Z,2004-09-12T22:45:31Z,2004-09-22T20:44:38Z,2004-10-02T18:43:10Z,2004-10-12T16:41:35Z,2004-10-22T14:40:22Z,2004-11-01T12:39:46Z,2004-11-11T10:37:33Z,2004-11-21T08:35:33Z,2004-12-01T06:34:28Z,2004-12-11T04:33:17Z,2004-12-17T17:47:42Z,2004-12-30T23:59:57Z,2005-01-09T22:26:47Z,2005-01-19T20:27:49Z,2005-01-29T18:32:28Z,2005-02-08T16:25:08Z,2005-02-18T14:20:55Z,2005-02-28T12:21:58Z,2005-03-10T10:20:38Z,2005-03-17T02:54:59Z,2005-03-30T06:17:28Z,2005-04-09T04:16:07Z,2005-04-19T02:15:15Z
2005-01-01/2005-07-03/P1D
2005-01-01/2005-07-03/P1D
2005-01-01/2005-07-03/P1D
2005-01-01/2005-07-03/P1D
1979-09/2004-09/P1Y
2002-01/2002-12/P1M
1997-01-01/1999-12-27/P10D
1997-01-01/1999-12-27/P10D
2002-07/2004-06/P1M
2002-07/2004-06/P1M
2002-07/2004-06/P1M
2002-07/2004-06/P1M
2002-09-01/2003-07-01/P1D
2002-09-01/2003-07-01/P1D
1998-05-10,1998-05-18,1998-05-22,1998-05-24,1998-05-29,1998-05-31
2002-06-02/2003-09-07/P1D
2002-06-02/2003-09-07/P1D
2002-06-02/2003-09-07/P1D
2001-09-10T14:27:00Z/2001-09-10T14:31:59Z/PT1S
1991-06-16/1991-06-29/P1D
1973-09-15,1983-05-22,2000-09-25
1960-01/1995-12/P1M
1960-01/1995-12/P1M
1980-01-12/1995-12-31/P12D
2005-08-23T17:45Z/2005-08-30T17:45Z/P1D
2005-08-23T17:45Z/2005-08-30T17:45Z/P1D
2005-08-26T22:45Z/2005-08-30T22:45Z/PT5M
2005-08-26T22:45Z/2005-08-30T22:45Z/PT5M
2005-08-26T22:45Z/2005-08-30T22:45Z/PT5M
2005-08-26T22:45Z/2005-08-30T22:45Z/PT5M
2005-08-26T23:45Z/2005-08-30T23:45Z/PT5M
2005-08-26T23:45Z/2005-08-30T23:45Z/PT5M
2001-05-20,2002-05-23,2003-05-19
2004-01-24T20:22:19Z,2004-01-30T03:26:50Z,2004-02-14T00:18:00Z,2004-04-13T04:07:00Z
2003-06-20T12:00:00Z/2004-06-19T12:00:00Z/P1D
2002-07/2004-06/P1M  
1880-/2000-/P10Y
1790-/2000-/P10Y

  
 
// los que dice que no reconoce
2004-08-13/2004-08-17/P1D,2004-08-20/2004-08-23/P1D,2004-08-25/2004-08-31/P1D,2004-09-02/2004-09-06/P1D,2004-09-10/2004-09-16/P2D,2004-09-17/2004-09-22/P1D,2004-09-24/2004-09-29/P1D,2004-10-01,2004-10-03/2004-10-07/P1D,2004-10-09/2004-10-12/P1D,2004-10-14,2004-10-15
2003-08-27T00Z,2003-08-27T03Z,2003-08-27T15Z/2003-09-08T09Z/PT3H
1995-09-06T10:23Z/1995-09-06T10:29Z/PT1M,1995-09-06T10:32Z/1995-09-06T10:35Z/PT1M,1995-09-06T10:39Z,1995-09-06T10:41Z/1995-09-06T10:43Z/PT1M,1995-09-06T10:45Z/1995-09-06T10:49Z/PT1M,1995-09-06T10:51Z/1995-09-06T10:59Z/PT1M,1995-09-06T11:02Z/1995-09-06T11:05Z/PT1M,1995-09-06T11:09Z,1995-09-06T11:11Z/1995-09-06T11:13Z/PT1M,1995-09-06T11:15Z/1995-09-06T11:19Z/PT1M,1995-09-06T11:21Z/1995-09-06T11:29Z/PT1M,1995-09-06T11:32Z/1995-09-06T11:35Z/PT1M,1995-09-06T11:39Z,1995-09-06T11:41Z/1995-09-06T11:43Z/PT1M,1995-09-06T11:45Z/1995-09-06T11:51Z/PT1M,1995-09-06T11:53Z/1995-09-06T12:10Z/PT1M,1995-09-06T12:13Z,1995-09-06T12:15Z/1995-09-06T12:19Z/PT1M,1995-09-06T12:21Z,1995-09-06T12:23Z/1995-09-06T12:29Z/PT1M,1995-09-06T12:45Z/1995-09-06T12:51Z/PT1M,1995-09-06T12:53Z/1995-09-06T12:59Z/PT1M,1995-09-06T13:02Z/1995-09-06T13:05Z/PT1M,1995-09-06T13:09Z,1995-09-06T13:10Z,1995-09-06T13:12Z,1995-09-06T13:13Z,1995-09-06T13:15Z/1995-09-06T13:20Z/PT1M,1995-09-06T13:22Z/1995-09-06T13:29Z/PT1M,1995-09-06T13:32Z/1995-09-06T13:35Z/PT1M,1995-09-06T13:39Z,1995-09-06T13:40Z,1995-09-06T13:42Z,1995-09-06T13:43Z,1995-09-06T13:45Z/1995-09-06T13:50Z/PT1M,1995-09-06T13:52Z/1995-09-06T13:59Z/PT1M,1995-09-06T14:02Z/1995-09-06T14:05Z/PT1M,1995-09-06T14:09Z,1995-09-06T14:10Z,1995-09-06T14:12Z,1995-09-06T14:13Z,1995-09-06T14:15Z/1995-09-06T14:20Z/PT1M,1995-09-06T14:22Z/1995-09-06T14:29Z/PT1M,1995-09-06T14:32Z/1995-09-06T14:35Z/PT1M,1995-09-06T14:39Z,1995-09-06T14:41Z/1995-09-06T14:43Z/PT1M,1995-09-06T14:45Z/1995-09-06T14:51Z/PT1M,1995-09-06T14:53Z/1995-09-06T14:58Z/PT1M
2003-08-27T02:45Z/2003-09-17T08:45Z/PT6H,2003-09-17T20:45Z/2003-09-18T14:45Z/PT6H,2003-09-19T08:45Z/2003-09-21T20:45Z/PT6H
2001-09-01T00:45Z/2001-09-01T03:45Z/PT30M,2001-09-01T04:00Z/2001-09-01T06:00Z/PT30M,2001-09-01T06:45Z/2001-09-01T11:15Z/PT30M,2001-09-01T14:15Z/2001-09-01T19:15Z/PT30M,2001-09-01T20:15Z/2001-09-02T03:45Z/PT30M,2001-09-02T04:00Z/2001-09-02T06:00Z/PT30M,2001-09-02T06:45Z/2001-09-03T03:45Z/PT30M,2001-09-03T04:00Z/2001-09-03T05:00Z/PT30M,2001-09-03T06:00Z,2001-09-03T06:45Z/2001-09-04T03:45Z/PT30M,2001-09-04T04:00Z/2001-09-04T06:00Z/PT30M,2001-09-04T06:45Z/2001-09-04T19:45Z/PT30M,2001-09-04T20:45Z/2001-09-05T03:45Z/PT30M,2001-09-05T04:00Z/2001-09-05T05:00Z/PT30M,2001-09-05T06:00Z,2001-09-05T06:45Z/2001-09-06T03:45Z/PT30M,2001-09-06T04:00Z/2001-09-06T06:00Z/PT30M,2001-09-06T06:45Z/2001-09-07T03:45Z/PT30M,2001-09-07T04:00Z/2001-09-07T05:00Z/PT30M,2001-09-07T06:00Z,2001-09-07T06:45Z/2001-09-07T11:15Z/PT30M,2001-09-07T12:45Z/2001-09-07T15:15Z/PT30M,2001-09-07T16:15Z/2001-09-08T03:45Z/PT30M,2001-09-08T04:00Z/2001-09-08T06:00Z/PT30M,2001-09-08T06:45Z/2001-09-08T22:45Z/PT30M,2001-09-08T23:45Z/2001-09-09T03:45Z/PT30M,2001-09-09T04:00Z/2001-09-09T05:00Z/PT30M,2001-09-09T06:45Z/2001-09-10T03:45Z/PT30M,2001-09-10T04:00Z/2001-09-10T06:00Z/PT30M,2001-09-10T06:45Z/2001-09-11T03:45Z/PT30M,2001-09-11T04:30Z,2001-09-11T05:00Z,2001-09-11T06:00Z,2001-09-11T06:45Z/2001-09-11T20:45Z/PT30M,2001-09-12T03:45Z,2001-09-12T04:00Z/2001-09-12T06:00Z/PT30M,2001-09-12T06:45Z/2001-09-13T03:45Z/PT30M,2001-09-13T04:00Z/2001-09-13T05:00Z/PT30M,2001-09-13T06:00Z,2001-09-13T06:45Z/2001-09-14T03:45Z/PT30M,2001-09-14T04:00Z/2001-09-14T06:00Z/PT30M,2001-09-14T06:45Z/2001-09-15T03:45Z/PT30M,2001-09-15T04:00Z/2001-09-15T06:00Z/PT30M,2001-09-15T06:45Z/2001-09-15T23:45Z/PT30M
2001-09-01T00:45Z/2001-09-01T03:45Z/PT30M,2001-09-01T04:00Z/2001-09-01T06:00Z/PT30M,2001-09-01T06:45Z/2001-09-01T11:15Z/PT30M,2001-09-01T14:15Z/2001-09-01T19:15Z/PT30M,2001-09-01T20:15Z/2001-09-02T03:45Z/PT30M,2001-09-02T04:00Z/2001-09-02T06:00Z/PT30M,2001-09-02T06:45Z/2001-09-03T03:45Z/PT30M,2001-09-03T04:00Z/2001-09-03T05:00Z/PT30M,2001-09-03T06:00Z,2001-09-03T06:45Z/2001-09-04T03:45Z/PT30M,2001-09-04T04:00Z/2001-09-04T06:00Z/PT30M,2001-09-04T06:45Z/2001-09-04T19:45Z/PT30M,2001-09-04T20:45Z/2001-09-05T03:45Z/PT30M,2001-09-05T04:00Z/2001-09-05T05:00Z/PT30M,2001-09-05T06:00Z,2001-09-05T06:45Z/2001-09-06T03:45Z/PT30M,2001-09-06T04:00Z/2001-09-06T06:00Z/PT30M,2001-09-06T06:45Z/2001-09-07T03:45Z/PT30M,2001-09-07T04:00Z/2001-09-07T05:00Z/PT30M,2001-09-07T06:00Z,2001-09-07T06:45Z/2001-09-07T11:15Z/PT30M,2001-09-07T12:45Z/2001-09-07T15:15Z/PT30M,2001-09-07T16:15Z/2001-09-08T03:45Z/PT30M,2001-09-08T04:00Z/2001-09-08T06:00Z/PT30M,2001-09-08T06:45Z/2001-09-08T22:45Z/PT30M,2001-09-08T23:45Z/2001-09-09T03:45Z/PT30M,2001-09-09T04:00Z/2001-09-09T05:00Z/PT30M,2001-09-09T06:45Z/2001-09-10T03:45Z/PT30M,2001-09-10T04:00Z/2001-09-10T06:00Z/PT30M,2001-09-10T06:45Z/2001-09-11T03:45Z/PT30M,2001-09-11T04:30Z,2001-09-11T05:00Z,2001-09-11T06:00Z,2001-09-11T06:45Z/2001-09-11T20:45Z/PT30M,2001-09-12T03:45Z,2001-09-12T04:00Z/2001-09-12T06:00Z/PT30M,2001-09-12T06:45Z/2001-09-13T03:45Z/PT30M,2001-09-13T04:00Z/2001-09-13T05:00Z/PT30M,2001-09-13T06:00Z,2001-09-13T06:45Z/2001-09-14T03:45Z/PT30M,2001-09-14T04:00Z/2001-09-14T06:00Z/PT30M,2001-09-14T06:45Z/2001-09-15T03:45Z/PT30M,2001-09-15T04:00Z/2001-09-15T06:00Z/PT30M,2001-09-15T06:45Z/2001-09-15T23:45Z/PT30M
1999-08-26T14:15Z/1999-08-26T14:45Z/PT15M,1999-08-26T15:15Z/1999-08-26T15:45Z/PT15M,1999-08-26T15:59Z,1999-08-26T16:15Z/1999-08-26T16:45Z/PT15M,1999-08-26T16:59Z,1999-08-26T17:15Z,1999-08-26T17:32Z,1999-08-26T17:40Z,1999-08-26T17:45Z,1999-08-26T18:15Z,1999-08-26T18:25Z,1999-08-26T18:46Z,1999-08-26T18:55Z,1999-08-26T19:03Z,1999-08-26T19:10Z,1999-08-26T19:15Z,1999-08-26T19:25Z,1999-08-26T19:32Z,1999-08-26T19:40Z,1999-08-26T19:45Z,1999-08-26T19:55Z,1999-08-26T20:02Z,1999-08-26T20:10Z,1999-08-26T20:15Z,1999-08-26T20:25Z,1999-08-26T20:32Z,1999-08-26T20:40Z,1999-08-26T20:45Z,1999-08-26T21:15Z,1999-08-26T21:25Z,1999-08-26T21:32Z,1999-08-26T21:40Z,1999-08-26T21:45Z,1999-08-26T21:55Z,1999-08-26T22:02Z,1999-08-26T22:10Z,1999-08-26T22:15Z,1999-08-26T22:25Z,1999-08-26T22:32Z,1999-08-26T22:40Z,1999-08-26T22:45Z,1999-08-26T22:55Z,1999-08-26T23:03Z,1999-08-26T23:10Z,1999-08-26T23:15Z,1999-08-26T23:25Z,1999-08-26T23:32Z,1999-08-26T23:40Z,1999-08-26T23:45Z/1999-08-27T00:45Z/PT30M,1999-08-27T00:55Z,1999-08-27T01:03Z,1999-08-27T01:10Z,1999-08-27T01:15Z,1999-08-27T01:25Z,1999-08-27T01:32Z,1999-08-27T01:45Z,1999-08-27T02:02Z,1999-08-27T02:15Z,1999-08-27T02:32Z,1999-08-27T02:45Z,1999-08-27T03:15Z,1999-08-27T03:32Z,1999-08-27T03:45Z,1999-08-27T04:02Z,1999-08-27T04:15Z,1999-08-27T06:15Z,1999-08-27T06:46Z,1999-08-27T07:02Z,1999-08-27T07:15Z,1999-08-27T07:32Z,1999-08-27T07:45Z,1999-08-27T08:02Z,1999-08-27T08:15Z/1999-08-27T09:45Z/PT30M,1999-08-27T10:02Z,1999-08-27T10:15Z,1999-08-27T10:32Z,1999-08-27T10:45Z,1999-08-27T11:02Z,1999-08-27T11:15Z,1999-08-27T11:32Z,1999-08-27T11:45Z/1999-08-27T12:45Z/PT30M,1999-08-27T13:02Z,1999-08-27T13:15Z,1999-08-27T13:33Z,1999-08-27T13:40Z,1999-08-27T13:45Z,1999-08-27T13:55Z,1999-08-27T14:03Z,1999-08-27T14:10Z,1999-08-27T14:15Z,1999-08-27T14:25Z,1999-08-27T14:33Z,1999-08-27T14:40Z,1999-08-27T14:45Z,1999-08-27T15:15Z,1999-08-27T15:25Z,1999-08-27T15:33Z,1999-08-27T15:40Z,1999-08-27T15:45Z,1999-08-27T15:55Z,1999-08-27T16:02Z,1999-08-27T16:10Z,1999-08-27T16:15Z,1999-08-27T16:25Z,1999-08-27T16:32Z,1999-08-27T16:40Z,1999-08-27T16:45Z,1999-08-27T16:55Z,1999-08-27T17:02Z,1999-08-27T17:10Z,1999-08-27T17:15Z,1999-08-27T17:25Z,1999-08-27T17:32Z,1999-08-27T17:40Z,1999-08-27T17:45Z,1999-08-27T18:15Z,1999-08-27T18:25Z,1999-08-27T18:46Z,1999-08-27T18:55Z,1999-08-27T19:03Z,1999-08-27T19:15Z,1999-08-27T19:25Z,1999-08-27T19:33Z,1999-08-27T19:40Z,1999-08-27T19:45Z,1999-08-27T19:55Z,1999-08-27T20:03Z,1999-08-27T20:10Z,1999-08-27T20:15Z,1999-08-27T20:25Z,1999-08-27T20:33Z,1999-08-27T20:40Z,1999-08-27T20:45Z,1999-08-27T21:15Z,1999-08-27T21:25Z,1999-08-27T21:32Z,1999-08-27T21:45Z,1999-08-27T22:02Z,1999-08-27T22:15Z,1999-08-27T22:32Z,1999-08-27T22:45Z,1999-08-27T23:02Z,1999-08-27T23:15Z,1999-08-27T23:32Z,1999-08-27T23:45Z,1999-08-28T00:15Z,1999-08-28T00:46Z,1999-08-28T00:55Z,1999-08-28T01:03Z,1999-08-28T01:10Z,1999-08-28T01:15Z,1999-08-28T01:25Z,1999-08-28T01:32Z,1999-08-28T01:40Z,1999-08-28T01:45Z,1999-08-28T01:55Z,1999-08-28T02:02Z,1999-08-28T02:10Z,1999-08-28T02:15Z,1999-08-28T02:25Z,1999-08-28T02:32Z,1999-08-28T02:40Z,1999-08-28T02:45Z,1999-08-28T03:15Z,1999-08-28T03:25Z,1999-08-28T03:32Z,1999-08-28T03:40Z,1999-08-28T03:45Z,1999-08-28T03:55Z,1999-08-28T04:03Z,1999-08-28T04:10Z,1999-08-28T05:33Z,1999-08-28T05:40Z,1999-08-28T06:15Z,1999-08-28T06:25Z,1999-08-28T06:45Z,1999-08-28T06:55Z,1999-08-28T07:02Z,1999-08-28T07:15Z,1999-08-28T07:25Z,1999-08-28T07:32Z,1999-08-28T07:40Z,1999-08-28T07:45Z,1999-08-28T07:55Z,1999-08-28T08:02Z,1999-08-28T08:10Z,1999-08-28T08:15Z,1999-08-28T08:25Z,1999-08-28T08:32Z,1999-08-28T08:40Z,1999-08-28T08:45Z,1999-08-28T09:15Z,1999-08-28T09:25Z,1999-08-28T09:45Z,1999-08-28T10:02Z,1999-08-28T10:15Z,1999-08-28T10:32Z,1999-08-28T10:45Z,1999-08-28T11:02Z,1999-08-28T11:15Z,1999-08-28T11:32Z,1999-08-28T11:45Z/1999-08-28T12:45Z/PT30M,1999-08-28T12:55Z,1999-08-28T13:02Z,1999-08-28T13:10Z,1999-08-28T13:15Z,1999-08-28T13:25Z,1999-08-28T13:33Z,1999-08-28T13:40Z,1999-08-28T13:45Z,1999-08-28T13:55Z,1999-08-28T14:03Z,1999-08-28T14:10Z,1999-08-28T14:15Z,1999-08-28T14:25Z,1999-08-28T14:33Z,1999-08-28T14:40Z,1999-08-28T14:45Z,1999-08-28T15:15Z,1999-08-28T15:25Z,1999-08-28T15:32Z,1999-08-28T15:40Z,1999-08-28T15:45Z,1999-08-28T15:55Z,1999-08-28T16:02Z,1999-08-28T16:10Z,1999-08-28T16:15Z,1999-08-28T16:25Z,1999-08-28T16:32Z,1999-08-28T16:40Z,1999-08-28T16:45Z,1999-08-28T16:55Z,1999-08-28T17:02Z,1999-08-28T17:10Z,1999-08-28T17:15Z,1999-08-28T17:25Z,1999-08-28T17:32Z,1999-08-28T17:40Z,1999-08-28T17:45Z,1999-08-28T18:15Z,1999-08-28T18:25Z,1999-08-28T18:45Z,1999-08-28T18:55Z,1999-08-28T19:03Z,1999-08-28T19:10Z,1999-08-28T19:15Z,1999-08-28T19:25Z,1999-08-28T19:32Z,1999-08-28T19:40Z,1999-08-28T19:45Z,1999-08-28T19:55Z,1999-08-28T20:03Z,1999-08-28T20:15Z,1999-08-28T20:25Z,1999-08-28T20:33Z,1999-08-28T20:40Z,1999-08-28T20:45Z,1999-08-28T21:15Z,1999-08-28T21:25Z,1999-08-28T21:32Z,1999-08-28T21:40Z,1999-08-28T21:45Z,1999-08-28T21:55Z,1999-08-28T22:02Z,1999-08-28T22:10Z,1999-08-28T22:15Z,1999-08-28T22:25Z,1999-08-28T22:32Z,1999-08-28T22:40Z,1999-08-28T22:45Z,1999-08-28T22:55Z,1999-08-28T23:02Z,1999-08-28T23:10Z,1999-08-28T23:15Z,1999-08-28T23:25Z,1999-08-28T23:32Z,1999-08-28T23:40Z,1999-08-28T23:45Z,1999-08-29T00:15Z,1999-08-29T00:46Z,1999-08-29T00:55Z,1999-08-29T01:03Z,1999-08-29T01:10Z,1999-08-29T01:15Z,1999-08-29T01:25Z,1999-08-29T01:33Z,1999-08-29T01:40Z,1999-08-29T01:45Z,1999-08-29T01:55Z,1999-08-29T02:02Z,1999-08-29T02:10Z,1999-08-29T02:15Z,1999-08-29T02:25Z,1999-08-29T02:32Z,1999-08-29T02:40Z,1999-08-29T02:45Z,1999-08-29T03:15Z,1999-08-29T03:25Z,1999-08-29T03:32Z,1999-08-29T03:40Z,1999-08-29T03:45Z,1999-08-29T03:55Z,1999-08-29T04:02Z,1999-08-29T04:10Z,1999-08-29T05:33Z,1999-08-29T05:40Z,1999-08-29T06:15Z,1999-08-29T06:25Z,1999-08-29T06:45Z,1999-08-29T07:02Z,1999-08-29T07:15Z,1999-08-29T07:32Z,1999-08-29T07:45Z,1999-08-29T08:02Z,1999-08-29T08:15Z/1999-08-29T09:45Z/PT30M,1999-08-29T10:02Z,1999-08-29T10:15Z,1999-08-29T10:32Z,1999-08-29T10:45Z,1999-08-29T11:02Z,1999-08-29T11:15Z,1999-08-29T11:32Z,1999-08-29T11:46Z,1999-08-29T12:15Z,1999-08-29T12:45Z,1999-08-29T13:02Z,1999-08-29T13:15Z,1999-08-29T13:32Z,1999-08-29T13:45Z,1999-08-29T14:02Z,1999-08-29T14:15Z,1999-08-29T14:32Z,1999-08-29T14:45Z,1999-08-29T15:15Z,1999-08-29T15:32Z,1999-08-29T15:45Z,1999-08-29T16:02Z,1999-08-29T16:15Z,1999-08-29T16:32Z,1999-08-29T16:40Z,1999-08-29T16:45Z,1999-08-29T16:55Z,1999-08-29T17:02Z,1999-08-29T17:10Z,1999-08-29T17:15Z,1999-08-29T17:25Z,1999-08-29T17:32Z,1999-08-29T17:40Z,1999-08-29T17:45Z,1999-08-29T18:15Z,1999-08-29T18:25Z,1999-08-29T18:46Z,1999-08-29T18:55Z,1999-08-29T19:03Z,1999-08-29T19:10Z,1999-08-29T19:15Z,1999-08-29T19:25Z,1999-08-29T19:33Z,1999-08-29T19:40Z,1999-08-29T19:45Z,1999-08-29T19:55Z,1999-08-29T20:03Z,1999-08-29T20:10Z,1999-08-29T20:15Z,1999-08-29T20:25Z,1999-08-29T20:33Z,1999-08-29T20:40Z,1999-08-29T20:45Z,1999-08-29T21:15Z,1999-08-29T21:25Z,1999-08-29T21:32Z,1999-08-29T21:40Z,1999-08-29T21:45Z,1999-08-29T21:55Z,1999-08-29T22:02Z,1999-08-29T22:10Z,1999-08-29T22:15Z,1999-08-29T22:25Z,1999-08-29T22:32Z,1999-08-29T22:40Z,1999-08-29T22:45Z,1999-08-29T22:55Z,1999-08-29T23:02Z,1999-08-29T23:10Z,1999-08-29T23:15Z,1999-08-29T23:25Z,1999-08-29T23:32Z,1999-08-29T23:40Z,1999-08-29T23:45Z,1999-08-30T00:15Z,1999-08-30T00:46Z,1999-08-30T00:55Z,1999-08-30T01:02Z,1999-08-30T01:10Z,1999-08-30T01:15Z,1999-08-30T01:25Z,1999-08-30T01:32Z,1999-08-30T01:40Z,1999-08-30T01:45Z,1999-08-30T01:55Z,1999-08-30T02:02Z,1999-08-30T02:10Z,1999-08-30T02:15Z,1999-08-30T02:25Z,1999-08-30T02:32Z,1999-08-30T02:40Z,1999-08-30T02:45Z,1999-08-30T03:15Z,1999-08-30T03:25Z,1999-08-30T03:32Z,1999-08-30T03:40Z,1999-08-30T03:45Z,1999-08-30T03:55Z,1999-08-30T04:02Z,1999-08-30T04:10Z,1999-08-30T05:40Z,1999-08-30T06:15Z,1999-08-30T06:25Z,1999-08-30T06:45Z,1999-08-30T07:02Z,1999-08-30T07:15Z,1999-08-30T07:32Z,1999-08-30T07:45Z,1999-08-30T08:02Z,1999-08-30T08:15Z/1999-08-30T09:45Z/PT30M,1999-08-30T10:02Z,1999-08-30T10:15Z,1999-08-30T10:32Z,1999-08-30T10:45Z,1999-08-30T11:02Z,1999-08-30T11:15Z,1999-08-30T11:32Z,1999-08-30T11:45Z/1999-08-30T12:45Z/PT30M,1999-08-30T13:02Z,1999-08-30T13:15Z,1999-08-30T13:32Z,1999-08-30T13:45Z,1999-08-30T14:02Z,1999-08-30T14:15Z,1999-08-30T14:32Z,1999-08-30T14:45Z,1999-08-30T15:15Z,1999-08-30T15:32Z,1999-08-30T15:45Z,1999-08-30T16:02Z,1999-08-30T16:15Z,1999-08-30T16:32Z,1999-08-30T16:45Z,1999-08-30T17:02Z,1999-08-30T17:15Z,1999-08-30T17:32Z,1999-08-30T17:45Z,1999-08-30T18:15Z,1999-08-30T18:46Z,1999-08-30T18:55Z,1999-08-30T19:02Z,1999-08-30T19:10Z,1999-08-30T19:15Z,1999-08-30T19:25Z,1999-08-30T19:33Z,1999-08-30T19:40Z,1999-08-30T19:45Z,1999-08-30T19:55Z,1999-08-30T20:03Z,1999-08-30T20:10Z,1999-08-30T20:15Z,1999-08-30T20:25Z,1999-08-30T20:32Z,1999-08-30T20:40Z,1999-08-30T20:45Z,1999-08-30T21:15Z,1999-08-30T21:25Z,1999-08-30T21:32Z,1999-08-30T21:45Z,1999-08-30T21:55Z,1999-08-30T22:02Z,1999-08-30T22:10Z,1999-08-30T22:15Z,1999-08-30T22:25Z,1999-08-30T22:32Z,1999-08-30T22:40Z,1999-08-30T22:45Z,1999-08-30T22:55Z,1999-08-30T23:02Z,1999-08-30T23:10Z,1999-08-30T23:15Z,1999-08-30T23:25Z,1999-08-30T23:32Z,1999-08-30T23:40Z,1999-08-30T23:45Z/1999-08-31T00:45Z/PT30M,1999-08-31T00:55Z,1999-08-31T01:03Z,1999-08-31T01:10Z,1999-08-31T01:15Z,1999-08-31T01:25Z,1999-08-31T01:32Z,1999-08-31T01:40Z,1999-08-31T01:45Z,1999-08-31T01:55Z,1999-08-31T02:03Z,1999-08-31T02:10Z,1999-08-31T02:15Z,1999-08-31T02:25Z,1999-08-31T02:32Z,1999-08-31T02:40Z,1999-08-31T02:45Z,1999-08-31T03:15Z,1999-08-31T03:25Z,1999-08-31T03:32Z,1999-08-31T03:40Z,1999-08-31T03:45Z,1999-08-31T03:55Z,1999-08-31T04:02Z,1999-08-31T06:46Z,1999-08-31T07:02Z,1999-08-31T07:15Z,1999-08-31T07:32Z,1999-08-31T07:45Z,1999-08-31T08:02Z,1999-08-31T08:15Z/1999-08-31T09:45Z/PT30M,1999-08-31T10:02Z,1999-08-31T10:15Z,1999-08-31T10:32Z,1999-08-31T10:45Z,1999-08-31T11:02Z,1999-08-31T11:15Z,1999-08-31T11:32Z,1999-08-31T11:45Z/1999-08-31T12:45Z/PT30M,1999-08-31T13:02Z,1999-08-31T13:15Z,1999-08-31T13:32Z,1999-08-31T13:45Z,1999-08-31T14:02Z,1999-08-31T14:15Z,1999-08-31T14:32Z,1999-08-31T14:45Z
1999-06-10/1999-07-20/P10D,1999-07-31/1999-08-20/P10D,1999-08-31/1999-09-30/P10D,2000-06-10/2000-07-20/P10D,2000-07-31/2000-08-20/P10D,2000-08-31/2000-09-30/P10D,2001-06-10/2001-07-20/P10D,2001-07-31/2001-08-20/P10D,2001-08-31/2001-09-30/P10D,2002-06-10/2002-07-20/P10D,2002-07-31/2002-08-20/P10D,2002-08-31/2002-09-30/P10D,2003-06-10/2003-07-20/P10D,2003-07-31/2003-08-20/P10D,2003-08-31/2003-09-30/P10D
1997-08-13/1997-12-27/P8D,1998-01-01/1998-12-27/P8D,1999-01-01/1999-12-27/P8D,2000-01-01/2000-12-26/P8D,2001-01-01/2001-12-27/P8D,2002-01-01/2002-12-27/P8D,2003-01-01/2003-07-20/P8D
1997-01-07/1997-01-21/P7D,1997-01-31/1997-03-21/P7D,1997-03-31/1997-04-21/P7D,1997-04-30/1997-05-21/P7D,1997-05-31/1997-06-21/P7D,1997-06-30/1997-07-21/P7D,1997-07-31/1997-08-21/P7D,1997-08-31/1997-09-21/P7D,1997-09-30/1997-10-21/P7D,1997-10-31/1997-11-21/P7D,1997-11-30/1997-12-21/P7D,1997-12-31/1998-01-21/P7D,1998-01-31/1998-03-21/P7D,1998-03-31/1998-04-21/P7D,1998-04-30/1998-05-21/P7D,1998-05-31/1998-06-21/P7D,1998-06-30/1998-07-21/P7D,1998-07-31/1998-08-21/P7D,1998-08-31/1998-09-21/P7D,1998-09-30/1998-10-21/P7D,1998-10-31/1998-11-21/P7D,1998-11-30/1998-12-21/P7D,1998-12-31/1999-01-21/P7D,1999-01-31/1999-03-21/P7D,1999-03-31/1999-04-21/P7D,1999-04-30/1999-05-21/P7D,1999-05-31/1999-06-21/P7D,1999-06-30/1999-07-21/P7D,1999-07-31/1999-08-21/P7D,1999-08-31/1999-09-21/P7D,1999-09-30/1999-10-21/P7D,1999-10-31/1999-11-21/P7D,1999-11-30/1999-12-21/P7D,1999-12-31
2003-06-20T02:44Z/2003-06-22T00:56Z/PT1H39M
2001-03-17,2001-05-04,2001-05-20,2001-07-07,2002-03-04,2002-03-29,2002-04-28/2002-06-17/P25D,2002-07-01,2002-09-03,2003-03-23,2003-05-19
2003-06-20T02:44Z/2003-06-22T00:56Z/PT1H39M
2001-10-16/2001-12-27/P8D,2002-01-01/2002-04-23/P8D
2005-08-22T24Z,2005-08-23T05Z,2005-08-23T23Z,2005-08-24T06Z,2005-08-24T22Z,2005-08-25T05Z,2005-08-25T23Z,2005-08-26T04Z,2005-08-26T22Z,2005-08-27T04Z,2005-08-27T21Z,2005-08-28T04Z,2005-08-28T22Z,2005-08-29T03Z,2005-08-29T22Z,2005-08-30T02Z,2005-08-30T22Z
2005-08-22T24Z,2005-08-23T05Z,2005-08-23T23Z,2005-08-24T06Z,2005-08-24T22Z,2005-08-25T05Z,2005-08-25T23Z,2005-08-26T04Z,2005-08-26T22Z,2005-08-27T04Z,2005-08-27T21Z,2005-08-28T04Z,2005-08-28T22Z,2005-08-29T03Z,2005-08-29T22Z,2005-08-30T02Z,2005-08-30T22Z
2005-08-23T21:00Z/2005-08-24T06:00Z/PT3H,2005-08-24T12:00Z/2005-08-25T06:00Z/PT3H,2005-08-25T12:00Z/2005-08-26T06:00Z/PT3H,2005-08-26T12:00Z/2005-08-27T06:00Z/PT3H,2005-08-27T12:00Z/2005-08-28T06:00Z/PT3H,2005-08-28T12:00Z/2005-08-29T06:00Z/PT3H,2005-08-29T12:00Z/2005-08-30T06:00Z/PT3H,2005-08-30T12:00Z/2005-08-31T06:00Z/PT3H
2005-08-23T08:45Z/2005-08-24T02:45Z/PT3H,2005-08-24T08:45Z/2005-08-25T02:45Z/PT3H,2005-08-25T08:45Z/2005-08-26T02:45Z/PT3H,2005-08-26T08:45Z/2005-08-27T02:45Z/PT3H,2005-08-27T08:45Z/2005-08-28T02:45Z/PT3H,2005-08-28T08:45Z/2005-08-29T02:45Z/PT3H,2005-08-29T08:45Z/2005-08-30T02:45Z/PT3H,2005-08-30T08:45Z/2005-08-31T02:45Z/PT3H
2005-08-23T08:45Z/2005-08-24T02:45Z/PT3H,2005-08-24T08:45Z/2005-08-25T02:45Z/PT3H,2005-08-25T08:45Z/2005-08-26T02:45Z/PT3H,2005-08-26T08:45Z/2005-08-27T02:45Z/PT3H,2005-08-27T08:45Z/2005-08-28T02:45Z/PT3H,2005-08-28T08:45Z/2005-08-29T02:45Z/PT3H,2005-08-29T08:45Z/2005-08-30T02:45Z/PT3H,2005-08-30T08:45Z/2005-08-31T02:45Z/PT3H
2005-08-23T08:45Z/2005-08-24T02:45Z/PT3H,2005-08-24T08:45Z/2005-08-25T02:45Z/PT3H,2005-08-25T08:45Z/2005-08-26T02:45Z/PT3H,2005-08-26T08:45Z/2005-08-27T02:45Z/PT3H,2005-08-27T08:45Z/2005-08-28T02:45Z/PT3H,2005-08-28T08:45Z/2005-08-29T02:45Z/PT3H,2005-08-29T08:45Z/2005-08-30T02:45Z/PT3H,2005-08-30T08:45Z/2005-08-31T02:45Z/PT3H
2005-08-23T08:45Z/2005-08-24T02:45Z/PT3H,2005-08-24T08:45Z/2005-08-25T02:45Z/PT3H,2005-08-25T08:45Z/2005-08-26T02:45Z/PT3H,2005-08-26T08:45Z/2005-08-27T02:45Z/PT3H,2005-08-27T08:45Z/2005-08-28T02:45Z/PT3H,2005-08-28T08:45Z/2005-08-29T02:45Z/PT3H,2005-08-29T08:45Z/2005-08-30T02:45Z/PT3H,2005-08-30T08:45Z/2005-08-31T02:45Z/PT3H
2005-08-23T08:45Z/2005-08-24T02:45Z/PT3H,2005-08-24T08:45Z/2005-08-25T02:45Z/PT3H,2005-08-25T08:45Z/2005-08-26T02:45Z/PT3H,2005-08-26T08:45Z/2005-08-27T02:45Z/PT3H,2005-08-27T08:45Z/2005-08-28T02:45Z/PT3H,2005-08-28T08:45Z/2005-08-29T02:45Z/PT3H,2005-08-29T08:45Z/2005-08-30T02:45Z/PT3H,2005-08-30T08:45Z/2005-08-31T02:45Z/PT3H
2005-08-26T23:45Z/2005-08-27T00:45Z/PT30M,2005-08-27T00:55Z,2005-08-27T01:02Z,2005-08-27T01:10Z,2005-08-27T01:15Z,2005-08-27T01:25Z,2005-08-27T01:32Z,2005-08-27T01:40Z,2005-08-27T01:45Z,2005-08-27T01:55Z,2005-08-27T02:02Z,2005-08-27T02:10Z,2005-08-27T02:15Z,2005-08-27T02:25Z,2005-08-27T02:32Z,2005-08-27T02:40Z,2005-08-27T02:45Z,2005-08-27T03:15Z,2005-08-27T03:25Z,2005-08-27T03:33Z,2005-08-27T03:40Z,2005-08-27T03:45Z,2005-08-27T04:02Z,2005-08-27T06:15Z,2005-08-27T06:32Z,2005-08-27T06:45Z,2005-08-27T06:55Z,2005-08-27T07:02Z,2005-08-27T07:10Z,2005-08-27T07:15Z,2005-08-27T07:25Z,2005-08-27T07:33Z,2005-08-27T07:40Z,2005-08-27T07:45Z,2005-08-27T07:55Z,2005-08-27T08:03Z,2005-08-27T08:10Z,2005-08-27T08:15Z,2005-08-27T08:25Z,2005-08-27T08:33Z,2005-08-27T08:40Z,2005-08-27T08:45Z,2005-08-27T09:15Z,2005-08-27T09:25Z,2005-08-27T09:32Z,2005-08-27T09:40Z,2005-08-27T09:45Z,2005-08-27T09:55Z,2005-08-27T10:02Z,2005-08-27T10:10Z,2005-08-27T10:15Z,2005-08-27T10:25Z,2005-08-27T10:33Z,2005-08-27T10:40Z,2005-08-27T10:45Z,2005-08-27T10:55Z,2005-08-27T11:02Z,2005-08-27T11:10Z,2005-08-27T11:15Z,2005-08-27T11:25Z,2005-08-27T11:33Z,2005-08-27T11:40Z,2005-08-27T11:45Z,2005-08-27T12:15Z,2005-08-27T12:25Z,2005-08-27T12:45Z,2005-08-27T12:55Z,2005-08-27T13:03Z,2005-08-27T13:10Z,2005-08-27T13:15Z,2005-08-27T13:25Z,2005-08-27T13:33Z,2005-08-27T13:40Z,2005-08-27T13:45Z,2005-08-27T13:55Z,2005-08-27T14:03Z,2005-08-27T14:10Z,2005-08-27T14:15Z,2005-08-27T14:25Z,2005-08-27T14:32Z,2005-08-27T14:40Z,2005-08-27T14:45Z,2005-08-27T15:15Z,2005-08-27T15:25Z,2005-08-27T15:32Z,2005-08-27T15:40Z,2005-08-27T15:45Z,2005-08-27T15:55Z,2005-08-27T16:02Z,2005-08-27T16:10Z,2005-08-27T16:15Z,2005-08-27T16:25Z,2005-08-27T16:32Z,2005-08-27T16:40Z,2005-08-27T16:45Z,2005-08-27T16:55Z,2005-08-27T17:03Z,2005-08-27T17:10Z,2005-08-27T17:15Z,2005-08-27T17:25Z,2005-08-27T17:33Z,2005-08-27T17:40Z,2005-08-27T17:45Z,2005-08-27T18:15Z,2005-08-27T18:25Z,2005-08-27T18:45Z,2005-08-27T18:55Z,2005-08-27T19:03Z,2005-08-27T19:10Z,2005-08-27T19:15Z,2005-08-27T19:25Z,2005-08-27T19:33Z,2005-08-27T19:40Z,2005-08-27T19:45Z,2005-08-27T19:55Z,2005-08-27T20:03Z,2005-08-27T20:10Z,2005-08-27T20:15Z,2005-08-27T20:25Z,2005-08-27T20:32Z,2005-08-27T20:40Z,2005-08-27T20:45Z,2005-08-27T21:15Z,2005-08-27T21:25Z,2005-08-27T21:32Z,2005-08-27T21:40Z,2005-08-27T21:45Z,2005-08-27T21:55Z,2005-08-27T22:03Z,2005-08-27T22:10Z,2005-08-27T22:15Z,2005-08-27T22:25Z,2005-08-27T22:33Z,2005-08-27T22:40Z,2005-08-27T22:45Z,2005-08-27T22:55Z,2005-08-27T23:03Z,2005-08-27T23:10Z,2005-08-27T23:15Z,2005-08-27T23:25Z,2005-08-27T23:33Z,2005-08-27T23:40Z,2005-08-27T23:45Z/2005-08-28T00:45Z/PT30M,2005-08-28T00:55Z,2005-08-28T01:02Z,2005-08-28T01:10Z,2005-08-28T01:15Z,2005-08-28T01:25Z,2005-08-28T01:32Z,2005-08-28T01:40Z,2005-08-28T01:45Z,2005-08-28T01:55Z,2005-08-28T02:02Z,2005-08-28T02:10Z,2005-08-28T02:15Z,2005-08-28T02:25Z,2005-08-28T02:32Z,2005-08-28T02:40Z,2005-08-28T02:45Z,2005-08-28T03:15Z,2005-08-28T03:25Z,2005-08-28T03:33Z,2005-08-28T03:40Z,2005-08-28T03:45Z,2005-08-28T04:02Z,2005-08-28T06:15Z,2005-08-28T06:32Z,2005-08-28T06:45Z,2005-08-28T06:55Z,2005-08-28T07:02Z,2005-08-28T07:10Z,2005-08-28T07:15Z,2005-08-28T07:25Z,2005-08-28T07:33Z,2005-08-28T07:40Z,2005-08-28T07:45Z,2005-08-28T07:55Z,2005-08-28T08:03Z,2005-08-28T08:10Z,2005-08-28T08:15Z,2005-08-28T08:25Z,2005-08-28T08:33Z,2005-08-28T08:40Z,2005-08-28T08:45Z,2005-08-28T09:15Z,2005-08-28T09:25Z,2005-08-28T09:33Z,2005-08-28T09:40Z,2005-08-28T09:45Z,2005-08-28T09:55Z,2005-08-28T10:03Z,2005-08-28T10:10Z,2005-08-28T10:15Z,2005-08-28T10:25Z,2005-08-28T10:32Z,2005-08-28T10:40Z,2005-08-28T10:45Z,2005-08-28T10:55Z,2005-08-28T11:02Z,2005-08-28T11:10Z,2005-08-28T11:15Z,2005-08-28T11:25Z,2005-08-28T11:32Z,2005-08-28T11:40Z,2005-08-28T11:45Z,2005-08-28T12:15Z,2005-08-28T12:25Z,2005-08-28T12:45Z,2005-08-28T12:55Z,2005-08-28T13:03Z,2005-08-28T13:10Z,2005-08-28T13:15Z,2005-08-28T13:25Z,2005-08-28T13:33Z,2005-08-28T13:40Z,2005-08-28T13:45Z,2005-08-28T13:55Z,2005-08-28T14:03Z,2005-08-28T14:10Z,2005-08-28T14:15Z,2005-08-28T14:25Z,2005-08-28T14:33Z,2005-08-28T14:40Z,2005-08-28T14:45Z,2005-08-28T15:15Z,2005-08-28T15:25Z,2005-08-28T15:32Z,2005-08-28T15:40Z,2005-08-28T15:45Z,2005-08-28T15:55Z,2005-08-28T16:02Z,2005-08-28T16:10Z,2005-08-28T16:15Z,2005-08-28T16:25Z,2005-08-28T16:32Z,2005-08-28T16:40Z,2005-08-28T16:45Z,2005-08-28T16:55Z,2005-08-28T17:03Z,2005-08-28T17:10Z,2005-08-28T17:15Z,2005-08-28T17:25Z,2005-08-28T17:33Z,2005-08-28T17:40Z,2005-08-28T17:45Z,2005-08-28T18:15Z,2005-08-28T18:25Z,2005-08-28T18:45Z,2005-08-28T18:55Z,2005-08-28T19:03Z,2005-08-28T19:10Z,2005-08-28T19:15Z,2005-08-28T19:25Z,2005-08-28T19:32Z,2005-08-28T19:40Z,2005-08-28T19:45Z,2005-08-28T19:55Z,2005-08-28T20:02Z,2005-08-28T20:10Z,2005-08-28T20:15Z,2005-08-28T20:25Z,2005-08-28T20:32Z,2005-08-28T20:40Z,2005-08-28T20:45Z,2005-08-28T21:15Z,2005-08-28T21:25Z,2005-08-28T21:32Z,2005-08-28T21:40Z,2005-08-28T21:45Z,2005-08-28T21:55Z,2005-08-28T22:03Z,2005-08-28T22:10Z,2005-08-28T22:15Z,2005-08-28T22:25Z,2005-08-28T22:33Z,2005-08-28T22:40Z,2005-08-28T22:45Z,2005-08-28T22:55Z,2005-08-28T23:03Z,2005-08-28T23:10Z,2005-08-28T23:15Z,2005-08-28T23:25Z,2005-08-28T23:33Z,2005-08-28T23:40Z,2005-08-28T23:45Z/2005-08-29T00:45Z/PT30M,2005-08-29T00:55Z,2005-08-29T01:02Z,2005-08-29T01:10Z,2005-08-29T01:15Z,2005-08-29T01:25Z,2005-08-29T01:32Z,2005-08-29T01:40Z,2005-08-29T01:45Z,2005-08-29T01:55Z,2005-08-29T02:02Z,2005-08-29T02:10Z,2005-08-29T02:15Z,2005-08-29T02:25Z,2005-08-29T02:32Z,2005-08-29T02:40Z,2005-08-29T02:45Z,2005-08-29T03:15Z,2005-08-29T03:25Z,2005-08-29T03:33Z,2005-08-29T03:40Z,2005-08-29T03:45Z,2005-08-29T04:02Z,2005-08-29T06:15Z,2005-08-29T06:32Z,2005-08-29T06:45Z,2005-08-29T06:55Z,2005-08-29T07:02Z,2005-08-29T07:10Z,2005-08-29T07:15Z,2005-08-29T07:25Z,2005-08-29T07:32Z,2005-08-29T07:40Z,2005-08-29T07:45Z,2005-08-29T07:55Z,2005-08-29T08:03Z,2005-08-29T08:10Z,2005-08-29T08:15Z,2005-08-29T08:25Z,2005-08-29T08:33Z,2005-08-29T08:40Z,2005-08-29T08:45Z,2005-08-29T09:15Z,2005-08-29T09:25Z,2005-08-29T09:33Z,2005-08-29T09:40Z,2005-08-29T09:45Z,2005-08-29T09:55Z,2005-08-29T10:03Z,2005-08-29T10:10Z,2005-08-29T10:15Z,2005-08-29T10:25Z,2005-08-29T10:33Z,2005-08-29T10:40Z,2005-08-29T10:45Z,2005-08-29T10:55Z,2005-08-29T11:02Z,2005-08-29T11:10Z,2005-08-29T11:15Z,2005-08-29T11:25Z,2005-08-29T11:32Z,2005-08-29T11:40Z,2005-08-29T11:45Z,2005-08-29T12:15Z,2005-08-29T12:25Z,2005-08-29T12:45Z,2005-08-29T12:55Z,2005-08-29T13:03Z,2005-08-29T13:10Z,2005-08-29T13:15Z,2005-08-29T13:25Z,2005-08-29T13:33Z,2005-08-29T13:40Z,2005-08-29T13:45Z,2005-08-29T13:55Z,2005-08-29T14:03Z,2005-08-29T14:10Z,2005-08-29T14:15Z,2005-08-29T14:25Z,2005-08-29T14:33Z,2005-08-29T14:40Z,2005-08-29T14:45Z,2005-08-29T15:15Z,2005-08-29T15:25Z,2005-08-29T15:32Z,2005-08-29T15:40Z,2005-08-29T15:45Z,2005-08-29T15:55Z,2005-08-29T16:02Z,2005-08-29T16:10Z,2005-08-29T16:15Z,2005-08-29T16:25Z,2005-08-29T16:32Z,2005-08-29T16:40Z,2005-08-29T16:45Z,2005-08-29T16:55Z,2005-08-29T17:02Z,2005-08-29T17:10Z,2005-08-29T17:15Z,2005-08-29T17:25Z,2005-08-29T17:33Z,2005-08-29T17:40Z,2005-08-29T17:45Z,2005-08-29T18:15Z,2005-08-29T18:25Z,2005-08-29T18:45Z,2005-08-29T18:55Z,2005-08-29T19:02Z,2005-08-29T19:10Z,2005-08-29T19:15Z,2005-08-29T19:25Z,2005-08-29T19:33Z,2005-08-29T19:40Z,2005-08-29T19:45Z,2005-08-29T19:55Z,2005-08-29T20:03Z,2005-08-29T20:10Z,2005-08-29T20:15Z,2005-08-29T20:25Z,2005-08-29T20:32Z,2005-08-29T20:40Z,2005-08-29T20:45Z,2005-08-29T21:15Z,2005-08-29T21:25Z,2005-08-29T21:32Z,2005-08-29T21:40Z,2005-08-29T21:45Z,2005-08-29T21:55Z,2005-08-29T22:03Z,2005-08-29T22:10Z,2005-08-29T22:15Z,2005-08-29T22:25Z,2005-08-29T22:33Z,2005-08-29T22:40Z,2005-08-29T22:45Z,2005-08-29T22:55Z,2005-08-29T23:03Z,2005-08-29T23:10Z,2005-08-29T23:15Z,2005-08-29T23:25Z,2005-08-29T23:33Z,2005-08-29T23:40Z,2005-08-29T23:45Z/2005-08-30T00:45Z/PT30M,2005-08-30T00:55Z,2005-08-30T01:03Z,2005-08-30T01:10Z,2005-08-30T01:15Z,2005-08-30T01:25Z,2005-08-30T01:33Z,2005-08-30T01:40Z,2005-08-30T01:45Z,2005-08-30T01:55Z,2005-08-30T02:02Z,2005-08-30T02:10Z,2005-08-30T02:15Z,2005-08-30T02:25Z,2005-08-30T02:32Z,2005-08-30T02:40Z,2005-08-30T02:45Z,2005-08-30T03:15Z,2005-08-30T03:25Z,2005-08-30T03:32Z,2005-08-30T03:45Z,2005-08-30T04:02Z,2005-08-30T06:15Z,2005-08-30T06:32Z,2005-08-30T06:45Z,2005-08-30T07:02Z,2005-08-30T07:15Z,2005-08-30T07:32Z,2005-08-30T07:45Z,2005-08-30T08:02Z,2005-08-30T08:15Z/2005-08-30T10:15Z/PT30M,2005-08-30T10:32Z,2005-08-30T10:45Z,2005-08-30T11:02Z,2005-08-30T11:15Z,2005-08-30T11:32Z,2005-08-30T11:45Z/2005-08-30T12:45Z/PT30M,2005-08-30T13:02Z,2005-08-30T13:15Z,2005-08-30T13:32Z,2005-08-30T13:45Z,2005-08-30T14:02Z,2005-08-30T14:15Z,2005-08-30T14:32Z,2005-08-30T14:45Z,2005-08-30T15:15Z,2005-08-30T15:32Z,2005-08-30T15:45Z,2005-08-30T16:02Z,2005-08-30T16:15Z,2005-08-30T16:33Z,2005-08-30T16:40Z,2005-08-30T16:45Z,2005-08-30T16:55Z,2005-08-30T17:02Z,2005-08-30T17:10Z,2005-08-30T17:15Z,2005-08-30T17:25Z,2005-08-30T17:33Z,2005-08-30T17:40Z,2005-08-30T17:45Z,2005-08-30T18:15Z,2005-08-30T18:25Z,2005-08-30T18:45Z,2005-08-30T18:55Z,2005-08-30T19:02Z,2005-08-30T19:10Z,2005-08-30T19:15Z,2005-08-30T19:25Z,2005-08-30T19:32Z,2005-08-30T19:40Z,2005-08-30T19:45Z,2005-08-30T19:55Z,2005-08-30T20:03Z,2005-08-30T20:10Z,2005-08-30T20:15Z,2005-08-30T20:25Z,2005-08-30T20:33Z,2005-08-30T20:40Z,2005-08-30T20:45Z,2005-08-30T21:15Z,2005-08-30T21:25Z,2005-08-30T21:33Z,2005-08-30T21:40Z,2005-08-30T21:45Z,2005-08-30T21:55Z,2005-08-30T22:03Z,2005-08-30T22:10Z,2005-08-30T22:15Z,2005-08-30T22:25Z,2005-08-30T22:33Z,2005-08-30T22:40Z,2005-08-30T22:45Z,2005-08-30T22:55Z,2005-08-30T23:02Z,2005-08-30T23:10Z,2005-08-30T23:15Z,2005-08-30T23:25Z,2005-08-30T23:32Z,2005-08-30T23:40Z,2005-08-30T23:45Z
2004-09-01T03Z/2004-09-06T00Z/PT3H
2004-09-01T03Z/2004-09-06T00Z/PT3H
2004-09-01T03Z/2004-09-06T00Z/PT3H
2004-09-01T03Z/2004-09-06T00Z/PT3H
2004-09-01T03Z/2004-09-06T00Z/PT3H
2004-09-01T03Z/2004-09-06T00Z/PT3H
2004-09-01T03Z/2004-09-06T00Z/PT3H
2004-09-01T03Z/2004-09-06T00Z/PT3H
2004-09-01T03Z/2004-09-06T00Z/PT3H
2004-09-01T03Z/2004-09-06T00Z/PT3H
2004-09-01T03Z/2004-09-06T00Z/PT3H
1990-/2000-/P5Y,2015-
-
1995-09-06T10:23Z/1995-09-06T10:29Z/PT1M,1995-09-06T10:32Z/1995-09-06T10:35Z/PT1M,1995-09-06T10:39Z,1995-09-06T10:41Z/1995-09-06T10:43Z/PT1M,1995-09-06T10:45Z/1995-09-06T10:49Z/PT1M,1995-09-06T10:51Z/1995-09-06T10:59Z/PT1M,1995-09-06T11:02Z/1995-09-06T11:05Z/PT1M,1995-09-06T11:09Z,1995-09-06T11:11Z/1995-09-06T11:13Z/PT1M,1995-09-06T11:15Z/1995-09-06T11:19Z/PT1M,1995-09-06T11:21Z/1995-09-06T11:29Z/PT1M,1995-09-06T11:32Z/1995-09-06T11:35Z/PT1M,1995-09-06T11:39Z,1995-09-06T11:41Z/1995-09-06T11:43Z/PT1M,1995-09-06T11:45Z/1995-09-06T11:51Z/PT1M,1995-09-06T11:53Z/1995-09-06T12:10Z/PT1M,1995-09-06T12:13Z,1995-09-06T12:15Z/1995-09-06T12:19Z/PT1M,1995-09-06T12:21Z,1995-09-06T12:23Z/1995-09-06T12:29Z/PT1M,1995-09-06T12:45Z/1995-09-06T12:51Z/PT1M,1995-09-06T12:53Z/1995-09-06T12:59Z/PT1M,1995-09-06T13:02Z/1995-09-06T13:05Z/PT1M,1995-09-06T13:09Z,1995-09-06T13:10Z,1995-09-06T13:12Z,1995-09-06T13:13Z,1995-09-06T13:15Z/1995-09-06T13:20Z/PT1M,1995-09-06T13:22Z/1995-09-06T13:29Z/PT1M,1995-09-06T13:32Z/1995-09-06T13:35Z/PT1M,1995-09-06T13:39Z,1995-09-06T13:40Z,1995-09-06T13:42Z,1995-09-06T13:43Z,1995-09-06T13:45Z/1995-09-06T13:50Z/PT1M,1995-09-06T13:52Z/1995-09-06T13:59Z/PT1M,1995-09-06T14:02Z/1995-09-06T14:05Z/PT1M,1995-09-06T14:09Z,1995-09-06T14:10Z,1995-09-06T14:12Z,1995-09-06T14:13Z,1995-09-06T14:15Z/1995-09-06T14:20Z/PT1M,1995-09-06T14:22Z/1995-09-06T14:29Z/PT1M,1995-09-06T14:32Z/1995-09-06T14:35Z/PT1M,1995-09-06T14:39Z,1995-09-06T14:41Z/1995-09-06T14:43Z/PT1M,1995-09-06T14:45Z/1995-09-06T14:51Z/PT1M,1995-09-06T14:53Z/1995-09-06T14:58Z/PT1M
1999-08-26T14:15Z/1999-08-26T14:45Z/PT15M,1999-08-26T15:15Z/1999-08-26T15:45Z/PT15M,1999-08-26T15:59Z,1999-08-26T16:15Z/1999-08-26T16:45Z/PT15M,1999-08-26T16:59Z,1999-08-26T17:15Z,1999-08-26T17:32Z,1999-08-26T17:40Z,1999-08-26T17:45Z,1999-08-26T18:15Z,1999-08-26T18:25Z,1999-08-26T18:46Z,1999-08-26T18:55Z,1999-08-26T19:03Z,1999-08-26T19:10Z,1999-08-26T19:15Z,1999-08-26T19:25Z,1999-08-26T19:32Z,1999-08-26T19:40Z,1999-08-26T19:45Z,1999-08-26T19:55Z,1999-08-26T20:02Z,1999-08-26T20:10Z,1999-08-26T20:15Z,1999-08-26T20:25Z,1999-08-26T20:32Z,1999-08-26T20:40Z,1999-08-26T20:45Z,1999-08-26T21:15Z,1999-08-26T21:25Z,1999-08-26T21:32Z,1999-08-26T21:40Z,1999-08-26T21:45Z,1999-08-26T21:55Z,1999-08-26T22:02Z,1999-08-26T22:10Z,1999-08-26T22:15Z,1999-08-26T22:25Z,1999-08-26T22:32Z,1999-08-26T22:40Z,1999-08-26T22:45Z,1999-08-26T22:55Z,1999-08-26T23:03Z,1999-08-26T23:10Z,1999-08-26T23:15Z,1999-08-26T23:25Z,1999-08-26T23:32Z,1999-08-26T23:40Z,1999-08-26T23:45Z/1999-08-27T00:45Z/PT30M,1999-08-27T00:55Z,1999-08-27T01:03Z,1999-08-27T01:10Z,1999-08-27T01:15Z,1999-08-27T01:25Z,1999-08-27T01:32Z,1999-08-27T01:45Z,1999-08-27T02:02Z,1999-08-27T02:15Z,1999-08-27T02:32Z,1999-08-27T02:45Z,1999-08-27T03:15Z,1999-08-27T03:32Z,1999-08-27T03:45Z,1999-08-27T04:02Z,1999-08-27T04:15Z,1999-08-27T06:15Z,1999-08-27T06:46Z,1999-08-27T07:02Z,1999-08-27T07:15Z,1999-08-27T07:32Z,1999-08-27T07:45Z,1999-08-27T08:02Z,1999-08-27T08:15Z/1999-08-27T09:45Z/PT30M,1999-08-27T10:02Z,1999-08-27T10:15Z,1999-08-27T10:32Z,1999-08-27T10:45Z,1999-08-27T11:02Z,1999-08-27T11:15Z,1999-08-27T11:32Z,1999-08-27T11:45Z/1999-08-27T12:45Z/PT30M,1999-08-27T13:02Z,1999-08-27T13:15Z,1999-08-27T13:33Z,1999-08-27T13:40Z,1999-08-27T13:45Z,1999-08-27T13:55Z,1999-08-27T14:03Z,1999-08-27T14:10Z,1999-08-27T14:15Z,1999-08-27T14:25Z,1999-08-27T14:33Z,1999-08-27T14:40Z,1999-08-27T14:45Z,1999-08-27T15:15Z,1999-08-27T15:25Z,1999-08-27T15:33Z,1999-08-27T15:40Z,1999-08-27T15:45Z,1999-08-27T15:55Z,1999-08-27T16:02Z,1999-08-27T16:10Z,1999-08-27T16:15Z,1999-08-27T16:25Z,1999-08-27T16:32Z,1999-08-27T16:40Z,1999-08-27T16:45Z,1999-08-27T16:55Z,1999-08-27T17:02Z,1999-08-27T17:10Z,1999-08-27T17:15Z,1999-08-27T17:25Z,1999-08-27T17:32Z,1999-08-27T17:40Z,1999-08-27T17:45Z,1999-08-27T18:15Z,1999-08-27T18:25Z,1999-08-27T18:46Z,1999-08-27T18:55Z,1999-08-27T19:03Z,1999-08-27T19:15Z,1999-08-27T19:25Z,1999-08-27T19:33Z,1999-08-27T19:40Z,1999-08-27T19:45Z,1999-08-27T19:55Z,1999-08-27T20:03Z,1999-08-27T20:10Z,1999-08-27T20:15Z,1999-08-27T20:25Z,1999-08-27T20:33Z,1999-08-27T20:40Z,1999-08-27T20:45Z,1999-08-27T21:15Z,1999-08-27T21:25Z,1999-08-27T21:32Z,1999-08-27T21:45Z,1999-08-27T22:02Z,1999-08-27T22:15Z,1999-08-27T22:32Z,1999-08-27T22:45Z,1999-08-27T23:02Z,1999-08-27T23:15Z,1999-08-27T23:32Z,1999-08-27T23:45Z,1999-08-28T00:15Z,1999-08-28T00:46Z,1999-08-28T00:55Z,1999-08-28T01:03Z,1999-08-28T01:10Z,1999-08-28T01:15Z,1999-08-28T01:25Z,1999-08-28T01:32Z,1999-08-28T01:40Z,1999-08-28T01:45Z,1999-08-28T01:55Z,1999-08-28T02:02Z,1999-08-28T02:10Z,1999-08-28T02:15Z,1999-08-28T02:25Z,1999-08-28T02:32Z,1999-08-28T02:40Z,1999-08-28T02:45Z,1999-08-28T03:15Z,1999-08-28T03:25Z,1999-08-28T03:32Z,1999-08-28T03:40Z,1999-08-28T03:45Z,1999-08-28T03:55Z,1999-08-28T04:03Z,1999-08-28T04:10Z,1999-08-28T05:33Z,1999-08-28T05:40Z,1999-08-28T06:15Z,1999-08-28T06:25Z,1999-08-28T06:45Z,1999-08-28T06:55Z,1999-08-28T07:02Z,1999-08-28T07:15Z,1999-08-28T07:25Z,1999-08-28T07:32Z,1999-08-28T07:40Z,1999-08-28T07:45Z,1999-08-28T07:55Z,1999-08-28T08:02Z,1999-08-28T08:10Z,1999-08-28T08:15Z,1999-08-28T08:25Z,1999-08-28T08:32Z,1999-08-28T08:40Z,1999-08-28T08:45Z,1999-08-28T09:15Z,1999-08-28T09:25Z,1999-08-28T09:45Z,1999-08-28T10:02Z,1999-08-28T10:15Z,1999-08-28T10:32Z,1999-08-28T10:45Z,1999-08-28T11:02Z,1999-08-28T11:15Z,1999-08-28T11:32Z,1999-08-28T11:45Z/1999-08-28T12:45Z/PT30M,1999-08-28T12:55Z,1999-08-28T13:02Z,1999-08-28T13:10Z,1999-08-28T13:15Z,1999-08-28T13:25Z,1999-08-28T13:33Z,1999-08-28T13:40Z,1999-08-28T13:45Z,1999-08-28T13:55Z,1999-08-28T14:03Z,1999-08-28T14:10Z,1999-08-28T14:15Z,1999-08-28T14:25Z,1999-08-28T14:33Z,1999-08-28T14:40Z,1999-08-28T14:45Z,1999-08-28T15:15Z,1999-08-28T15:25Z,1999-08-28T15:32Z,1999-08-28T15:40Z,1999-08-28T15:45Z,1999-08-28T15:55Z,1999-08-28T16:02Z,1999-08-28T16:10Z,1999-08-28T16:15Z,1999-08-28T16:25Z,1999-08-28T16:32Z,1999-08-28T16:40Z,1999-08-28T16:45Z,1999-08-28T16:55Z,1999-08-28T17:02Z,1999-08-28T17:10Z,1999-08-28T17:15Z,1999-08-28T17:25Z,1999-08-28T17:32Z,1999-08-28T17:40Z,1999-08-28T17:45Z,1999-08-28T18:15Z,1999-08-28T18:25Z,1999-08-28T18:45Z,1999-08-28T18:55Z,1999-08-28T19:03Z,1999-08-28T19:10Z,1999-08-28T19:15Z,1999-08-28T19:25Z,1999-08-28T19:32Z,1999-08-28T19:40Z,1999-08-28T19:45Z,1999-08-28T19:55Z,1999-08-28T20:03Z,1999-08-28T20:15Z,1999-08-28T20:25Z,1999-08-28T20:33Z,1999-08-28T20:40Z,1999-08-28T20:45Z,1999-08-28T21:15Z,1999-08-28T21:25Z,1999-08-28T21:32Z,1999-08-28T21:40Z,1999-08-28T21:45Z,1999-08-28T21:55Z,1999-08-28T22:02Z,1999-08-28T22:10Z,1999-08-28T22:15Z,1999-08-28T22:25Z,1999-08-28T22:32Z,1999-08-28T22:40Z,1999-08-28T22:45Z,1999-08-28T22:55Z,1999-08-28T23:02Z,1999-08-28T23:10Z,1999-08-28T23:15Z,1999-08-28T23:25Z,1999-08-28T23:32Z,1999-08-28T23:40Z,1999-08-28T23:45Z,1999-08-29T00:15Z,1999-08-29T00:46Z,1999-08-29T00:55Z,1999-08-29T01:03Z,1999-08-29T01:10Z,1999-08-29T01:15Z,1999-08-29T01:25Z,1999-08-29T01:33Z,1999-08-29T01:40Z,1999-08-29T01:45Z,1999-08-29T01:55Z,1999-08-29T02:02Z,1999-08-29T02:10Z,1999-08-29T02:15Z,1999-08-29T02:25Z,1999-08-29T02:32Z,1999-08-29T02:40Z,1999-08-29T02:45Z,1999-08-29T03:15Z,1999-08-29T03:25Z,1999-08-29T03:32Z,1999-08-29T03:40Z,1999-08-29T03:45Z,1999-08-29T03:55Z,1999-08-29T04:02Z,1999-08-29T04:10Z,1999-08-29T05:33Z,1999-08-29T05:40Z,1999-08-29T06:15Z,1999-08-29T06:25Z,1999-08-29T06:45Z,1999-08-29T07:02Z,1999-08-29T07:15Z,1999-08-29T07:32Z,1999-08-29T07:45Z,1999-08-29T08:02Z,1999-08-29T08:15Z/1999-08-29T09:45Z/PT30M,1999-08-29T10:02Z,1999-08-29T10:15Z,1999-08-29T10:32Z,1999-08-29T10:45Z,1999-08-29T11:02Z,1999-08-29T11:15Z,1999-08-29T11:32Z,1999-08-29T11:46Z,1999-08-29T12:15Z,1999-08-29T12:45Z,1999-08-29T13:02Z,1999-08-29T13:15Z,1999-08-29T13:32Z,1999-08-29T13:45Z,1999-08-29T14:02Z,1999-08-29T14:15Z,1999-08-29T14:32Z,1999-08-29T14:45Z,1999-08-29T15:15Z,1999-08-29T15:32Z,1999-08-29T15:45Z,1999-08-29T16:02Z,1999-08-29T16:15Z,1999-08-29T16:32Z,1999-08-29T16:40Z,1999-08-29T16:45Z,1999-08-29T16:55Z,1999-08-29T17:02Z,1999-08-29T17:10Z,1999-08-29T17:15Z,1999-08-29T17:25Z,1999-08-29T17:32Z,1999-08-29T17:40Z,1999-08-29T17:45Z,1999-08-29T18:15Z,1999-08-29T18:25Z,1999-08-29T18:46Z,1999-08-29T18:55Z,1999-08-29T19:03Z,1999-08-29T19:10Z,1999-08-29T19:15Z,1999-08-29T19:25Z,1999-08-29T19:33Z,1999-08-29T19:40Z,1999-08-29T19:45Z,1999-08-29T19:55Z,1999-08-29T20:03Z,1999-08-29T20:10Z,1999-08-29T20:15Z,1999-08-29T20:25Z,1999-08-29T20:33Z,1999-08-29T20:40Z,1999-08-29T20:45Z,1999-08-29T21:15Z,1999-08-29T21:25Z,1999-08-29T21:32Z,1999-08-29T21:40Z,1999-08-29T21:45Z,1999-08-29T21:55Z,1999-08-29T22:02Z,1999-08-29T22:10Z,1999-08-29T22:15Z,1999-08-29T22:25Z,1999-08-29T22:32Z,1999-08-29T22:40Z,1999-08-29T22:45Z,1999-08-29T22:55Z,1999-08-29T23:02Z,1999-08-29T23:10Z,1999-08-29T23:15Z,1999-08-29T23:25Z,1999-08-29T23:32Z,1999-08-29T23:40Z,1999-08-29T23:45Z,1999-08-30T00:15Z,1999-08-30T00:46Z,1999-08-30T00:55Z,1999-08-30T01:02Z,1999-08-30T01:10Z,1999-08-30T01:15Z,1999-08-30T01:25Z,1999-08-30T01:32Z,1999-08-30T01:40Z,1999-08-30T01:45Z,1999-08-30T01:55Z,1999-08-30T02:02Z,1999-08-30T02:10Z,1999-08-30T02:15Z,1999-08-30T02:25Z,1999-08-30T02:32Z,1999-08-30T02:40Z,1999-08-30T02:45Z,1999-08-30T03:15Z,1999-08-30T03:25Z,1999-08-30T03:32Z,1999-08-30T03:40Z,1999-08-30T03:45Z,1999-08-30T03:55Z,1999-08-30T04:02Z,1999-08-30T04:10Z,1999-08-30T05:40Z,1999-08-30T06:15Z,1999-08-30T06:25Z,1999-08-30T06:45Z,1999-08-30T07:02Z,1999-08-30T07:15Z,1999-08-30T07:32Z,1999-08-30T07:45Z,1999-08-30T08:02Z,1999-08-30T08:15Z/1999-08-30T09:45Z/PT30M,1999-08-30T10:02Z,1999-08-30T10:15Z,1999-08-30T10:32Z,1999-08-30T10:45Z,1999-08-30T11:02Z,1999-08-30T11:15Z,1999-08-30T11:32Z,1999-08-30T11:45Z/1999-08-30T12:45Z/PT30M,1999-08-30T13:02Z,1999-08-30T13:15Z,1999-08-30T13:32Z,1999-08-30T13:45Z,1999-08-30T14:02Z,1999-08-30T14:15Z,1999-08-30T14:32Z,1999-08-30T14:45Z,1999-08-30T15:15Z,1999-08-30T15:32Z,1999-08-30T15:45Z,1999-08-30T16:02Z,1999-08-30T16:15Z,1999-08-30T16:32Z,1999-08-30T16:45Z,1999-08-30T17:02Z,1999-08-30T17:15Z,1999-08-30T17:32Z,1999-08-30T17:45Z,1999-08-30T18:15Z,1999-08-30T18:46Z,1999-08-30T18:55Z,1999-08-30T19:02Z,1999-08-30T19:10Z,1999-08-30T19:15Z,1999-08-30T19:25Z,1999-08-30T19:33Z,1999-08-30T19:40Z,1999-08-30T19:45Z,1999-08-30T19:55Z,1999-08-30T20:03Z,1999-08-30T20:10Z,1999-08-30T20:15Z,1999-08-30T20:25Z,1999-08-30T20:32Z,1999-08-30T20:40Z,1999-08-30T20:45Z,1999-08-30T21:15Z,1999-08-30T21:25Z,1999-08-30T21:32Z,1999-08-30T21:45Z,1999-08-30T21:55Z,1999-08-30T22:02Z,1999-08-30T22:10Z,1999-08-30T22:15Z,1999-08-30T22:25Z,1999-08-30T22:32Z,1999-08-30T22:40Z,1999-08-30T22:45Z,1999-08-30T22:55Z,1999-08-30T23:02Z,1999-08-30T23:10Z,1999-08-30T23:15Z,1999-08-30T23:25Z,1999-08-30T23:32Z,1999-08-30T23:40Z,1999-08-30T23:45Z/1999-08-31T00:45Z/PT30M,1999-08-31T00:55Z,1999-08-31T01:03Z,1999-08-31T01:10Z,1999-08-31T01:15Z,1999-08-31T01:25Z,1999-08-31T01:32Z,1999-08-31T01:40Z,1999-08-31T01:45Z,1999-08-31T01:55Z,1999-08-31T02:03Z,1999-08-31T02:10Z,1999-08-31T02:15Z,1999-08-31T02:25Z,1999-08-31T02:32Z,1999-08-31T02:40Z,1999-08-31T02:45Z,1999-08-31T03:15Z,1999-08-31T03:25Z,1999-08-31T03:32Z,1999-08-31T03:40Z,1999-08-31T03:45Z,1999-08-31T03:55Z,1999-08-31T04:02Z,1999-08-31T06:46Z,1999-08-31T07:02Z,1999-08-31T07:15Z,1999-08-31T07:32Z,1999-08-31T07:45Z,1999-08-31T08:02Z,1999-08-31T08:15Z/1999-08-31T09:45Z/PT30M,1999-08-31T10:02Z,1999-08-31T10:15Z,1999-08-31T10:32Z,1999-08-31T10:45Z,1999-08-31T11:02Z,1999-08-31T11:15Z,1999-08-31T11:32Z,1999-08-31T11:45Z/1999-08-31T12:45Z/PT30M,1999-08-31T13:02Z,1999-08-31T13:15Z,1999-08-31T13:32Z,1999-08-31T13:45Z,1999-08-31T14:02Z,1999-08-31T14:15Z,1999-08-31T14:32Z,1999-08-31T14:45Z
2001-03-17,2001-05-04,2001-05-20,2001-07-07,2002-03-04,2002-03-29,2002-04-28/2002-06-17/P25D,2002-07-01,2002-09-03,2003-03-23,2003-05-19
2001-10-16/2001-12-27/P8D,2002-01-01/2002-04-23/P8D
2003-06-20T02:44Z/2003-06-22T00:56Z/PT1H39M
2003-06-20T02:44Z/2003-06-22T00:56Z/PT1H39M
2003-06-20T02:44Z/2003-06-22T00:56Z/PT1H39M
2003-06-20T02:44Z/2003-06-22T00:56Z/PT1H39M
2003-06-20T02:44Z/2003-06-22T00:56Z/PT1H39M
1997-01-07/1997-01-21/P7D,1997-01-31/1997-03-21/P7D,1997-03-31/1997-04-21/P7D,1997-04-30/1997-05-21/P7D,1997-05-31/1997-06-21/P7D,1997-06-30/1997-07-21/P7D,1997-07-31/1997-08-21/P7D,1997-08-31/1997-09-21/P7D,1997-09-30/1997-10-21/P7D,1997-10-31/1997-11-21/P7D,1997-11-30/1997-12-21/P7D,1997-12-31/1998-01-21/P7D,1998-01-31/1998-03-21/P7D,1998-03-31/1998-04-21/P7D,1998-04-30/1998-05-21/P7D,1998-05-31/1998-06-21/P7D,1998-06-30/1998-07-21/P7D,1998-07-31/1998-08-21/P7D,1998-08-31/1998-09-21/P7D,1998-09-30/1998-10-21/P7D,1998-10-31/1998-11-21/P7D,1998-11-30/1998-12-21/P7D,1998-12-31/1999-01-21/P7D,1999-01-31/1999-03-21/P7D,1999-03-31/1999-04-21/P7D,1999-04-30/1999-05-21/P7D,1999-05-31/1999-06-21/P7D,1999-06-30/1999-07-21/P7D,1999-07-31/1999-08-21/P7D,1999-08-31/1999-09-21/P7D,1999-09-30/1999-10-21/P7D,1999-10-31/1999-11-21/P7D,1999-11-30/1999-12-21/P7D,1999-12-31
2003-06-20T02:44Z/2003-06-22T00:56Z/PT1H39M
2003-06-20T02:44Z/2003-06-22T00:56Z/PT1H39M
2003-06-20T02:44Z/2003-06-22T00:56Z/PT1H39M
1997-08-13/1997-12-27/P8D,1998-01-01/1998-12-27/P8D,1999-01-01/1999-12-27/P8D,2000-01-01/2000-12-26/P8D,2001-01-01/2001-12-27/P8D,2002-01-01/2002-12-27/P8D,2003-01-01/2003-07-20/P8D
2003-08-27T02:45Z/2003-09-17T08:45Z/PT6H,2003-09-17T20:45Z/2003-09-18T14:45Z/PT6H,2003-09-19T08:45Z/2003-09-21T20:45Z/PT6H
2005-08-22T24Z,2005-08-23T05Z,2005-08-23T23Z,2005-08-24T06Z,2005-08-24T22Z,2005-08-25T05Z,2005-08-25T23Z,2005-08-26T04Z,2005-08-26T22Z,2005-08-27T04Z,2005-08-27T21Z,2005-08-28T04Z,2005-08-28T22Z,2005-08-29T03Z,2005-08-29T22Z,2005-08-30T02Z,2005-08-30T22Z
2005-08-22T24Z,2005-08-23T05Z,2005-08-23T23Z,2005-08-24T06Z,2005-08-24T22Z,2005-08-25T05Z,2005-08-25T23Z,2005-08-26T04Z,2005-08-26T22Z,2005-08-27T04Z,2005-08-27T21Z,2005-08-28T04Z,2005-08-28T22Z,2005-08-29T03Z,2005-08-29T22Z,2005-08-30T02Z,2005-08-30T22Z
2005-08-23T21:00Z/2005-08-24T06:00Z/PT3H,2005-08-24T12:00Z/2005-08-25T06:00Z/PT3H,2005-08-25T12:00Z/2005-08-26T06:00Z/PT3H,2005-08-26T12:00Z/2005-08-27T06:00Z/PT3H,2005-08-27T12:00Z/2005-08-28T06:00Z/PT3H,2005-08-28T12:00Z/2005-08-29T06:00Z/PT3H,2005-08-29T12:00Z/2005-08-30T06:00Z/PT3H,2005-08-30T12:00Z/2005-08-31T06:00Z/PT3H
2005-08-23T08:45Z/2005-08-24T02:45Z/PT3H,2005-08-24T08:45Z/2005-08-25T02:45Z/PT3H,2005-08-25T08:45Z/2005-08-26T02:45Z/PT3H,2005-08-26T08:45Z/2005-08-27T02:45Z/PT3H,2005-08-27T08:45Z/2005-08-28T02:45Z/PT3H,2005-08-28T08:45Z/2005-08-29T02:45Z/PT3H,2005-08-29T08:45Z/2005-08-30T02:45Z/PT3H,2005-08-30T08:45Z/2005-08-31T02:45Z/PT3H
2005-08-23T08:45Z/2005-08-24T02:45Z/PT3H,2005-08-24T08:45Z/2005-08-25T02:45Z/PT3H,2005-08-25T08:45Z/2005-08-26T02:45Z/PT3H,2005-08-26T08:45Z/2005-08-27T02:45Z/PT3H,2005-08-27T08:45Z/2005-08-28T02:45Z/PT3H,2005-08-28T08:45Z/2005-08-29T02:45Z/PT3H,2005-08-29T08:45Z/2005-08-30T02:45Z/PT3H,2005-08-30T08:45Z/2005-08-31T02:45Z/PT3H
2005-08-23T08:45Z/2005-08-24T02:45Z/PT3H,2005-08-24T08:45Z/2005-08-25T02:45Z/PT3H,2005-08-25T08:45Z/2005-08-26T02:45Z/PT3H,2005-08-26T08:45Z/2005-08-27T02:45Z/PT3H,2005-08-27T08:45Z/2005-08-28T02:45Z/PT3H,2005-08-28T08:45Z/2005-08-29T02:45Z/PT3H,2005-08-29T08:45Z/2005-08-30T02:45Z/PT3H,2005-08-30T08:45Z/2005-08-31T02:45Z/PT3H
2005-08-23T08:45Z/2005-08-24T02:45Z/PT3H,2005-08-24T08:45Z/2005-08-25T02:45Z/PT3H,2005-08-25T08:45Z/2005-08-26T02:45Z/PT3H,2005-08-26T08:45Z/2005-08-27T02:45Z/PT3H,2005-08-27T08:45Z/2005-08-28T02:45Z/PT3H,2005-08-28T08:45Z/2005-08-29T02:45Z/PT3H,2005-08-29T08:45Z/2005-08-30T02:45Z/PT3H,2005-08-30T08:45Z/2005-08-31T02:45Z/PT3H
2005-08-23T08:45Z/2005-08-24T02:45Z/PT3H,2005-08-24T08:45Z/2005-08-25T02:45Z/PT3H,2005-08-25T08:45Z/2005-08-26T02:45Z/PT3H,2005-08-26T08:45Z/2005-08-27T02:45Z/PT3H,2005-08-27T08:45Z/2005-08-28T02:45Z/PT3H,2005-08-28T08:45Z/2005-08-29T02:45Z/PT3H,2005-08-29T08:45Z/2005-08-30T02:45Z/PT3H,2005-08-30T08:45Z/2005-08-31T02:45Z/PT3H
2005-08-26T23:45Z/2005-08-27T00:45Z/PT30M,2005-08-27T00:55Z,2005-08-27T01:02Z,2005-08-27T01:10Z,2005-08-27T01:15Z,2005-08-27T01:25Z,2005-08-27T01:32Z,2005-08-27T01:40Z,2005-08-27T01:45Z,2005-08-27T01:55Z,2005-08-27T02:02Z,2005-08-27T02:10Z,2005-08-27T02:15Z,2005-08-27T02:25Z,2005-08-27T02:32Z,2005-08-27T02:40Z,2005-08-27T02:45Z,2005-08-27T03:15Z,2005-08-27T03:25Z,2005-08-27T03:33Z,2005-08-27T03:40Z,2005-08-27T03:45Z,2005-08-27T04:02Z,2005-08-27T06:15Z,2005-08-27T06:32Z,2005-08-27T06:45Z,2005-08-27T06:55Z,2005-08-27T07:02Z,2005-08-27T07:10Z,2005-08-27T07:15Z,2005-08-27T07:25Z,2005-08-27T07:33Z,2005-08-27T07:40Z,2005-08-27T07:45Z,2005-08-27T07:55Z,2005-08-27T08:03Z,2005-08-27T08:10Z,2005-08-27T08:15Z,2005-08-27T08:25Z,2005-08-27T08:33Z,2005-08-27T08:40Z,2005-08-27T08:45Z,2005-08-27T09:15Z,2005-08-27T09:25Z,2005-08-27T09:32Z,2005-08-27T09:40Z,2005-08-27T09:45Z,2005-08-27T09:55Z,2005-08-27T10:02Z,2005-08-27T10:10Z,2005-08-27T10:15Z,2005-08-27T10:25Z,2005-08-27T10:33Z,2005-08-27T10:40Z,2005-08-27T10:45Z,2005-08-27T10:55Z,2005-08-27T11:02Z,2005-08-27T11:10Z,2005-08-27T11:15Z,2005-08-27T11:25Z,2005-08-27T11:33Z,2005-08-27T11:40Z,2005-08-27T11:45Z,2005-08-27T12:15Z,2005-08-27T12:25Z,2005-08-27T12:45Z,2005-08-27T12:55Z,2005-08-27T13:03Z,2005-08-27T13:10Z,2005-08-27T13:15Z,2005-08-27T13:25Z,2005-08-27T13:33Z,2005-08-27T13:40Z,2005-08-27T13:45Z,2005-08-27T13:55Z,2005-08-27T14:03Z,2005-08-27T14:10Z,2005-08-27T14:15Z,2005-08-27T14:25Z,2005-08-27T14:32Z,2005-08-27T14:40Z,2005-08-27T14:45Z,2005-08-27T15:15Z,2005-08-27T15:25Z,2005-08-27T15:32Z,2005-08-27T15:40Z,2005-08-27T15:45Z,2005-08-27T15:55Z,2005-08-27T16:02Z,2005-08-27T16:10Z,2005-08-27T16:15Z,2005-08-27T16:25Z,2005-08-27T16:32Z,2005-08-27T16:40Z,2005-08-27T16:45Z,2005-08-27T16:55Z,2005-08-27T17:03Z,2005-08-27T17:10Z,2005-08-27T17:15Z,2005-08-27T17:25Z,2005-08-27T17:33Z,2005-08-27T17:40Z,2005-08-27T17:45Z,2005-08-27T18:15Z,2005-08-27T18:25Z,2005-08-27T18:45Z,2005-08-27T18:55Z,2005-08-27T19:03Z,2005-08-27T19:10Z,2005-08-27T19:15Z,2005-08-27T19:25Z,2005-08-27T19:33Z,2005-08-27T19:40Z,2005-08-27T19:45Z,2005-08-27T19:55Z,2005-08-27T20:03Z,2005-08-27T20:10Z,2005-08-27T20:15Z,2005-08-27T20:25Z,2005-08-27T20:32Z,2005-08-27T20:40Z,2005-08-27T20:45Z,2005-08-27T21:15Z,2005-08-27T21:25Z,2005-08-27T21:32Z,2005-08-27T21:40Z,2005-08-27T21:45Z,2005-08-27T21:55Z,2005-08-27T22:03Z,2005-08-27T22:10Z,2005-08-27T22:15Z,2005-08-27T22:25Z,2005-08-27T22:33Z,2005-08-27T22:40Z,2005-08-27T22:45Z,2005-08-27T22:55Z,2005-08-27T23:03Z,2005-08-27T23:10Z,2005-08-27T23:15Z,2005-08-27T23:25Z,2005-08-27T23:33Z,2005-08-27T23:40Z,2005-08-27T23:45Z/2005-08-28T00:45Z/PT30M,2005-08-28T00:55Z,2005-08-28T01:02Z,2005-08-28T01:10Z,2005-08-28T01:15Z,2005-08-28T01:25Z,2005-08-28T01:32Z,2005-08-28T01:40Z,2005-08-28T01:45Z,2005-08-28T01:55Z,2005-08-28T02:02Z,2005-08-28T02:10Z,2005-08-28T02:15Z,2005-08-28T02:25Z,2005-08-28T02:32Z,2005-08-28T02:40Z,2005-08-28T02:45Z,2005-08-28T03:15Z,2005-08-28T03:25Z,2005-08-28T03:33Z,2005-08-28T03:40Z,2005-08-28T03:45Z,2005-08-28T04:02Z,2005-08-28T06:15Z,2005-08-28T06:32Z,2005-08-28T06:45Z,2005-08-28T06:55Z,2005-08-28T07:02Z,2005-08-28T07:10Z,2005-08-28T07:15Z,2005-08-28T07:25Z,2005-08-28T07:33Z,2005-08-28T07:40Z,2005-08-28T07:45Z,2005-08-28T07:55Z,2005-08-28T08:03Z,2005-08-28T08:10Z,2005-08-28T08:15Z,2005-08-28T08:25Z,2005-08-28T08:33Z,2005-08-28T08:40Z,2005-08-28T08:45Z,2005-08-28T09:15Z,2005-08-28T09:25Z,2005-08-28T09:33Z,2005-08-28T09:40Z,2005-08-28T09:45Z,2005-08-28T09:55Z,2005-08-28T10:03Z,2005-08-28T10:10Z,2005-08-28T10:15Z,2005-08-28T10:25Z,2005-08-28T10:32Z,2005-08-28T10:40Z,2005-08-28T10:45Z,2005-08-28T10:55Z,2005-08-28T11:02Z,2005-08-28T11:10Z,2005-08-28T11:15Z,2005-08-28T11:25Z,2005-08-28T11:32Z,2005-08-28T11:40Z,2005-08-28T11:45Z,2005-08-28T12:15Z,2005-08-28T12:25Z,2005-08-28T12:45Z,2005-08-28T12:55Z,2005-08-28T13:03Z,2005-08-28T13:10Z,2005-08-28T13:15Z,2005-08-28T13:25Z,2005-08-28T13:33Z,2005-08-28T13:40Z,2005-08-28T13:45Z,2005-08-28T13:55Z,2005-08-28T14:03Z,2005-08-28T14:10Z,2005-08-28T14:15Z,2005-08-28T14:25Z,2005-08-28T14:33Z,2005-08-28T14:40Z,2005-08-28T14:45Z,2005-08-28T15:15Z,2005-08-28T15:25Z,2005-08-28T15:32Z,2005-08-28T15:40Z,2005-08-28T15:45Z,2005-08-28T15:55Z,2005-08-28T16:02Z,2005-08-28T16:10Z,2005-08-28T16:15Z,2005-08-28T16:25Z,2005-08-28T16:32Z,2005-08-28T16:40Z,2005-08-28T16:45Z,2005-08-28T16:55Z,2005-08-28T17:03Z,2005-08-28T17:10Z,2005-08-28T17:15Z,2005-08-28T17:25Z,2005-08-28T17:33Z,2005-08-28T17:40Z,2005-08-28T17:45Z,2005-08-28T18:15Z,2005-08-28T18:25Z,2005-08-28T18:45Z,2005-08-28T18:55Z,2005-08-28T19:03Z,2005-08-28T19:10Z,2005-08-28T19:15Z,2005-08-28T19:25Z,2005-08-28T19:32Z,2005-08-28T19:40Z,2005-08-28T19:45Z,2005-08-28T19:55Z,2005-08-28T20:02Z,2005-08-28T20:10Z,2005-08-28T20:15Z,2005-08-28T20:25Z,2005-08-28T20:32Z,2005-08-28T20:40Z,2005-08-28T20:45Z,2005-08-28T21:15Z,2005-08-28T21:25Z,2005-08-28T21:32Z,2005-08-28T21:40Z,2005-08-28T21:45Z,2005-08-28T21:55Z,2005-08-28T22:03Z,2005-08-28T22:10Z,2005-08-28T22:15Z,2005-08-28T22:25Z,2005-08-28T22:33Z,2005-08-28T22:40Z,2005-08-28T22:45Z,2005-08-28T22:55Z,2005-08-28T23:03Z,2005-08-28T23:10Z,2005-08-28T23:15Z,2005-08-28T23:25Z,2005-08-28T23:33Z,2005-08-28T23:40Z,2005-08-28T23:45Z/2005-08-29T00:45Z/PT30M,2005-08-29T00:55Z,2005-08-29T01:02Z,2005-08-29T01:10Z,2005-08-29T01:15Z,2005-08-29T01:25Z,2005-08-29T01:32Z,2005-08-29T01:40Z,2005-08-29T01:45Z,2005-08-29T01:55Z,2005-08-29T02:02Z,2005-08-29T02:10Z,2005-08-29T02:15Z,2005-08-29T02:25Z,2005-08-29T02:32Z,2005-08-29T02:40Z,2005-08-29T02:45Z,2005-08-29T03:15Z,2005-08-29T03:25Z,2005-08-29T03:33Z,2005-08-29T03:40Z,2005-08-29T03:45Z,2005-08-29T04:02Z,2005-08-29T06:15Z,2005-08-29T06:32Z,2005-08-29T06:45Z,2005-08-29T06:55Z,2005-08-29T07:02Z,2005-08-29T07:10Z,2005-08-29T07:15Z,2005-08-29T07:25Z,2005-08-29T07:32Z,2005-08-29T07:40Z,2005-08-29T07:45Z,2005-08-29T07:55Z,2005-08-29T08:03Z,2005-08-29T08:10Z,2005-08-29T08:15Z,2005-08-29T08:25Z,2005-08-29T08:33Z,2005-08-29T08:40Z,2005-08-29T08:45Z,2005-08-29T09:15Z,2005-08-29T09:25Z,2005-08-29T09:33Z,2005-08-29T09:40Z,2005-08-29T09:45Z,2005-08-29T09:55Z,2005-08-29T10:03Z,2005-08-29T10:10Z,2005-08-29T10:15Z,2005-08-29T10:25Z,2005-08-29T10:33Z,2005-08-29T10:40Z,2005-08-29T10:45Z,2005-08-29T10:55Z,2005-08-29T11:02Z,2005-08-29T11:10Z,2005-08-29T11:15Z,2005-08-29T11:25Z,2005-08-29T11:32Z,2005-08-29T11:40Z,2005-08-29T11:45Z,2005-08-29T12:15Z,2005-08-29T12:25Z,2005-08-29T12:45Z,2005-08-29T12:55Z,2005-08-29T13:03Z,2005-08-29T13:10Z,2005-08-29T13:15Z,2005-08-29T13:25Z,2005-08-29T13:33Z,2005-08-29T13:40Z,2005-08-29T13:45Z,2005-08-29T13:55Z,2005-08-29T14:03Z,2005-08-29T14:10Z,2005-08-29T14:15Z,2005-08-29T14:25Z,2005-08-29T14:33Z,2005-08-29T14:40Z,2005-08-29T14:45Z,2005-08-29T15:15Z,2005-08-29T15:25Z,2005-08-29T15:32Z,2005-08-29T15:40Z,2005-08-29T15:45Z,2005-08-29T15:55Z,2005-08-29T16:02Z,2005-08-29T16:10Z,2005-08-29T16:15Z,2005-08-29T16:25Z,2005-08-29T16:32Z,2005-08-29T16:40Z,2005-08-29T16:45Z,2005-08-29T16:55Z,2005-08-29T17:02Z,2005-08-29T17:10Z,2005-08-29T17:15Z,2005-08-29T17:25Z,2005-08-29T17:33Z,2005-08-29T17:40Z,2005-08-29T17:45Z,2005-08-29T18:15Z,2005-08-29T18:25Z,2005-08-29T18:45Z,2005-08-29T18:55Z,2005-08-29T19:02Z,2005-08-29T19:10Z,2005-08-29T19:15Z,2005-08-29T19:25Z,2005-08-29T19:33Z,2005-08-29T19:40Z,2005-08-29T19:45Z,2005-08-29T19:55Z,2005-08-29T20:03Z,2005-08-29T20:10Z,2005-08-29T20:15Z,2005-08-29T20:25Z,2005-08-29T20:32Z,2005-08-29T20:40Z,2005-08-29T20:45Z,2005-08-29T21:15Z,2005-08-29T21:25Z,2005-08-29T21:32Z,2005-08-29T21:40Z,2005-08-29T21:45Z,2005-08-29T21:55Z,2005-08-29T22:03Z,2005-08-29T22:10Z,2005-08-29T22:15Z,2005-08-29T22:25Z,2005-08-29T22:33Z,2005-08-29T22:40Z,2005-08-29T22:45Z,2005-08-29T22:55Z,2005-08-29T23:03Z,2005-08-29T23:10Z,2005-08-29T23:15Z,2005-08-29T23:25Z,2005-08-29T23:33Z,2005-08-29T23:40Z,2005-08-29T23:45Z/2005-08-30T00:45Z/PT30M,2005-08-30T00:55Z,2005-08-30T01:03Z,2005-08-30T01:10Z,2005-08-30T01:15Z,2005-08-30T01:25Z,2005-08-30T01:33Z,2005-08-30T01:40Z,2005-08-30T01:45Z,2005-08-30T01:55Z,2005-08-30T02:02Z,2005-08-30T02:10Z,2005-08-30T02:15Z,2005-08-30T02:25Z,2005-08-30T02:32Z,2005-08-30T02:40Z,2005-08-30T02:45Z,2005-08-30T03:15Z,2005-08-30T03:25Z,2005-08-30T03:32Z,2005-08-30T03:45Z,2005-08-30T04:02Z,2005-08-30T06:15Z,2005-08-30T06:32Z,2005-08-30T06:45Z,2005-08-30T07:02Z,2005-08-30T07:15Z,2005-08-30T07:32Z,2005-08-30T07:45Z,2005-08-30T08:02Z,2005-08-30T08:15Z/2005-08-30T10:15Z/PT30M,2005-08-30T10:32Z,2005-08-30T10:45Z,2005-08-30T11:02Z,2005-08-30T11:15Z,2005-08-30T11:32Z,2005-08-30T11:45Z/2005-08-30T12:45Z/PT30M,2005-08-30T13:02Z,2005-08-30T13:15Z,2005-08-30T13:32Z,2005-08-30T13:45Z,2005-08-30T14:02Z,2005-08-30T14:15Z,2005-08-30T14:32Z,2005-08-30T14:45Z,2005-08-30T15:15Z,2005-08-30T15:32Z,2005-08-30T15:45Z,2005-08-30T16:02Z,2005-08-30T16:15Z,2005-08-30T16:33Z,2005-08-30T16:40Z,2005-08-30T16:45Z,2005-08-30T16:55Z,2005-08-30T17:02Z,2005-08-30T17:10Z,2005-08-30T17:15Z,2005-08-30T17:25Z,2005-08-30T17:33Z,2005-08-30T17:40Z,2005-08-30T17:45Z,2005-08-30T18:15Z,2005-08-30T18:25Z,2005-08-30T18:45Z,2005-08-30T18:55Z,2005-08-30T19:02Z,2005-08-30T19:10Z,2005-08-30T19:15Z,2005-08-30T19:25Z,2005-08-30T19:32Z,2005-08-30T19:40Z,2005-08-30T19:45Z,2005-08-30T19:55Z,2005-08-30T20:03Z,2005-08-30T20:10Z,2005-08-30T20:15Z,2005-08-30T20:25Z,2005-08-30T20:33Z,2005-08-30T20:40Z,2005-08-30T20:45Z,2005-08-30T21:15Z,2005-08-30T21:25Z,2005-08-30T21:33Z,2005-08-30T21:40Z,2005-08-30T21:45Z,2005-08-30T21:55Z,2005-08-30T22:03Z,2005-08-30T22:10Z,2005-08-30T22:15Z,2005-08-30T22:25Z,2005-08-30T22:33Z,2005-08-30T22:40Z,2005-08-30T22:45Z,2005-08-30T22:55Z,2005-08-30T23:02Z,2005-08-30T23:10Z,2005-08-30T23:15Z,2005-08-30T23:25Z,2005-08-30T23:32Z,2005-08-30T23:40Z,2005-08-30T23:45Z
2001-03-17,2001-05-04,2001-05-20,2001-07-07,2002-03-04,2002-03-29,2002-04-28/2002-06-17/P25D,2002-07-01,2002-09-03,2003-03-23,2003-05-19
1990-12-11T22:41:09Z/1990-12-11T22:45:11Z/PT2M1S,1990-12-11T22:47:13Z/1990-12-11T22:51:15Z/PT2M1S,1990-12-11T22:53:17Z/1990-12-11T22:57:19Z/PT2M1S,1990-12-11T22:59:21Z/1990-12-11T23:03:23Z/PT2M1S,1990-12-11T23:05:25Z/1990-12-11T23:09:27Z/PT2M1S,1990-12-11T23:11:29Z/1990-12-11T23:15:31Z/PT2M1S,1990-12-11T23:17:33Z/1990-12-11T23:21:35Z/PT2M1S,1990-12-11T23:23:37Z/1990-12-11T23:27:39Z/PT2M1S,1990-12-11T23:29:41Z/1990-12-11T23:33:43Z/PT2M1S,1990-12-11T23:35:45Z/1990-12-11T23:39:47Z/PT2M1S,1990-12-11T23:41:49Z/1990-12-11T23:45:51Z/PT2M1S,1990-12-11T23:47:53Z/1990-12-11T23:51:55Z/PT2M1S,1990-12-11T23:53:57Z/1990-12-11T23:57:59Z/PT2M1S,1990-12-12T00:00:01Z/1990-12-12T00:04:03Z/PT2M1S,1990-12-12T00:06:05Z/1990-12-12T00:10:07Z/PT2M1S,1990-12-12T00:12:09Z/1990-12-12T00:16:11Z/PT2M1S,1990-12-12T00:18:13Z/1990-12-12T00:22:15Z/PT2M1S,1990-12-12T00:24:17Z/1990-12-12T00:28:19Z/PT2M1S,1990-12-12T00:30:21Z/1990-12-12T00:34:23Z/PT2M1S,1990-12-12T00:36:25Z/1990-12-12T00:40:27Z/PT2M1S,1990-12-12T00:42:29Z/1990-12-12T00:46:31Z/PT2M1S,1990-12-12T00:48:33Z/1990-12-12T00:52:35Z/PT2M1S,1990-12-12T00:54:37Z/1990-12-12T00:58:39Z/PT2M1S,1990-12-12T01:00:41Z/1990-12-12T01:04:43Z/PT2M1S,1990-12-12T01:06:45Z/1990-12-12T01:10:47Z/PT2M1S,1990-12-12T01:12:49Z/1990-12-12T01:16:51Z/PT2M1S,1990-12-12T01:18:53Z/1990-12-12T01:22:55Z/PT2M1S,1990-12-12T01:24:57Z/1990-12-12T01:28:59Z/PT2M1S,1990-12-12T01:31:01Z/1990-12-12T01:35:03Z/PT2M1S,1990-12-12T01:37:05Z/1990-12-12T01:41:07Z/PT2M1S,1990-12-12T01:43:09Z/1990-12-12T01:47:11Z/PT2M1S,1990-12-12T01:49:13Z/1990-12-12T01:53:15Z/PT2M1S,1990-12-12T01:55:17Z/1990-12-12T01:59:19Z/PT2M1S,1990-12-12T02:01:21Z/1990-12-12T02:05:23Z/PT2M1S,1990-12-12T02:07:25Z/1990-12-12T02:11:27Z/PT2M1S,1990-12-12T02:13:29Z/1990-12-12T02:17:31Z/PT2M1S,1990-12-12T02:19:33Z/1990-12-12T02:23:35Z/PT2M1S,1990-12-12T02:25:37Z/1990-12-12T02:29:39Z/PT2M1S,1990-12-12T02:31:41Z/1990-12-12T02:35:43Z/PT2M1S,1990-12-12T02:37:45Z/1990-12-12T02:41:47Z/PT2M1S,1990-12-12T02:43:49Z/1990-12-12T02:47:51Z/PT2M1S,1990-12-12T02:49:53Z/1990-12-12T02:53:55Z/PT2M1S,1990-12-12T02:55:57Z/1990-12-12T02:59:59Z/PT2M1S,1990-12-12T03:02:01Z/1990-12-12T03:06:03Z/PT2M1S,1990-12-12T03:08:05Z/1990-12-12T03:12:07Z/PT2M1S,1990-12-12T03:14:09Z/1990-12-12T03:18:11Z/PT2M1S,1990-12-12T03:20:13Z/1990-12-12T03:24:15Z/PT2M1S,1990-12-12T03:26:17Z/1990-12-12T03:30:19Z/PT2M1S,1990-12-12T03:32:21Z/1990-12-12T03:36:23Z/PT2M1S,1990-12-12T03:38:25Z/1990-12-12T03:42:27Z/PT2M1S,1990-12-12T03:44:29Z/1990-12-12T03:48:31Z/PT2M1S,1990-12-12T03:50:33Z/1990-12-12T03:54:35Z/PT2M1S,1990-12-12T03:56:37Z/1990-12-12T04:00:39Z/PT2M1S,1990-12-12T04:02:41Z/1990-12-12T04:06:43Z/PT2M1S,1990-12-12T04:08:45Z/1990-12-12T04:12:47Z/PT2M1S,1990-12-12T04:14:49Z/1990-12-12T04:18:51Z/PT2M1S,1990-12-12T04:20:53Z/1990-12-12T04:24:55Z/PT2M1S,1990-12-12T04:26:57Z
2001-09-01T00:45Z/2001-09-01T03:45Z/PT30M,2001-09-01T04:00Z/2001-09-01T06:00Z/PT30M,2001-09-01T06:45Z/2001-09-01T11:15Z/PT30M,2001-09-01T14:15Z/2001-09-01T19:15Z/PT30M,2001-09-01T20:15Z/2001-09-02T03:45Z/PT30M,2001-09-02T04:00Z/2001-09-02T06:00Z/PT30M,2001-09-02T06:45Z/2001-09-03T03:45Z/PT30M,2001-09-03T04:00Z/2001-09-03T05:00Z/PT30M,2001-09-03T06:00Z,2001-09-03T06:45Z/2001-09-04T03:45Z/PT30M,2001-09-04T04:00Z/2001-09-04T06:00Z/PT30M,2001-09-04T06:45Z/2001-09-04T19:45Z/PT30M,2001-09-04T20:45Z/2001-09-05T03:45Z/PT30M,2001-09-05T04:00Z/2001-09-05T05:00Z/PT30M,2001-09-05T06:00Z,2001-09-05T06:45Z/2001-09-06T03:45Z/PT30M,2001-09-06T04:00Z/2001-09-06T06:00Z/PT30M,2001-09-06T06:45Z/2001-09-07T03:45Z/PT30M,2001-09-07T04:00Z/2001-09-07T05:00Z/PT30M,2001-09-07T06:00Z,2001-09-07T06:45Z/2001-09-07T11:15Z/PT30M,2001-09-07T12:45Z/2001-09-07T15:15Z/PT30M,2001-09-07T16:15Z/2001-09-08T03:45Z/PT30M,2001-09-08T04:00Z/2001-09-08T06:00Z/PT30M,2001-09-08T06:45Z/2001-09-08T22:45Z/PT30M,2001-09-08T23:45Z/2001-09-09T03:45Z/PT30M,2001-09-09T04:00Z/2001-09-09T05:00Z/PT30M,2001-09-09T06:45Z/2001-09-10T03:45Z/PT30M,2001-09-10T04:00Z/2001-09-10T06:00Z/PT30M,2001-09-10T06:45Z/2001-09-11T03:45Z/PT30M,2001-09-11T04:30Z,2001-09-11T05:00Z,2001-09-11T06:00Z,2001-09-11T06:45Z/2001-09-11T20:45Z/PT30M,2001-09-12T03:45Z,2001-09-12T04:00Z/2001-09-12T06:00Z/PT30M,2001-09-12T06:45Z/2001-09-13T03:45Z/PT30M,2001-09-13T04:00Z/2001-09-13T05:00Z/PT30M,2001-09-13T06:00Z,2001-09-13T06:45Z/2001-09-14T03:45Z/PT30M,2001-09-14T04:00Z/2001-09-14T06:00Z/PT30M,2001-09-14T06:45Z/2001-09-15T03:45Z/PT30M,2001-09-15T04:00Z/2001-09-15T06:00Z/PT30M,2001-09-15T06:45Z/2001-09-15T23:45Z/PT30M
2001-09-01T00:45Z/2001-09-01T03:45Z/PT30M,2001-09-01T04:00Z/2001-09-01T06:00Z/PT30M,2001-09-01T06:45Z/2001-09-01T11:15Z/PT30M,2001-09-01T14:15Z/2001-09-01T19:15Z/PT30M,2001-09-01T20:15Z/2001-09-02T03:45Z/PT30M,2001-09-02T04:00Z/2001-09-02T06:00Z/PT30M,2001-09-02T06:45Z/2001-09-03T03:45Z/PT30M,2001-09-03T04:00Z/2001-09-03T05:00Z/PT30M,2001-09-03T06:00Z,2001-09-03T06:45Z/2001-09-04T03:45Z/PT30M,2001-09-04T04:00Z/2001-09-04T06:00Z/PT30M,2001-09-04T06:45Z/2001-09-04T19:45Z/PT30M,2001-09-04T20:45Z/2001-09-05T03:45Z/PT30M,2001-09-05T04:00Z/2001-09-05T05:00Z/PT30M,2001-09-05T06:00Z,2001-09-05T06:45Z/2001-09-06T03:45Z/PT30M,2001-09-06T04:00Z/2001-09-06T06:00Z/PT30M,2001-09-06T06:45Z/2001-09-07T03:45Z/PT30M,2001-09-07T04:00Z/2001-09-07T05:00Z/PT30M,2001-09-07T06:00Z,2001-09-07T06:45Z/2001-09-07T11:15Z/PT30M,2001-09-07T12:45Z/2001-09-07T15:15Z/PT30M,2001-09-07T16:15Z/2001-09-08T03:45Z/PT30M,2001-09-08T04:00Z/2001-09-08T06:00Z/PT30M,2001-09-08T06:45Z/2001-09-08T22:45Z/PT30M,2001-09-08T23:45Z/2001-09-09T03:45Z/PT30M,2001-09-09T04:00Z/2001-09-09T05:00Z/PT30M,2001-09-09T06:45Z/2001-09-10T03:45Z/PT30M,2001-09-10T04:00Z/2001-09-10T06:00Z/PT30M,2001-09-10T06:45Z/2001-09-11T03:45Z/PT30M,2001-09-11T04:30Z,2001-09-11T05:00Z,2001-09-11T06:00Z,2001-09-11T06:45Z/2001-09-11T20:45Z/PT30M,2001-09-12T03:45Z,2001-09-12T04:00Z/2001-09-12T06:00Z/PT30M,2001-09-12T06:45Z/2001-09-13T03:45Z/PT30M,2001-09-13T04:00Z/2001-09-13T05:00Z/PT30M,2001-09-13T06:00Z,2001-09-13T06:45Z/2001-09-14T03:45Z/PT30M,2001-09-14T04:00Z/2001-09-14T06:00Z/PT30M,2001-09-14T06:45Z/2001-09-15T03:45Z/PT30M,2001-09-15T04:00Z/2001-09-15T06:00Z/PT30M,2001-09-15T06:45Z/2001-09-15T23:45Z/PT30M
2003-06-20T02:44Z/2003-06-22T00:56Z/PT1H39M
2003-06-20T02:44Z/2003-06-22T00:56Z/PT1H39M
1999-04-17T00:49:27Z,1999-04-17T00:50:22Z/1999-04-17T00:56:40Z/PT54S,1999-04-17T00:57:35Z/1999-04-17T01:02:05Z/PT54S,1999-04-17T01:03:00Z/1999-04-17T01:09:18Z/PT54S,1999-04-17T01:10:13Z/1999-04-17T01:16:31Z/PT54S,1999-04-17T01:17:26Z/1999-04-17T01:23:44Z/PT54S,1999-04-17T01:24:39Z/1999-04-17T01:30:03Z/PT54S,1999-04-17T01:30:58Z/1999-04-17T01:36:22Z/PT54S,1999-04-17T01:37:17Z/1999-04-17T01:42:41Z/PT54S,1999-04-17T01:43:36Z/1999-04-17T01:50:48Z/PT54S,1999-04-17T01:51:43Z/1999-04-17T01:58:01Z/PT54S,1999-04-17T01:58:56Z/1999-04-17T02:03:26Z/PT54S,1999-04-17T02:04:21Z/1999-04-17T02:09:45Z/PT54S,1999-04-17T02:10:40Z/1999-04-17T02:16:58Z/PT54S,1999-04-17T02:17:53Z/1999-04-17T02:24:11Z/PT54S,1999-04-17T02:25:06Z/1999-04-17T02:30:30Z/PT54S,1999-04-17T02:31:25Z/1999-04-17T02:36:49Z/PT54S,1999-04-17T02:37:44Z/1999-04-17T02:44:02Z/PT54S,1999-04-17T02:44:57Z/1999-04-17T02:52:09Z/PT54S,1999-04-17T02:53:04Z/1999-04-17T02:58:28Z/PT54S,1999-04-17T02:59:23Z/1999-04-17T03:03:53Z/PT54S,1999-04-17T03:04:48Z/1999-04-17T03:11:06Z/PT54S,1999-04-17T03:12:01Z/1999-04-17T03:18:19Z/PT54S,1999-04-17T03:19:14Z/1999-04-17T03:24:38Z/PT54S,1999-04-17T03:25:33Z/1999-04-17T03:30:57Z/PT54S,1999-04-17T03:31:52Z/1999-04-17T03:38:10Z/PT54S,1999-04-17T03:39:05Z/1999-04-17T03:45:23Z/PT54S,1999-04-17T03:46:18Z/1999-04-17T03:51:42Z/PT54S,1999-04-17T03:52:37Z/1999-04-17T03:58:01Z/PT54S,1999-04-17T03:58:56Z/1999-04-17T04:05:14Z/PT54S,1999-04-17T04:06:09Z/1999-04-17T04:11:33Z/PT54S,1999-04-17T04:12:28Z/1999-04-17T04:17:52Z/PT54S,1999-04-17T04:18:47Z/1999-04-17T04:25:05Z/PT54S
*/