package org.cresques.filter.enhancement;

import org.cresques.io.data.RasterBuf;
import org.cresques.io.datastruct.Statistic;

public class LinearEnhancementDoubleFilter extends LinearEnhancementFilter {
	private double[] 		px = new double[4];
	private int 			bandsCnt = 3;
	
	public void post() {
		// TODO Auto-generated method stub

	}

	public void process(int col, int line) {
		raster.getElemDouble(line, col, px);
        px = calcLinearEnhancement(px);
        raster.setElemDouble(line, col, px);
	}

	public void processSuperSampling(int col, int line) {
		raster.getElemDouble(line, col, px);
        px = calcLinearEnhancement(px);
		for(int j = col; j < raster.getWidth() && j < (col + stepX[contX + 1]); j++)
			for(int i = line; i < raster.getHeight() && i < (line + stepY[contY + 1]); i++)
				 raster.setElemDouble(i, j, px);
	}

	public void processLine(int y) {
		// TODO Auto-generated method stub

	}

	public int getInRasterDataType() {
		return RasterBuf.TYPE_DOUBLE;
	}

	public int getOutRasterDataType() {
		return RasterBuf.TYPE_DOUBLE;
	}

	public Object getResult(String name) {
		if (name.equals("raster")) {
            return (Object) this.raster;
        } else {
            return null;
        }
	}

	public void pre() {
//		Obtención de parámetros
        this.raster = (RasterBuf) params.get("raster");
        this.stats = (Statistic) params.get("stats");
        this.removeExtrema = ((Boolean) params.get("remove")).booleanValue();
        this.filename = (String) params.get("filename");
        height = raster.getHeight();
        width = raster.getWidth();
        super.pre();
	}
	
	/**
     * Calculo del realce
     * @param pt pixel
     * @return pixel con el calculo de realce aplicado
     */
    private double[] calcLinearEnhancement(double[] px){
    	for (int i = 0; i < bandsCnt; i++) {
            if (px[i] > (float)maxBandValue[i]) {
                px[i] = (float)maxBandValue[i];
            } else if (px[i] < minBandValue[i]) {
                px[i] = (float)minBandValue[i];
            }

            px[i] = (int)(((int) ((((double) px[i]) * scale[i]) + offset[i])) & 0xff);
        }
    	return px;
    }

}
