/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.cresques.ui;

import org.cresques.cts.IProjection;

import org.cresques.px.PxLayer;

import java.awt.geom.Point2D;


/**
 * Define los mtodos de comunicacin entre la librera y la aplicacin
 * @author "Luis W. Sevilla" <sevilla_lui@gva.es>
 */
public interface CQApp {
    public CQMapCanvas getCanvas();

    public IProjection getCurrentProjection();

    public void setCurrentProjection(IProjection proj);

    public CQLayerManager getLayerManager();

    public PxLayer getLayerByName(String lName);

    public void setCurrentLayer(PxLayer layer);

    public PxLayer getCurrentLayer();

    public PxLayer createLayer(String name, IProjection proj);

    public void loadFile(String fName, IProjection proj);

    public void loadFile(String[] fNames, IProjection proj);

    public void setCurrentMinuteo(PxLayer layerMin);

    public void selectHoja(Point2D pt);
}
