package org.cresques.ui.raster;

import javax.swing.JPanel;
import javax.swing.JButton;

import java.awt.Color;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.FlowLayout;
import javax.swing.ImageIcon;

public class AddRemoveButtonsPanel extends JPanel {

	private JPanel pBorder = null;
	private JButton bAdd = null;
	private JButton bRemove = null;

	/**
	 * This is the default constructor
	 */
	public AddRemoveButtonsPanel() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		FlowLayout flowLayout = new FlowLayout();
		flowLayout.setHgap(0);
		flowLayout.setVgap(0);
		this.setLayout(flowLayout);
		this.setSize(26, 52);
		this.add(getJPanel(), null);
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (pBorder == null) {
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.insets = new java.awt.Insets(3,3,3,3);
			gridBagConstraints1.gridy = 1;
			gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints1.gridx = 0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.insets = new java.awt.Insets(3,3,3,3);
			gridBagConstraints.gridy = 0;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints.gridx = 0;
			pBorder = new JPanel();
			pBorder.setLayout(new GridBagLayout());
			pBorder.setBorder(javax.swing.BorderFactory.createEmptyBorder(0,0,0,0));
			pBorder.add(getBAdd(), gridBagConstraints);
			pBorder.add(getBRemove(), gridBagConstraints1);
		}
		return pBorder;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	public JButton getBAdd() {
		if (bAdd == null) {
			bAdd = new JButton();
			bAdd.setPreferredSize(new java.awt.Dimension(20,20));
			bAdd.setIcon(new ImageIcon("./gvSIG/extensiones/com.iver.cit.gvsig/images/forward.png"));
		}
		return bAdd;
	}

	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	public JButton getBRemove() {
		if (bRemove == null) {
			bRemove = new JButton();
			bRemove.setPreferredSize(new java.awt.Dimension(20,20));
			bRemove.setIcon(new ImageIcon("./gvSIG/extensiones/com.iver.cit.gvsig/images/backward.png"));
		}
		return bRemove;
	}
	
	/**
	 * Activa o desactiva el control
	 * @param enable True activa el control y false lo desactiva
	 */
	public void setControlEnabled(boolean enabled){
		this.getBAdd().setEnabled(enabled);
		this.getBRemove().setEnabled(enabled);
	}

}
