/*
 * Created on 19-jul-2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informaci�n Geogr�fica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 */
package org.cresques.ui.raster;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.cresques.io.data.RasterBuf;
import org.cresques.io.datastruct.Histogram;
import org.cresques.io.datastruct.Statistic;
import org.cresques.ui.raster.listener.HistogramPanelListener;
import org.cresques.util.Utilities;
import org.gvsig.gui.beans.BaseComponent;
import org.gvsig.gui.beans.graphic.GraphicChartPanel;
import org.gvsig.gui.beans.graphic.GraphicContainer;
import org.gvsig.gui.beans.table.TableContainer;
import org.gvsig.gui.beans.table.exceptions.NotInitializeException;
import org.gvsig.i18n.Messages;

/**
 * Interfaz de usuario para la representacin de histogramas.
 * 
 * @author Diego Guerrero (diego.guerrero@uclm.es)
 *
 */

public class HistogramPanel extends BaseComponent {
	
	public static int					MAXBANDS = 10;  
	private int 						HSUP = 60;
	private int 						HTABLE = 105;
	private int 						MARGIN = 12;
	
	private JPanel 						pGeneral = null;
	private JPanel 						pSupControl = null;
	private GraphicContainer 			pHistogram = null;
	private JPanel 						pTable = null;
	private JComboBox 					jComboBoxOrigen = null;
	private JComboBox 					jComboBoxTipo = null;
	private JComboBox 					jComboBands = null;
	private JButton 					jButtonClear = null;
	private JButton 					jButtonBands = null;
	private JButton 					bTable = null;
	private TableContainer 				tableContainer = null;
	private HistogramPanelListener  	listener = null;
		
	private JPanel 						pButtons = null;
	private int 						width, height;
	private JPanel 						cbSup = null;
	private JLabel 						lOrigin = null;
	private JLabel 						lBands = null;
	private JLabel 						lType = null;
	/**
	 * Objeto histograma para la gestin de procesos de histograma
	 */
	private	Histogram					histogramObj = null;
	/**
	 * Bandas que se estn mostrando en el grfico. Se inicializa con las 3 bandas
	 * RGB de la visualizacin. Este array puede tener ms elementos ya que si las 
	 * bandas no son de visualizacin (bandas de la imagen en disco) tendr un elemento
	 * por cada una. 
	 */
	public boolean[]					showBands = {true, true, true};
	/**
	 * Tipo de histograma 
	 * 0 = acumulado 
	 * 1 = No acumulado
	 */
	private int							type = 0;
	/**
	 * Tipo de fuente de datos para el histograma
	 * 0 = Datos de la vista
	 * 1 = extent de la vista y datos leidos desde la imagen
	 * 2 = histograma de la imagen completa
	 */
	private int 						histogramDataSource = 0;
	
	private HistogramIncrement 			incrementPanel = null;
	
	/**
	 * ltimo histograma visualizado en el grfico
	 */
	private int[][]						lastHistogram = null;
	/**
	 * Tipo de dato de la peticin. Si la peticin del histograma es de la vista el tipo
	 * de dato ser byte aunque la imagen sea de 16 bits. Si la peticin es de los datos 
	 * reales de la imagen entonces el tipo de dato de la peticin coincide con el tipo
	 * de datos de la imagen.
	 */
	private int							requestDataType = RasterBuf.TYPE_BYTE;
	
	/**
	 * This method initializes 
	 * @param histograms
	 */
	public HistogramPanel(int w, int h){
		super();
		this.width = w;
		this.height = h;
		initialize();
		this.setComponentSize(width, height);
	}

	/**
	 * This method initializes 
	 * 
	 */
	public HistogramPanel() {
		super();
		initialize();
		this.setComponentSize(width, height);
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		listener = new HistogramPanelListener(this);
		BorderLayout l = new BorderLayout();
		setLayout(l);
        add(getCbSup(), l.NORTH);
        add(getPHistogram(), l.CENTER);
        add(getPTable(), l.SOUTH);
        setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
        listener.setControlListeners();
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPGeneral() {
		if (pGeneral == null) {
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.gridy = 2;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridy = 1;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 0;
			pGeneral = new JPanel();
			pGeneral.setLayout(new GridBagLayout());
			//pGeneral.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			pGeneral.add(getCbSup(), gridBagConstraints);
			pGeneral.add(getPHistogram(), gridBagConstraints1);
			pGeneral.add(getPTable(), gridBagConstraints2);
		}
		return pGeneral;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public GraphicContainer getPHistogram() {
		if (pHistogram == null) {
			pHistogram = new GraphicContainer(width - MARGIN, height - HSUP - HTABLE, false);
			//pHistogram.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
		}
		return pHistogram;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPTable() {
		if (pTable == null) {
			pTable = new JPanel();
			//pTable.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
						
			FlowLayout flowlayout = new FlowLayout();
			flowlayout.setVgap(0);
			flowlayout.setHgap(0);
			flowlayout.setAlignment(java.awt.FlowLayout.LEFT);
			
			pTable.setLayout(flowlayout);
			pTable.add(getTable(), null);
			pTable.add(getBCreateTable(), null);
		}
		return pTable;
	}

	/**
	 * Obtiene la tabla de estadisticas
	 * @return
	 */
	public TableContainer getTable(){
		if(tableContainer == null){
			String[] columnNames = {Messages.getText("banda"), Messages.getText("minimo"), Messages.getText("maximo"), Messages.getText("media"), Messages.getText("mediana"), Messages.getText("npixeles")};
			int[] columnWidths = {50, 65, 65, 65, 65, 115};
			tableContainer = new TableContainer(width - 200, HTABLE - 12, columnNames, columnWidths);
			tableContainer.setControlVisible(false);
			tableContainer.setModel("ListModel");
			tableContainer.initialize();
			try{
				tableContainer.setEditable(false);
			}catch(NotInitializeException ex){
				System.out.println("Tabla no inicializada");
			}	
		}
		return tableContainer;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getCbSup() {
		if (cbSup == null) {
			lOrigin = new JLabel();
			lOrigin.setText(Messages.getText("origen")+":");
			lBands = new JLabel();
			lBands.setText(Messages.getText("bandas")+":");
			lType = new JLabel();
			lType.setText(Messages.getText("tipo")+":");
			
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridy = 0;
			gridBagConstraints.gridx = 0;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.insets = new java.awt.Insets(0,0,0,80);
			gridBagConstraints1.gridy = 0;
			gridBagConstraints1.gridx = 1;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridy = 0;
			gridBagConstraints2.gridx = 3;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.insets = new java.awt.Insets(2,0,0,0);
			gridBagConstraints3.gridy = 1;
			gridBagConstraints3.gridx = 0;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.insets = new java.awt.Insets(2,0,0,80);
			gridBagConstraints4.gridy = 1;
			gridBagConstraints4.gridx = 1;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.insets = new java.awt.Insets(2,0,0,0);
			gridBagConstraints5.gridy = 1;
			gridBagConstraints5.gridx = 3;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridy = 0;
			gridBagConstraints6.gridx = 2;
			
			cbSup = new JPanel();
			//cbSup.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			
			cbSup.setSize(new java.awt.Dimension(width - MARGIN, HSUP));
			cbSup.setPreferredSize(new java.awt.Dimension(height - MARGIN, HSUP));
			
			cbSup.setLayout(new GridBagLayout());
			cbSup.add(lOrigin, gridBagConstraints);
			cbSup.add(getJComboBoxOrigen(), gridBagConstraints1);
			
			cbSup.add(lBands, gridBagConstraints6);
			
			cbSup.add(getJComboBands(), gridBagConstraints2);
			cbSup.add(lType, gridBagConstraints3);
			cbSup.add(getJComboBoxTipo(), gridBagConstraints4);
			cbSup.add(getJButtonClear(), gridBagConstraints5);
		}
		return cbSup;
	}
	
	/**
	 * Obtiene el combo con la seleccin de tipo de histograma, acumulado/no acumulado
	 * @return javax.swing.JComboBox	
	 */
	public JComboBox getJComboBoxTipo() {
		if (jComboBoxTipo == null) {
			String lista [] = {Messages.getText("no_acumulado"),Messages.getText("acumulado")};
			jComboBoxTipo = new JComboBox(lista);
			jComboBoxTipo.addActionListener(listener);
			jComboBoxTipo.setPreferredSize(new java.awt.Dimension(150,25));
		}
		return jComboBoxTipo;
	}
	
	/**
	 * Obtiene el combo con la seleccin de la fuente de datos en el calculo del histograma,
	 * datos de la vista, datos reales con el extent de la vista e imagen completa.
	 * @return javax.swing.JComboBox	
	 */
	public JComboBox getJComboBoxOrigen() {
		if (jComboBoxOrigen == null) {
			String lista [] = {Messages.getText("datos_visualizados"),Messages.getText("vista_datasource"),Messages.getText("imagen_completa")};
			jComboBoxOrigen = new JComboBox(lista);
			jComboBoxOrigen.addActionListener(listener);
			jComboBoxOrigen.setPreferredSize(new java.awt.Dimension(150,25));
		}
		return jComboBoxOrigen;
	}
	
	/**
	 *Asigna el combo "Origen" el valor de solo vista para el calculo del histograma. Esa opcin es 
	 *utilizada para extensiones que necesitan histograma pero no pueden acceder a la fuente de datos.
	 */
	public void setOnlyViewValue(){
		HistogramPanelListener.comboEventEnable = false;
		getJComboBoxOrigen().removeAllItems();
		getJComboBoxOrigen().addItem(Messages.getText("vista"));
		HistogramPanelListener.comboEventEnable = true;
	}
	
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	public JButton getJButtonClear() {
		if (jButtonClear == null) {
			jButtonClear = new JButton();
			jButtonClear.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jButtonClear.setText(Messages.getText("limpiar"));
			jButtonClear.addActionListener(listener);
			jButtonClear.setPreferredSize(new java.awt.Dimension(100,25));
		}
		return jButtonClear;
	}
	
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	public JButton getBCreateTable() {
		if (bTable == null) {
			bTable = new JButton();
			bTable.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			bTable.setText(Messages.getText("crear_tabla"));
			bTable.addActionListener(listener);
			bTable.setPreferredSize(new java.awt.Dimension(150,25));
		}
		return bTable;
	}
	
	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	public JComboBox getJComboBands() {
		if (jComboBands == null) {
			String lista [] = {Messages.getText("todas")};
			jComboBands = new JComboBox(lista);
			jComboBands.addActionListener(listener);
			jComboBands.setPreferredSize(new java.awt.Dimension(100,25));
		}
		return jComboBands;
	}
		
	/**
	 * Asigna el tamao del componente
	 * @param w Nuevo ancho del componente padre
	 * @param h Nuevo alto del componente padre
	 */
	public void setComponentSize(int w, int h){
		this.width = w;
		this.height = h;
		int margin_table = 200;
				
		this.setPreferredSize(new java.awt.Dimension(width, height));
		getPHistogram().setComponentSize(width - MARGIN, height - HSUP - HTABLE);
		getTable().setComponentSize(width - margin_table, HTABLE - MARGIN);		
	}
	
	//*************************************************************
	//MTODOS DEL CONTROL
	
	public void showHistogram(){
		switch(type){//Tipo noacumulado = 0, acumulado = 1
		case 0: switch(histogramDataSource){//Fte de datos vista = 0, extent = 1, completo =2
				case 0:	requestDataType = RasterBuf.TYPE_BYTE;
						calcHistogramFromView(showBands); 
						break;
				case 1:	if(this.getHistogram().getGrid().getDataType() == RasterBuf.TYPE_SHORT)
							requestDataType = RasterBuf.TYPE_SHORT;
						else
							requestDataType = RasterBuf.TYPE_BYTE;	
						calcHistogramFromDataSourceAndExtentView(showBands);
						break;
				case 2:	if(this.getHistogram().getGrid().getDataType() == RasterBuf.TYPE_SHORT)
							requestDataType = RasterBuf.TYPE_SHORT;
						else
							requestDataType = RasterBuf.TYPE_BYTE;
						calcFullHistogramFromDataSource(showBands);	
						break;
					}
				break;
		case 1:	switch(histogramDataSource){//Fte de datos vista = 0, extent = 1, completo =2
				case 0:	requestDataType = RasterBuf.TYPE_BYTE;
						calcAccumulatedHistogramFromView(showBands); 
						break;
				case 1:	if(this.getHistogram().getGrid().getDataType() == RasterBuf.TYPE_SHORT)
							requestDataType = RasterBuf.TYPE_SHORT;
						else
							requestDataType = RasterBuf.TYPE_BYTE;
						calcHistogramFromDataSourceAndExtentView(showBands);
						break;
				case 2:	if(this.getHistogram().getGrid().getDataType() == RasterBuf.TYPE_SHORT)
							requestDataType = RasterBuf.TYPE_SHORT;
						else
							requestDataType = RasterBuf.TYPE_BYTE;
						calcFullAccumulatedHistogramFromDataSource(showBands);
						break;
				}
				break;
		}
	}
	
	
	/**
	 * Calcula el histograma de la vista y solo con los datos de visualizacin
	 * de las bandas R, G o B solicitadas
	 * @param bandas que se desean visualizar. Cada elemento del vector es una banda y el boolean, si
	 * est a true se visualizar esa banda y si est a false no se visualizar
	 */
	private void calcHistogramFromView(boolean[] bands){
		if(histogramObj != null){
			lastHistogram = histogramObj.calcHistogramFromView(bands);
			showBands = bands;
			setStatistic(Statistic.getBasicStatsFromHistogram(	lastHistogram, 
																(int)getBoxesValues()[1], 
																(int)getBoxesValues()[0], 
																bands));
			GraphicChartPanel gcp = pHistogram.getPGraphic();
			
			String bandNames[] = new String[bands.length];
			for (int iBand = 0; iBand<bands.length; iBand++)
				bandNames[iBand]=this.getJComboBands().getItemAt(iBand+1).toString();
			
			gcp.setNewChart(lastHistogram, bandNames);
		}
	}
		
	/**
	 * Calcula el histograma accumulado de la vista y solo con los datos de visualizacin
	 * @param bandas que se desean visualizar. Cada elemento del vector es una banda y el boolean, si
	 * est a true se visualizar esa banda y si est a false no se visualizar
	 */
	private void calcAccumulatedHistogramFromView(boolean[] bands){
		if(histogramObj != null){
			lastHistogram = histogramObj.calcAccumulatedHistogramFromView(bands);
			showBands = bands;
			setStatistic(Statistic.getBasicStatsFromHistogram(	lastHistogram, 
																(int)getBoxesValues()[1], 
																(int)getBoxesValues()[0], 
																bands));
			GraphicChartPanel gcp = pHistogram.getPGraphic();
			
			String bandNames[] = new String[bands.length];
			for (int iBand = 0; iBand<bands.length; iBand++)
				bandNames[iBand]=this.getJComboBands().getItemAt(iBand+1).toString();
			
			gcp.setNewChart(lastHistogram, bandNames);
		}
	}
		
	/**
	 * Calcula el histograma completo
	 * @param bandas que se desean visualizar. Cada elemento del vector es una banda y el boolean, si
	 * est a true se visualizar esa banda y si est a false no se visualizar
	 */
	private void calcHistogramFromDataSourceAndExtentView(boolean[] bands){
		if(histogramObj != null){			
			incrementPanel = new HistogramIncrement(this);	
			if(histogramObj.calcHistogramFromRenderizerLimetedArea(bands))
				incrementPanel.showWindow();
			else 
				readFullHistogramFromThread();
		}
	}
		
	/**
	 * Calcula el histograma completo
	 * @param bandas que se desean visualizar. Cada elemento del vector es una banda y el boolean, si
	 * est a true se visualizar esa banda y si est a false no se visualizar
	 */
	private void calcFullHistogramFromDataSource(boolean[] bands){
		if(histogramObj != null){
			histogramObj.calcFullHistogram(bands);
			incrementPanel = new HistogramIncrement(this);	
			incrementPanel.showWindow();
		}
	}
	
	/**
	 * Calcula el histograma acumulado completo
	 * @param bandas que se desean visualizar. Cada elemento del vector es una banda y el boolean, si
	 * est a true se visualizar esa banda y si est a false no se visualizar
	 */
	private void calcFullAccumulatedHistogramFromDataSource(boolean[] bands){
		if(histogramObj != null){			
			incrementPanel = new HistogramIncrement(this);			
			histogramObj.calcFullAccumulatedHistogram(bands);
			incrementPanel.showWindow();
		}
	}

	
	/**
	 * Mtodo que ejecuta el thread que comprueba cuando se ha acabado de generar
	 * el histograma. Al finalizar, se lee el histograma de la imagen completa 
	 * calculado y se muestra.
	 */
	public void readFullHistogramFromThread(){
		if(type == 0)
			lastHistogram = histogramObj.getFullHistogram();
		else if(type == 1)
			lastHistogram = histogramObj.getFullAccumulatedHistogram();
		
		setStatistic(Statistic.getBasicStatsFromHistogram(	lastHistogram, 
															(int)getBoxesValues()[1], 
															(int)getBoxesValues()[0], 
															showBands));
		//Si el histograma es grande lo recortamos para mostrarlo porque jfreeChart se vuelve
		//inestable al poner muchos elementos en las X
		
		int pos = lastHistogram[0].length;
		int[][] newHistogram = lastHistogram;
		boolean elem = true;
		if(lastHistogram[0].length >= Utilities.MAX_SHORT_BIT_VALUE){
			for(int i = (lastHistogram[0].length - 1); i >= 0; i--){
				for(int iBand = 0; iBand < lastHistogram.length; iBand ++){
					if(lastHistogram[iBand][i] != 0)
						elem = false;
				}
				if(!elem){
					pos = i;
					break;
				}
			}
			newHistogram = new int[lastHistogram.length][pos];
			for(int iBand = 0; iBand < lastHistogram.length; iBand ++){
				for(int i = 0; i < newHistogram[iBand].length; i ++){
					newHistogram[iBand][i] = lastHistogram[iBand][i];
				}
			}
		}
		
		GraphicChartPanel gcp = pHistogram.getPGraphic();
		
		String bandNames[] = new String[lastHistogram.length];
		for (int iBand = 0; iBand<lastHistogram.length; iBand++)
			bandNames[iBand]=this.getJComboBands().getItemAt(iBand+1).toString();
		
		gcp.setNewChart(newHistogram, bandNames);
	}
	
	/**
	 * Asigna el nmero de bandas al combobox
	 * @param bands Nmero de bandas de la imagen
	 */
	public void setBands(int bands){
		HistogramPanelListener.comboEventEnable = false;
		getJComboBands().removeAllItems();
		getJComboBands().addItem(Messages.getText("todas"));
		showBands = new boolean[bands];
		for(int i = 0; i < bands; i++){
			getJComboBands().addItem("Band "+String.valueOf(i));
			showBands[i] = true;
		}
		HistogramPanelListener.comboEventEnable = true;
	}
	
	
	/**
	 * Asigna la estadistica a la tabla
	 * @param stat
	 */
	public void setStatistic(long[][] stat){
		if(stat == null)
			return;
		try {
			getTable().removeAllRows();
			for(int iBand = 0; iBand < stat[0].length; iBand++){
				Object[] list = new Object[stat.length + 1];
				list[0] = new Integer(iBand);
				for(int iStat = 1; iStat <= stat.length; iStat++)
					list[iStat] = new Long(stat[iStat - 1][iBand]);				
					
				getTable().addRow(list);
				list = null;
			}
		} catch (NotInitializeException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Resetea el control de bandas del panel con los valores RGB para 
	 * cuando se est haciendo el histograma de la visualizacin en
	 * vez del histograma con los datos
	 *
	 */
	public void setRGBInBandList(){
		HistogramPanelListener.comboEventEnable = false;
		boolean[] list = {true, true, true};
		showBands = list;
		getJComboBands().removeAllItems();
		getJComboBands().addItem(Messages.getText("todas"));
		getJComboBands().addItem("R");
		getJComboBands().addItem("G");
		getJComboBands().addItem("B");
		HistogramPanelListener.comboEventEnable = true;
	}
	
	/**
	 * Aade o elimina una banda de la visualizacin. Si la banda se est visualizando
	 * se elimina y si no entonces se muestra
	 * @param band banda a visualizar o borrar del grfico
	 */
	public void addOrRemoveGraphicBand(int band){
		if(band > showBands.length)
			return;
		showBands[band] = !showBands[band];
	}
	
	/**
	 * Limpia la grfica
	 */
	public void cleanChart(){
		GraphicChartPanel gcp = pHistogram.getPGraphic();
		gcp.cleanChart();
		for(int i = 0; i < showBands.length; i++)
			showBands[i] = false;
	}
	
	/**
	 * Asigna el objeto histograma para la gestin de procesos de histograma
	 * @param histogramObj
	 */
	public void setHistogram(Histogram histogramObj) {
		this.histogramObj = histogramObj;
		listener.setHistogram(histogramObj);
	}
	
	/**
	 * Obtiene el objeto histograma para la gestin de procesos de histograma
	 * @return
	 */
	public Histogram getHistogram() {
		return histogramObj;
	}
	
	/**
	 * Obtiene el tipo de datos de la fuente de la imagen
	 * @return tipo de datos de la fuente de la imagen
	 */
	public int getHistogramDataSource() {
		return histogramDataSource;
	}

	/**
	 * Asigna el tipo de datos de la fuente de la imagen
	 * @param histogramDataSource tipo de datos de la fuente de la imagen
	 */
	public void setHistogramDataSource(int histogramDataSource) {
		this.histogramDataSource = histogramDataSource;
	}

	/**
	 * Obtiene la lista de bandas que se muestran en el histograma
	 * @return Lista de bandas donde cada elemento es un booleano. True si la banda
	 * se muestra y false si no se muestra.
	 */
	public boolean[] getBandListShowInChart(){
		return showBands;
	}

	/**
	 * Asigna la lista de bandas que se muestran en el histograma
	 * @param Lista de bandas donde cada elemento es un booleano. True si la banda
	 * se muestra y false si no se muestra.
	 */
	public void setBandListShowInChart(boolean[] showBands) {
		this.showBands = showBands;
	}

	/**
	 * Obtiene el tipo de histograma a mostrar
	 * @return acumulado/no acumulado
	 */
	public int getType() {
		return type;
	}

	/**
	 * Asigna el tipo de histograma a mostrar
	 * @param type acumulado/no acumulado 
	 */
	public void setType(int type) {
		this.type = type;
	}
	
	/**
	 * Obtiene el valor de los controles en el rango 0-255. Los controles dan un rango en tanto por cien 0-100
	 * pero para el calculo de estadisticas necesitamos un rango de valor de pixel. 
	 * @return Array con los valores de ambos controles. El primer valor del array es el control de la derecha
	 * y el segundo el de la izquierda.  
	 */
	public double[] getBoxesValues(){
		double[] v = new double[2];
		double[] currentValues = getPHistogram().getBoxesValues();
		switch(requestDataType){
		case RasterBuf.TYPE_BYTE: 	v[0] = (currentValues[0] * Utilities.MAX_BYTE_BIT_VALUE) / 100; 
									v[1] = (currentValues[1] * Utilities.MAX_BYTE_BIT_VALUE) / 100;
									break;
		case RasterBuf.TYPE_SHORT: 	v[0] = (currentValues[0] * Utilities.MAX_SHORT_BIT_VALUE) / 100;
									v[1] = (currentValues[1] * Utilities.MAX_SHORT_BIT_VALUE) / 100;
									break;
		}
		return v;
	}

	/**
	 * Obtiene el ltimo histograma visualizado
	 * @return
	 */
	public int[][] getLastHistogram() {
		return lastHistogram;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
