package org.cresques.ui.raster;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import org.gvsig.gui.beans.dataInput.DataInputContainer;
import org.gvsig.i18n.Messages;

public class ResolutionPanel extends BaseComponent implements ActionListener{

	private int					MARGIN = 10;
	private int					wComp = 404, hComp = 120;
	private int					wHalf = (int)Math.floor((wComp - MARGIN) >> 1) - 4, hHalf = 92;
	private int					wData = wHalf - MARGIN, hData = (int)Math.floor(hHalf/3);
	
	private JPanel 				pResolution = null;
	private JPanel 				pOption = null;
	private JPanel 				pDataInput = null;
	private JPanel 				pRatio = null;
	private JPanel 				pInterpolation = null;
	private JPanel 				pCellSize = null;
	private JPanel 				pWidth = null;
	private JPanel 				pHeight = null;
	private DataInputContainer 	cCellSize = null;
	private DataInputContainer 	cHeight = null;
	private DataInputContainer 	cWidth = null;
	private JPanel 				pButtons = null;
	private JRadioButton 		rSize = null;
	private JRadioButton 		rWidthH = null;
	private JLabel 				lSize = null;
	private JLabel 				lWidthH = null;
	private JLabel 				lInterpolation = null;
	private JComboBox 			cInterpolation = null;
	
	/**
	 * This is the default constructor
	 */
	public ResolutionPanel() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		FlowLayout flowLayout = new FlowLayout();
		flowLayout.setHgap(0);
		flowLayout.setVgap(0);
		this.setLayout(flowLayout);
		this.setSize(wComp, hComp);
		this.add(getPResolution(), null);
		this.getRSize().addActionListener(this);
		this.getRWidthH().addActionListener(this);
		this.getRSize().setSelected(true);
		this.getCWidth().setControlEnabled(false);
		this.getCHeight().setControlEnabled(false);
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPResolution() {
		if (pResolution == null) {
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 1;
			gridBagConstraints1.gridy = 0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 0;
			pResolution = new JPanel();
			pResolution.setLayout(new GridBagLayout());
			pResolution.setPreferredSize(new java.awt.Dimension(wComp,hComp));
			pResolution.setBorder(javax.swing.BorderFactory.createTitledBorder(null, Messages.getText("resolucion_espacial"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10), null));
			pResolution.add(getPOption(), gridBagConstraints);
			pResolution.add(getPDataInput(), gridBagConstraints1);
		}
		return pResolution;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPOption() {
		if (pOption == null) {
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 0;
			gridBagConstraints6.gridy = 1;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.gridy = 0;
			pOption = new JPanel();
			pOption.setLayout(new GridBagLayout());
			pOption.setPreferredSize(new java.awt.Dimension(wHalf,hHalf));
			pOption.add(getPRatio(), gridBagConstraints2);
			pOption.add(getPWidth(), gridBagConstraints6);
		}
		return pOption;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPDataInput() {
		if (pDataInput == null) {
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.gridy = 2;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.gridy = 1;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 0;
			gridBagConstraints3.gridy = 0;
			pDataInput = new JPanel();
			pDataInput.setLayout(new GridBagLayout());
			pDataInput.setPreferredSize(new java.awt.Dimension(wHalf,hHalf));
			pDataInput.add(getPInterpolation(), gridBagConstraints3);
			pDataInput.add(getPCellSize(), gridBagConstraints4);
			pDataInput.add(getPHeight(), gridBagConstraints5);
		}
		return pDataInput;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPRatio() {
		if (pRatio == null) {
			pRatio = new JPanel();
			FlowLayout flowLayout3 = new FlowLayout();
			flowLayout3.setAlignment(java.awt.FlowLayout.RIGHT);
			flowLayout3.setVgap(0);
			flowLayout3.setHgap(0);
			//pRatio.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			pRatio.setLayout(flowLayout3);
			pRatio.setPreferredSize(new java.awt.Dimension(wHalf - MARGIN, (2 * hData)));
			pRatio.add(getPButtons(), null);
		}
		return pRatio;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPInterpolation() {
		if (pInterpolation == null) {
			FlowLayout flowLayout3 = new FlowLayout();
			flowLayout3.setAlignment(java.awt.FlowLayout.RIGHT);
			flowLayout3.setVgap(0);
			flowLayout3.setHgap(0);
			pInterpolation = new JPanel();
			pInterpolation.setLayout(flowLayout3);
			pInterpolation.setPreferredSize(new java.awt.Dimension(wHalf - MARGIN, hData));
			//pInterpolation.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			pInterpolation.add(getJComboBox(), null);
		}
		return pInterpolation;
	}

	/**
	 * This method initializes getPCellSize	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPCellSize() {
		if (pCellSize == null) {
			FlowLayout flowLayout3 = new FlowLayout();
			flowLayout3.setAlignment(java.awt.FlowLayout.RIGHT);
			flowLayout3.setVgap(0);
			flowLayout3.setHgap(0);
			pCellSize = new JPanel();
			//pCellSize.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			pCellSize.setLayout(flowLayout3);
			pCellSize.setPreferredSize(new java.awt.Dimension(wHalf - MARGIN, hData));
			pCellSize.add(getCCellSize(), null);
		}
		return pCellSize;
	}
	
	/**
	 * This method initializes getPHeight	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPHeight() {
		if (pHeight == null) {
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setAlignment(java.awt.FlowLayout.RIGHT);
			flowLayout1.setHgap(0);
			flowLayout1.setVgap(0);
			pHeight = new JPanel();
			//pHeight.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			pHeight.setLayout(flowLayout1);
			pHeight.setPreferredSize(new java.awt.Dimension(wHalf - MARGIN, hData));
			pHeight.add(getCHeight(), null);
		}
		return pHeight;
	}
	
	/**
	 * This method initializes getPWidth	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPWidth() {
		if (pWidth == null) {
			FlowLayout flowLayout2 = new FlowLayout();
			flowLayout2.setAlignment(java.awt.FlowLayout.RIGHT);
			flowLayout2.setVgap(0);
			flowLayout2.setHgap(0);
			pWidth = new JPanel();
			//pWidth.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			pWidth.setLayout(flowLayout2);
			pWidth.setPreferredSize(new java.awt.Dimension(wHalf - MARGIN, hData));
			pWidth.add(getCWidth(), null);
		}
		return pWidth;
	}
	
	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public DataInputContainer getCCellSize() {
		if (cCellSize == null) {
			cCellSize = new DataInputContainer(50);
			cCellSize.setComponentSize(180, 0);
			cCellSize.setLabelText(Messages.getText("celda"));
			cCellSize.setDecimal(true);
		}
		return cCellSize;
	}

	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public DataInputContainer getCHeight() {
		if (cHeight == null) {
			cHeight = new DataInputContainer(50);
			cHeight.setComponentSize(180, 0);
			cHeight.setLabelText(Messages.getText("alto"));
			cHeight.setDecimal(true);
		}
		return cHeight;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public DataInputContainer getCWidth() {
		if (cWidth == null) {
			cWidth = new DataInputContainer(50);
			cWidth.setComponentSize(180, 0);
			cWidth.setLabelText(Messages.getText("ancho"));
			cWidth.setDecimal(true);
		}
		return cWidth;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPButtons() {
		if (pButtons == null) {
			pButtons = new JPanel();
			FlowLayout flowLayout2 = new FlowLayout();
			flowLayout2.setAlignment(java.awt.FlowLayout.LEFT);
			flowLayout2.setVgap(2);
			flowLayout2.setHgap(5);
			pButtons.setLayout(flowLayout2);
			pButtons.setPreferredSize(new java.awt.Dimension(wHalf - 10, (2 * hData) - 6));
			pButtons.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			pButtons.add(getRSize(), null);
			pButtons.add(getRWidthH(), null);;
		}
		return pButtons;
	}

	/**
	 * This method initializes jRadioButton	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getRSize() {
		if (rSize == null) {
			rSize = new JRadioButton(Messages.getText("tamanyo_celda"));
		}
		return rSize;
	}

	/**
	 * This method initializes jRadioButton1	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getRWidthH() {
		if (rWidthH == null) {
			rWidthH = new JRadioButton(Messages.getText("ancho_x_alto"));
		}
		return rWidthH;
	}

	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBox() {
		if (cInterpolation == null) {
			cInterpolation = new JComboBox();
			cInterpolation.setPreferredSize(new java.awt.Dimension(wHalf - MARGIN - 2, 22));
			cInterpolation.addItem(Messages.getText("vecino_+_proximo"));
			cInterpolation.addItem(Messages.getText("bilinear"));
			cInterpolation.addItem(Messages.getText("distancia_inversa"));
			cInterpolation.addItem(Messages.getText("bicubico"));
			cInterpolation.addItem(Messages.getText("b_splines"));
			
		}
		return cInterpolation;
	}

	
	public void setComponentSize(int w, int h){
		/*wComp = w; hComp = 120;
		wHalf = (int)Math.floor((wComp-10)/2); hHalf = 95;
		wData = wHalf - 10; hData = (int)Math.floor(hHalf/3);
		
		this.setPreferredSize(new Dimension(wComp, hComp));
		getPResolution().setPreferredSize(new java.awt.Dimension(wComp,hComp));
		getPOption().setPreferredSize(new java.awt.Dimension(wHalf,hHalf));
		getPWidth().setPreferredSize(new java.awt.Dimension(wHalf,hData));
		getPDataInput().setPreferredSize(new java.awt.Dimension(wHalf,hHalf));
		getPInterpolation().setPreferredSize(new java.awt.Dimension(wHalf,hData));
		getPCellSize().setPreferredSize(new java.awt.Dimension(wHalf,hData));
		getCCellSize().setComponentSize(wData,hData);
		getCCellSize().setComponentHeight(hData);
		getPHeight().setPreferredSize(new java.awt.Dimension(wHalf,hData));
		getCHeight().setComponentSize(wData,hData);
		getCHeight().setComponentHeight(hData);
		getPWidth().setPreferredSize(new java.awt.Dimension(wHalf,hData));
		getCWidth().setComponentSize(wData,hData);
		getCWidth().setComponentHeight(hData);*/
		
	}
	
	/**
	 * Asigna el valor del campo "tamao de celda" a partir del double que lo representa
	 * y con el nmero de decimales que se especifica en el parmetro dec
	 * @param cellSize Tamao de celda en double
	 * @param dec Nmero de decimales
	 */
	public void setCellSizeText(double cellSize, int dec){
		int indexPoint = String.valueOf(cellSize).indexOf('.');
		try{
			cCellSize.setValue(String.valueOf(cellSize).substring(0, indexPoint + dec));
   		}catch(StringIndexOutOfBoundsException ex){
   			cCellSize.setValue(String.valueOf(cellSize));
   		}
	}
	
	/**
	 * Asigna el valor del campo "Ancho" a partir del double que lo representa
	 * y con el nmero de decimales que se especifica en el parmetro dec
	 * @param width Ancho
	 * @param dec Nmero de decimales
	 */
	public void setWidthText(double width, int dec){
		int indexPoint = String.valueOf(width).indexOf('.');
		try{
			cWidth.setValue(String.valueOf(width).substring(0, indexPoint + dec));
   		}catch(StringIndexOutOfBoundsException ex){
   			cWidth.setValue(String.valueOf(width));
   		}
	}
	
	/**
	 * Asigna el valor del campo "Alto" a partir del double que lo representa
	 * y con el nmero de decimales que se especifica en el parmetro dec
	 * @param height Alto
	 * @param dec Nmero de decimales
	 */
	public void setHeightText(double height, int dec){
		int indexPoint = String.valueOf(height).indexOf('.');
		try{
			cHeight.setValue(String.valueOf(height).substring(0, indexPoint + dec));
   		}catch(StringIndexOutOfBoundsException ex){
   			cHeight.setValue(String.valueOf(height));
   		}
	}
	
	/**
	 * Devuelve el valor del campo "tamao de celda"
	 * @return
	 */
	public double getCellSizeText(){
		return Double.parseDouble(cCellSize.getValue());
	}
	
	/**
	 * Devuelve el valor del campo "tamao de celda"
	 * @return
	 */
	public double getWidthText(){
		return Double.parseDouble(cWidth.getValue());
	}
	
	/**
	 * Devuelve el valor del campo "tamao de celda"
	 * @return
	 */
	public double getHeightText(){
		return Double.parseDouble(cHeight.getValue());
	}
	
	/**
	 * Devuelve los valores de Alto x Acho de la resolucin espacial
	 * @return
	 */
	public String[] getWidthHeight(){
		String[] text= { this.cWidth.getValue(),
						this.cHeight.getValue()
						};
		return text;
	}
	
	/**
	 * Devuelve el metodo de interpolacion.
	 * @return
	 */
	public String getInterpolation(){
		return (String)this.getJComboBox().getSelectedItem();
	}
	
	
	/**************************************************************/
	/********************Listeners*********************************/
	/**************************************************************/
	
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == this.getRSize()){
			this.getRSize().setSelected(true);
			this.getRWidthH().setSelected(false);
			cCellSize.setControlEnabled(true);
			cHeight.setControlEnabled(false);
			cWidth.setControlEnabled(false);
		}
		if(e.getSource() == this.getRWidthH()){
			this.getRWidthH().setSelected(true);
			this.getRSize().setSelected(false);
			cCellSize.setControlEnabled(false);
			cHeight.setControlEnabled(true);
			cWidth.setControlEnabled(true);
		}
	}
	
	
}
