package com.iver.cit.gvsig.fmap.layers;

import com.iver.utiles.XMLEntity;

import org.xml.sax.Attributes;
import org.xml.sax.ContentHandler;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

import java.util.Stack;


/**
 * Maneja los eventos de GDBMS para obtener un XMLEntity con la
 * informacin
 *
 * @author Fernando Gonzlez Corts
 */
public class GDBMSHandler implements ContentHandler {
	private Stack entities = new Stack();
	private XMLEntity last;

	/**
	 * @see org.xml.sax.ContentHandler#endDocument()
	 */
	public void endDocument() throws SAXException {
		// TODO Auto-generated method stub
	}

	/**
	 * @see org.xml.sax.ContentHandler#startDocument()
	 */
	public void startDocument() throws SAXException {
		// TODO Auto-generated method stub
	}

	/**
	 * @see org.xml.sax.ContentHandler#characters(char[], int, int)
	 */
	public void characters(char[] ch, int start, int length)
		throws SAXException {
		// TODO Auto-generated method stub
	}

	/**
	 * @see org.xml.sax.ContentHandler#ignorableWhitespace(char[], int, int)
	 */
	public void ignorableWhitespace(char[] ch, int start, int length)
		throws SAXException {
		// TODO Auto-generated method stub
	}

	/**
	 * @see org.xml.sax.ContentHandler#endPrefixMapping(java.lang.String)
	 */
	public void endPrefixMapping(String prefix) throws SAXException {
		// TODO Auto-generated method stub
	}

	/**
	 * @see org.xml.sax.ContentHandler#skippedEntity(java.lang.String)
	 */
	public void skippedEntity(String name) throws SAXException {
		// TODO Auto-generated method stub
	}

	/**
	 * @see org.xml.sax.ContentHandler#setDocumentLocator(org.xml.sax.Locator)
	 */
	public void setDocumentLocator(Locator locator) {
		// TODO Auto-generated method stub
	}

	/**
	 * @see org.xml.sax.ContentHandler#processingInstruction(java.lang.String,
	 * 		java.lang.String)
	 */
	public void processingInstruction(String target, String data)
		throws SAXException {
		// TODO Auto-generated method stub
	}

	/**
	 * @see org.xml.sax.ContentHandler#startPrefixMapping(java.lang.String,
	 * 		java.lang.String)
	 */
	public void startPrefixMapping(String prefix, String uri)
		throws SAXException {
		// TODO Auto-generated method stub
	}

	/**
	 * @see org.xml.sax.ContentHandler#endElement(java.lang.String,
	 * 		java.lang.String, java.lang.String)
	 */
	public void endElement(String namespaceURI, String localName, String qName)
		throws SAXException {
		last = (XMLEntity) entities.pop();
	}

	/**
	 * @see org.xml.sax.ContentHandler#startElement(java.lang.String,
	 * 		java.lang.String, java.lang.String, org.xml.sax.Attributes)
	 */
	public void startElement(String namespaceURI, String localName,
		String qName, Attributes atts) throws SAXException {
		//Configuramos el xml entity
		XMLEntity xml = new XMLEntity();
		xml.setName(qName);

		for (int i = 0; i < atts.getLength(); i++) {
			String name = atts.getQName(i);
			String value = atts.getValue(i);
			xml.putProperty(name, value);
		}

		if (!entities.isEmpty()) {
			XMLEntity parent = (XMLEntity) entities.peek();
			parent.addChild(xml);
		}

		entities.push(xml);
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	public XMLEntity getXMLEntity() {
		return last;
	}
}
