package com.iver.cit.gvsig.fmap.spatialindex;

import java.awt.geom.Rectangle2D;
import java.io.File;

import com.hardcode.driverManager.DriverLoadException;
import com.hardcode.driverManager.DriverManager;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.crs.CRSFactory;
import com.iver.cit.gvsig.fmap.drivers.VectorialFileDriver;
import com.iver.cit.gvsig.fmap.edition.writers.shp.Prueba;
import com.iver.cit.gvsig.fmap.layers.FBitSet;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.fmap.layers.LayerFactory;

import junit.framework.TestCase;

public class SpatialIndexTest extends TestCase {

	FLyrVect lyr;
	
	public SpatialIndexTest(String name) {
		super(name);
	}

	protected void setUp() throws Exception {
		super.setUp();
		LayerFactory.setDriversPath("../_fwAndami/gvSIG/extensiones/com.iver.cit.gvsig/drivers");
		lyr = (FLyrVect) LayerFactory.createLayer("Vias", 
				(VectorialFileDriver) LayerFactory.getDM().getDriver("gvSIG shp driver"),
				new File("C:/lics.shp"),
				CRSFactory.getCRS("EPSG:23030"));
		lyr.createSpatialIndex();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
		lyr = null;
	}
	
	
	public void testSpatialIndexFullExtent(){
		try {
			Rectangle2D rect2D = lyr.getFullExtent();
			FBitSet bitset = lyr.queryByRect(rect2D);
			assertTrue(bitset.cardinality() != 0);
			
			double x = rect2D.getCenterX();
			double y = rect2D.getCenterY();
			rect2D = new Rectangle2D.Double( x, y , 100d, 100d);
			bitset = lyr.queryByRect(rect2D);
			assertTrue(bitset.cardinality() != 0);
//			for(int i = bitset.nextSetBit(0); i >= 0; i = bitset.nextSetBit(i+1)) 
//			{
//				System.out.println(i);	
//			}
		} catch (DriverException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}
