/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.tools.Events;

import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;


/**
 * Evento de movimiento sobre la vista.
 *
 * @author Vicente Caballero Navarro
 */
public class MoveEvent {
    private Point2D from;
    private Point2D to;
	private MouseEvent event;

    /**
     * Crea un nuevo MoveEvent.
     *
	 * @param from origen.
	 * @param to destino.
     */
    public MoveEvent(Point2D from, Point2D to, MouseEvent e) {
        this.from = from;
        this.to = to;
        event = e;
    }

	/**
	 * Devuelve el punto inical del movimiento.
	 *
	 * @return Punto inicial.
	 */
    public Point2D getFrom() {
        return from;
    }

	/**
	 * Devuelve el punto finale del movimiento.
	 *
	 * @return Punto final.
	 */
    public Point2D getTo() {
        return to;
    }
	public MouseEvent getEvent() {
		return event;
	}
}
