package com.hardcode.gdbms.engine.data.indexes.hashMap;

/**
 * DOCUMENT ME!
 *
 * @author Fernando Gonzlez Corts
 */
public interface Index {
	/**
	 * Invocado cuando se va a comenzar una operacin de escritura con la
	 * estructura de datos
	 *
	 * @throws IndexException DOCUMENT ME!
	 */
	public void start() throws IndexException;

	/**
	 * Invocado cuando se termina la operacin de escritura con el ndice
	 *
	 * @throws IndexException DOCUMENT ME!
	 */
	public void stop() throws IndexException;

	/**
	 * Aade la posicin de un valor al ndice. Posiblemente ya haya una o
	 * varias posiciones para dicho valor tomando como funcin de identidad el
	 * mtodo equals de Value. En dicho caso se debern mantener todas estas
	 *
	 * @param v Valor
	 * @param position posicin del Valor dentro del DataSource
	 *
	 * @throws IndexException
	 */
	public void add(Object v, int position) throws IndexException;

	/**
	 * Obtiene un iterador para iterar sobre las posiciones sobre las que puede
	 * haber valores iguales al que se pasa como parmetro. No todas las
	 * posiciones se deben corresponder necesariamente con registros que
	 * contengan el valor buscado pero todas las posiciones de los registros
	 * que contengan value estarn en las posiciones que se retornen.
	 *
	 * @param v Value
	 *
	 * @return Objeto para iterar por las posiciones
	 *
	 * @throws IndexException
	 */
	public PositionIterator getPositions(Object v) throws IndexException;
}
