/*
 * Created on 12-oct-2004
 */
package com.hardcode.gdbms.engine.instruction;

import com.hardcode.gdbms.engine.data.driver.DriverException;
import com.hardcode.gdbms.engine.values.Value;


/**
 * Adaptador
 *
 * @author Fernando Gonzlez Corts
 */
public class LValueTermAdapter extends AbstractExpression {
	//	private DataSource[] tables;
	//private DataSource source;
	private Field field = null;

	/**
	 * @see com.hardcode.gdbms.engine.instruction.Expression#getFieldName()
	 */
	public String getFieldName() {
		return Utilities.getText(getEntity());
	}

	/**
	 * @see com.hardcode.gdbms.engine.instruction.Expression#simplify()
	 */
	public void simplify() {
	}

	/**
	 * @see com.hardcode.gdbms.engine.instruction.CachedExpression#evaluate(long)
	 */
	public Value evaluate(long row) throws EvaluationException {
		try {
            return getField().evaluateExpression(row);
        } catch (DriverException e) {
            throw new EvaluationException(e);
        } catch (SemanticException e) {
            throw new EvaluationException(e);
        }
	}

	/**
	 * Obtiene el campo al que referencia este adaptador
	 *
	 * @return Field
	 *
	 * @throws AmbiguousFieldNameException Si hay varios campos con el mismo
	 * 		   nombre y no se especific la tabla
	 * @throws FieldNotFoundException Si no hay ningn campo con ese nombre
	 * @throws DriverException Si se produjo un error en el driver
	 * @throws SemanticException Si existe algn error semntico en la
	 * 		   instruccin
	 */
	private Field getField()
		throws AmbiguousFieldNameException, FieldNotFoundException, 
			DriverException, SemanticException {
		if (field == null) {
			field = FieldFactory.createField(getInstructionContext()
												 .getFromTables(),
					getFieldName(), getInstructionContext().getDs());
		}

		return field;
	}

	/**
	 * @see com.hardcode.gdbms.engine.instruction.CachedExpression#isLiteral()
	 */
	public boolean isLiteral() {
		return false;
	}

	/**
	 * @see com.hardcode.gdbms.engine.instruction.Expression#calculateLiteralCondition()
	 */
	public void calculateLiteralCondition() {
	}
}
