package org.gvsig.crs;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;

import org.gvsig.crs.ogr.CrsOgr;
import org.gvsig.crs.ogr.CrsOgrException;
import org.gvsig.crs.ogr.OGRException;
import org.gvsig.crs.ogr.OGRSpatialReference;
import org.gvsig.crs.ogr.crsgdalException;
import org.gvsig.crs.proj.CrsProj;
import org.gvsig.crs.proj.CrsProjException;
import org.gvsig.crs.proj.JNIBaseCrs;
import org.gvsig.crs.proj.OperationCrsException;



public class Test{
	
	private static String source = null;
	private static String target = null;
	private static double[] x = new double[1]; 
	private static double[] y = new double[1];
	private static double[] z = new double[1];
	private static double[] coord = new double [15]; // Para la proyeccion PCI
	
	public static void main(String[] args) throws OGRException, CrsOgrException, crsgdalException, OperationCrsException, CrsProjException, IOException {
		opera(args);
		//pruebaWKT();
	}
	
	public static void opera(String[] args) throws OGRException, CrsOgrException, crsgdalException, OperationCrsException, CrsProjException, IOException {

		//System.out.print((new File(".").getCanonicalPath()));
		OGRSpatialReference oSRSSource = new OGRSpatialReference();
		OGRSpatialReference oSRSTarget = new OGRSpatialReference();
		double[] params = {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0}; // Para la proyeccion USGS
		String cadens = "PROJCS[\"ETRS89 / UTM zone 33N\", GEOGCS[\"ETRS89\", DATUM[\"European Terrestrial Reference System 1989\", SPHEROID[\"GRS 1980\", 6378137.0, 298.257222101]], PRIMEM[\"Greenwich\", 0.0], UNIT[\"Decimal Degree\", 0.017453292519943295]], PROJECTION[\"Transverse_Mercator\"], PARAMETER[\"latitude_of_origin\", 0.0], PARAMETER[\"central_meridian\", 0.2617993877991492], PARAMETER[\"scale_factor\", 0.9996], PARAMETER[\"false_easting\", 500000.0], PARAMETER[\"false_northing\", 0.0], UNIT[\"Meter\", 1.0]]";

		String cads = "";
		int n,m;
		n = args[0].charAt(0) - 48;
		m = args[1].charAt(0) - 48;
		if(n==7 || m==7){
			File f;
				// f = new File("C:/Archivos de programa/FWTools1.0.0a7/data/Geographic Coordinate Systems/Australia and New Zealand/Geocentric Datum of Australia 1994.prj");
				f = new File("C:/Archivos de programa/FWTools1.0.0a7/data/Geographic Coordinate Systems/Asia/Batavia.prj");
		    BufferedReader br = new BufferedReader(new InputStreamReader(
		        new FileInputStream(f)));
	
		    String line = null;
		     if ((line = br.readLine()) != null)
		     {
		    	 for( int i = 0; i<line.length();i++){
					if( i == 0 && line.charAt(0) != '"'){
						cads += line.charAt(i); 	
					}else if(line.charAt(i) == '"'){
						cads += '\\' ;
						cads += line.charAt(i);
					}else
						cads += line.charAt(i);
				}
		     }else
		      {
		         System.out.println("Wrong file format");
		         System.exit(0);
		      }
		}
		if(n > 7 || n < 0 || m > 7 || m < 0 || args[0].substring(0).length()>1 || args[1].substring(0).length()>1)
			System.out.println("Los parametros pasados por teclado tienen q estar comprendidos entre 0 y 7");
		else
		{
			try
			{
				switch(n){
				case 0: CrsOgr.importFromUSGS(oSRSSource, 1, 30, params, 4);break;
				case 1: CrsOgr.importFromPCI(oSRSSource,"pppppppppppp Ennn","DEGREES", coord);break;
				case 2: CrsOgr.setWellKnownGeogCS(oSRSSource, "EPSG:3002");break;
				case 3: CrsOgr.importFromWkt(oSRSSource,cads);break;
				case 4: CrsOgr.importFromEPSG(oSRSSource,/*4230*/23030);break;
				case 5: CrsOgr.importFromProj4(oSRSSource,"+proj=utm +zone=30 +ellps=intl +units=m");break;
				case 6: CrsOgr.setUTM(oSRSSource,11,true);break;
				case 7: CrsOgr.importFromESRI(oSRSSource,cads);break;	   
				}
				
				System.out.println("Proyeccion Origen ==> "+ CrsOgr.exportToProj4(oSRSSource));
				source = CrsOgr.exportToProj4(oSRSSource)+"+nadgrids=sped2et.gsb";
				
	    	
				switch(m){
				case 0: CrsOgr.importFromUSGS(oSRSTarget, 1, 30, params, 8);break;
				case 1: CrsOgr.importFromPCI(oSRSTarget,"Hola","DEGREES", coord);break;
				case 2: CrsOgr.setWellKnownGeogCS(oSRSTarget, "EPSG:4326");break;
				case 3: CrsOgr.importFromWkt(oSRSTarget,cadens);break;
				case 4: CrsOgr.importFromEPSG(oSRSTarget,/*4258*/4230);break;
				case 5: CrsOgr.importFromProj4(oSRSTarget,"+proj=utm +zone=30 +ellps=GRS80" );break;
				case 6: CrsOgr.setUTM(oSRSTarget,11,true);break;
				case 7: CrsOgr.importFromESRI(oSRSTarget,cads);break;		
				}
	    	
				target = CrsOgr.exportToProj4(oSRSTarget);
				System.out.println("Proyeccion Destino ==> "+ target);
		//		System.out.println("Coordenadas Iniciales:     x = 465348.7823 y = 4473240.8768 z = 0.0" );
				reiniciar(source,target);
		/*		System.out.println();
				System.out.println();
				System.out.println();
				System.out.println("Proyeccion Origen ==> "+ CrsOgr.exportToProj4(oSRSSource));
				System.out.println("Proyeccion Destino ==> "+ target);
				System.out.println("Coordenadas Iniciales:     x = 465348.7823 y = 4473240.8768 z = 0.0" );
				reiniciarArraySimple(source,target);*/			
	    	
			} catch (CrsOgrException h) {
				System.out.println(h.getStrError());
			}
	    
			oSRSSource.finalice();
			oSRSTarget.finalice();
		}
	}
	public static void reiniciar(String strCrsSource, String strCrsTarget) throws OperationCrsException, CrsProjException
	{
	//	x[0] = -(3.0+24.0/60.0+30.12345/3600.0);
	//	y[0] = (40.0+24.0/60.0+30.12345/3600.0);
		z[0] = 0.0;
		x[0]=465348.7823;
		y[0]=4473240.8768;
		double xgood = 465239.40;
		double ygood =  4473032.98;
	//	double xgood = -(3.0+24.0/60.0+34.804968/3600.0);//*Math.PI/180.0;
	//	double ygood = (40.0+24.0/60.0+25.867951/3600.0);//*Math.PI/180;
		CrsProj srcCrs = new CrsProj(strCrsSource);
		CrsProj destCrs = new CrsProj(strCrsTarget);
		System.out.println("Coordenadas Iniciales:     "+"x = " + x[0] + " y = " + y[0] + " z = " + z[0]);
		JNIBaseCrs.operate(x, y, z, srcCrs, destCrs);
		double difx=(xgood-x[0]);
		double dify=(ygood-y[0]);
		System.out.println("Coordenadas transformadas: "+"x = " + x[0] + " y = " + y[0] + " z = " + z[0]);
		System.out.println("diferencia coordenadas: "+"x = " + difx + " y = " + dify + " z = " + z[0]);
		System.out.println(srcCrs.isLatlong());
		System.out.println(destCrs.isLatlong());
	}
	
	public static void reiniciarSimple(String strCrsSource, String strCrsTarget) throws OperationCrsException, CrsProjException{
		
		double []pt = {465348.7823, 4473240.8768, 0.0};
		CrsProj srcCrs = new CrsProj(strCrsSource);
		CrsProj destCrs = new CrsProj(strCrsTarget);
		System.out.print("Coordenadas transformadas: ");
		JNIBaseCrs.operateSimple(pt[0],pt[1], pt[2], srcCrs, destCrs);
	}
	
	public static void reiniciarArraySimple(String strCrsSource, String strCrsTarget) throws OperationCrsException, CrsProjException{
		
		double []pt = {465348.7823, 4473240.8768, 0.0};
		CrsProj srcCrs = new CrsProj(strCrsSource);
		CrsProj destCrs = new CrsProj(strCrsTarget);
		JNIBaseCrs.operateArraySimple(pt, srcCrs, destCrs);
		System.out.println("Coordenadas transformadas: "+"x = " + pt[0] + " y = " + pt[1] + " z = " + pt[2]);
		
	}
	
	public static void pruebaWKT() {
		String data = "GEOGCS[\"WGS 84\",DATUM[\"WGS_1984\",SPHEROID[\"WGS 84\",6378137,298.257223563,"+
			"AUTHORITY[\"EPSG\",7030]],TOWGS84[0,0,0,0,0,0,0],AUTHORITY[\"EPSG\",6326]],"+
			"PRIMEM[\"Greenwich\",0,AUTHORITY[\"EPSG\",8901]],UNIT[\"DMSH\",0.0174532925199433,"+
			"AUTHORITY[\"EPSG\",9108]],AXIS[\"Lat\",NORTH],AXIS[\"Long\",EAST],AUTHORITY[\"EPSG\","+
			"4326]]";
		CrsWkt.WKT wkt = new CrsWkt.WKT(data);
	}
}