/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Instituto de Desarrollo Regional and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   Instituto de Desarrollo Regional (Universidad de Castilla La-Mancha)
 *   Campus Universitario s/n
 *   02071 Alabacete
 *   Spain
 *
 *   +34 967 599 200
 */

package org.gvsig.crs.ogr;

/**
 * 
 * @author Miguel Garca Jimnez (garciajimenez.miguel@gmail.com)
 *
 */
public class JNIBaseCRS
{
	
	protected static native String exportToProj4Nat(long cPtr);
	protected static native String exportToWktNat(long cPtr);
	protected static native int importFromWktNat(long cPtr, String cadenas);
	protected static native int setUTMNat(long cPtr, int zona, int norte_sur);
	protected static native int setWellKnownGeogCSNat(long cPtr, String cs);
	protected static native int importFromEPSGNat(long cPtr, int cod);
	protected static native int importFromProj4Nat(long cPtr, String cs);
	protected static native int importFromPCINat(long cPtr,String cod, String cs,double[] coord);
	protected static native int importFromUSGSNat(long cPtr, long code, long zone, double[] params, long datum);
	protected static native int importFromESRINat(long cPtr, String cadenas);
	
	static {
		String os = System.getProperty("os.name");
		if(os.toLowerCase().startsWith("windows"))
			System.loadLibrary("jgdal060");
		else
			System.loadLibrary("jgdal");
	}
	
}
