package org.agil.core.spatialindex;

/**
 *  Interface for easy access to common Node information. <p>
 *
 *  Created: Tue May 18 16:03:08 1999 <p>
 *
 *
 *
 *@author     Marios Hadjieleftheriou
 *@version    2
 */
public interface Node {
	// do not export any Set functions. We want to protect the state of the RTree from outside
	// tampering. Give only basic get methods.
	/**
	 *  Gets the Level attribute of the Node object
	 *
	 *@return    The Level value
	 */
	public int getLevel();


	/**
	 *  Gets the NodeMbb attribute of the Node object
	 *
	 *@return    The NodeMbb value
	 */
	public HyperCube getNodeMbb();


	/**
	 *  Gets the HyperCubes attribute of the Node object
	 *
	 *@return    The HyperCubes value
	 */
	public HyperCube[] getHyperCubes();


	/**
	 *  Gets the Leaf attribute of the Node object
	 *
	 *@return    The Leaf value
	 */
	public boolean isLeaf();


	/**
	 *  Gets the Root attribute of the Node object
	 *
	 *@return    The Root value
	 */
	public boolean isRoot();


	/**
	 *  Gets the Index attribute of the Node object
	 *
	 *@return    The Index value
	 */
	public boolean isIndex();


	/**
	 *  Converts to a String representation of the object.
	 *
	 *@return    A string representation of the object.
	 */
	public String toString();


	/**
	 *  Gets the Branches attribute of the Node object
	 *
	 *@return    The Branches value
	 */
	public long[] getBranches();
}
// Node
